/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ANIMATIONADDON_OPTIONS_H
#define _ANIMATIONADDON_OPTIONS_H

#include <core/core.h>

class AnimationaddonOptions : public CompOption::Class {
    public:
        enum Options {
            TimeStepIntense,
            AirplanePathLength,
            AirplaneFlyToTaskbar,
            BeamSize,
            BeamSpacing,
            BeamColor,
            BeamSlowdown,
            BeamLife,
            FireParticles,
            FireSize,
            FireSlowdown,
            FireLife,
            FireColor,
            FireDirection,
            FireConstantSpeed,
            FireSmoke,
            FireMystical,
            DominoDirection,
            ExplodeGridx,
            ExplodeGridy,
            ExplodeSpokes,
            ExplodeTiers,
            ExplodeThickness,
            ExplodeTessellation,
            FoldGridx,
            FoldGridy,
            FoldDir,
            Glide3AwayPosition,
            Glide3AwayAngle,
            Glide3Thickness,
            RazrDirection,
            SkewerDirection,
            SkewerTessellation,
            SkewerGridx,
            SkewerGridy,
            SkewerThickness,
            SkewerRotation,
            OptionNum
        };

        enum FireDirection {
            FireDirectionDown = 0,
            FireDirectionUp = 1,
            FireDirectionLeft = 2,
            FireDirectionRight = 3,
            FireDirectionRandom = 4,
            FireDirectionAutomatic = 5,
        };

        enum DominoDirection {
            DominoDirectionDown = 0,
            DominoDirectionUp = 1,
            DominoDirectionLeft = 2,
            DominoDirectionRight = 3,
            DominoDirectionRandom = 4,
            DominoDirectionAutomatic = 5,
        };

        enum ExplodeTessellation {
            ExplodeTessellationRectangular = 0,
            ExplodeTessellationHexagonal = 1,
            ExplodeTessellationGlass = 2,
        };

        enum FoldDir {
            FoldDirIn = 0,
            FoldDirOut = 1,
        };

        enum RazrDirection {
            RazrDirectionDown = 0,
            RazrDirectionUp = 1,
            RazrDirectionLeft = 2,
            RazrDirectionRight = 3,
            RazrDirectionRandom = 4,
            RazrDirectionAutomatic = 5,
        };

        enum SkewerDirection {
            SkewerDirectionLeft = 0,
            SkewerDirectionRight = 1,
            SkewerDirectionLeftRight = 2,
            SkewerDirectionUp = 3,
            SkewerDirectionDown = 4,
            SkewerDirectionUpDown = 5,
            SkewerDirectionIn = 6,
            SkewerDirectionOut = 7,
            SkewerDirectionInOut = 8,
            SkewerDirectionRandom = 9,
        };

        enum SkewerTessellation {
            SkewerTessellationRectangular = 0,
            SkewerTessellationHexagonal = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        AnimationaddonOptions (bool init = true);
        virtual ~AnimationaddonOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        int optionGetTimeStepIntense ();
        void optionSetTimeStepIntenseNotify (ChangeNotify notify);

        float optionGetAirplanePathLength ();
        void optionSetAirplanePathLengthNotify (ChangeNotify notify);

        bool optionGetAirplaneFlyToTaskbar ();
        void optionSetAirplaneFlyToTaskbarNotify (ChangeNotify notify);

        float optionGetBeamSize ();
        void optionSetBeamSizeNotify (ChangeNotify notify);

        int optionGetBeamSpacing ();
        void optionSetBeamSpacingNotify (ChangeNotify notify);

        unsigned short * optionGetBeamColor ();
        unsigned short optionGetBeamColorRed ();
        unsigned short optionGetBeamColorGreen ();
        unsigned short optionGetBeamColorBlue ();
        unsigned short optionGetBeamColorAlpha ();
        void optionSetBeamColorNotify (ChangeNotify notify);

        float optionGetBeamSlowdown ();
        void optionSetBeamSlowdownNotify (ChangeNotify notify);

        float optionGetBeamLife ();
        void optionSetBeamLifeNotify (ChangeNotify notify);

        int optionGetFireParticles ();
        void optionSetFireParticlesNotify (ChangeNotify notify);

        float optionGetFireSize ();
        void optionSetFireSizeNotify (ChangeNotify notify);

        float optionGetFireSlowdown ();
        void optionSetFireSlowdownNotify (ChangeNotify notify);

        float optionGetFireLife ();
        void optionSetFireLifeNotify (ChangeNotify notify);

        unsigned short * optionGetFireColor ();
        unsigned short optionGetFireColorRed ();
        unsigned short optionGetFireColorGreen ();
        unsigned short optionGetFireColorBlue ();
        unsigned short optionGetFireColorAlpha ();
        void optionSetFireColorNotify (ChangeNotify notify);

        int optionGetFireDirection ();
        void optionSetFireDirectionNotify (ChangeNotify notify);

        bool optionGetFireConstantSpeed ();
        void optionSetFireConstantSpeedNotify (ChangeNotify notify);

        bool optionGetFireSmoke ();
        void optionSetFireSmokeNotify (ChangeNotify notify);

        bool optionGetFireMystical ();
        void optionSetFireMysticalNotify (ChangeNotify notify);

        int optionGetDominoDirection ();
        void optionSetDominoDirectionNotify (ChangeNotify notify);

        int optionGetExplodeGridx ();
        void optionSetExplodeGridxNotify (ChangeNotify notify);

        int optionGetExplodeGridy ();
        void optionSetExplodeGridyNotify (ChangeNotify notify);

        int optionGetExplodeSpokes ();
        void optionSetExplodeSpokesNotify (ChangeNotify notify);

        int optionGetExplodeTiers ();
        void optionSetExplodeTiersNotify (ChangeNotify notify);

        float optionGetExplodeThickness ();
        void optionSetExplodeThicknessNotify (ChangeNotify notify);

        int optionGetExplodeTessellation ();
        void optionSetExplodeTessellationNotify (ChangeNotify notify);

        int optionGetFoldGridx ();
        void optionSetFoldGridxNotify (ChangeNotify notify);

        int optionGetFoldGridy ();
        void optionSetFoldGridyNotify (ChangeNotify notify);

        int optionGetFoldDir ();
        void optionSetFoldDirNotify (ChangeNotify notify);

        float optionGetGlide3AwayPosition ();
        void optionSetGlide3AwayPositionNotify (ChangeNotify notify);

        float optionGetGlide3AwayAngle ();
        void optionSetGlide3AwayAngleNotify (ChangeNotify notify);

        float optionGetGlide3Thickness ();
        void optionSetGlide3ThicknessNotify (ChangeNotify notify);

        int optionGetRazrDirection ();
        void optionSetRazrDirectionNotify (ChangeNotify notify);

        int optionGetSkewerDirection ();
        void optionSetSkewerDirectionNotify (ChangeNotify notify);

        int optionGetSkewerTessellation ();
        void optionSetSkewerTessellationNotify (ChangeNotify notify);

        int optionGetSkewerGridx ();
        void optionSetSkewerGridxNotify (ChangeNotify notify);

        int optionGetSkewerGridy ();
        void optionSetSkewerGridyNotify (ChangeNotify notify);

        float optionGetSkewerThickness ();
        void optionSetSkewerThicknessNotify (ChangeNotify notify);

        int optionGetSkewerRotation ();
        void optionSetSkewerRotationNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline int
AnimationaddonOptions::optionGetTimeStepIntense ()
{
    return mOptions[AnimationaddonOptions::TimeStepIntense].value ().i ();
}

inline void
AnimationaddonOptions::optionSetTimeStepIntenseNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::TimeStepIntense] = notify;
}

inline float
AnimationaddonOptions::optionGetAirplanePathLength ()
{
    return mOptions[AnimationaddonOptions::AirplanePathLength].value ().f ();
}

inline void
AnimationaddonOptions::optionSetAirplanePathLengthNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::AirplanePathLength] = notify;
}

inline bool
AnimationaddonOptions::optionGetAirplaneFlyToTaskbar ()
{
    return mOptions[AnimationaddonOptions::AirplaneFlyToTaskbar].value ().b ();
}

inline void
AnimationaddonOptions::optionSetAirplaneFlyToTaskbarNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::AirplaneFlyToTaskbar] = notify;
}

inline float
AnimationaddonOptions::optionGetBeamSize ()
{
    return mOptions[AnimationaddonOptions::BeamSize].value ().f ();
}

inline void
AnimationaddonOptions::optionSetBeamSizeNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::BeamSize] = notify;
}

inline int
AnimationaddonOptions::optionGetBeamSpacing ()
{
    return mOptions[AnimationaddonOptions::BeamSpacing].value ().i ();
}

inline void
AnimationaddonOptions::optionSetBeamSpacingNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::BeamSpacing] = notify;
}

inline unsigned short *
AnimationaddonOptions::optionGetBeamColor ()
{
    return mOptions[AnimationaddonOptions::BeamColor].value ().c ();
}

inline unsigned short
AnimationaddonOptions::optionGetBeamColorRed ()
{
    return mOptions[AnimationaddonOptions::BeamColor].value ().c ()[0];
}

inline unsigned short
AnimationaddonOptions::optionGetBeamColorGreen ()
{
    return mOptions[AnimationaddonOptions::BeamColor].value ().c ()[1];
}


inline unsigned short
AnimationaddonOptions::optionGetBeamColorBlue ()
{
    return mOptions[AnimationaddonOptions::BeamColor].value ().c ()[2];
}


inline unsigned short
AnimationaddonOptions::optionGetBeamColorAlpha ()
{
    return mOptions[AnimationaddonOptions::BeamColor].value ().c ()[3];
}


inline void
AnimationaddonOptions::optionSetBeamColorNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::BeamColor] = notify;
}

inline float
AnimationaddonOptions::optionGetBeamSlowdown ()
{
    return mOptions[AnimationaddonOptions::BeamSlowdown].value ().f ();
}

inline void
AnimationaddonOptions::optionSetBeamSlowdownNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::BeamSlowdown] = notify;
}

inline float
AnimationaddonOptions::optionGetBeamLife ()
{
    return mOptions[AnimationaddonOptions::BeamLife].value ().f ();
}

inline void
AnimationaddonOptions::optionSetBeamLifeNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::BeamLife] = notify;
}

inline int
AnimationaddonOptions::optionGetFireParticles ()
{
    return mOptions[AnimationaddonOptions::FireParticles].value ().i ();
}

inline void
AnimationaddonOptions::optionSetFireParticlesNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireParticles] = notify;
}

inline float
AnimationaddonOptions::optionGetFireSize ()
{
    return mOptions[AnimationaddonOptions::FireSize].value ().f ();
}

inline void
AnimationaddonOptions::optionSetFireSizeNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireSize] = notify;
}

inline float
AnimationaddonOptions::optionGetFireSlowdown ()
{
    return mOptions[AnimationaddonOptions::FireSlowdown].value ().f ();
}

inline void
AnimationaddonOptions::optionSetFireSlowdownNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireSlowdown] = notify;
}

inline float
AnimationaddonOptions::optionGetFireLife ()
{
    return mOptions[AnimationaddonOptions::FireLife].value ().f ();
}

inline void
AnimationaddonOptions::optionSetFireLifeNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireLife] = notify;
}

inline unsigned short *
AnimationaddonOptions::optionGetFireColor ()
{
    return mOptions[AnimationaddonOptions::FireColor].value ().c ();
}

inline unsigned short
AnimationaddonOptions::optionGetFireColorRed ()
{
    return mOptions[AnimationaddonOptions::FireColor].value ().c ()[0];
}

inline unsigned short
AnimationaddonOptions::optionGetFireColorGreen ()
{
    return mOptions[AnimationaddonOptions::FireColor].value ().c ()[1];
}


inline unsigned short
AnimationaddonOptions::optionGetFireColorBlue ()
{
    return mOptions[AnimationaddonOptions::FireColor].value ().c ()[2];
}


inline unsigned short
AnimationaddonOptions::optionGetFireColorAlpha ()
{
    return mOptions[AnimationaddonOptions::FireColor].value ().c ()[3];
}


inline void
AnimationaddonOptions::optionSetFireColorNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireColor] = notify;
}

inline int
AnimationaddonOptions::optionGetFireDirection ()
{
    return mOptions[AnimationaddonOptions::FireDirection].value ().i ();
}

inline void
AnimationaddonOptions::optionSetFireDirectionNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireDirection] = notify;
}

inline bool
AnimationaddonOptions::optionGetFireConstantSpeed ()
{
    return mOptions[AnimationaddonOptions::FireConstantSpeed].value ().b ();
}

inline void
AnimationaddonOptions::optionSetFireConstantSpeedNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireConstantSpeed] = notify;
}

inline bool
AnimationaddonOptions::optionGetFireSmoke ()
{
    return mOptions[AnimationaddonOptions::FireSmoke].value ().b ();
}

inline void
AnimationaddonOptions::optionSetFireSmokeNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireSmoke] = notify;
}

inline bool
AnimationaddonOptions::optionGetFireMystical ()
{
    return mOptions[AnimationaddonOptions::FireMystical].value ().b ();
}

inline void
AnimationaddonOptions::optionSetFireMysticalNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FireMystical] = notify;
}

inline int
AnimationaddonOptions::optionGetDominoDirection ()
{
    return mOptions[AnimationaddonOptions::DominoDirection].value ().i ();
}

inline void
AnimationaddonOptions::optionSetDominoDirectionNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::DominoDirection] = notify;
}

inline int
AnimationaddonOptions::optionGetExplodeGridx ()
{
    return mOptions[AnimationaddonOptions::ExplodeGridx].value ().i ();
}

inline void
AnimationaddonOptions::optionSetExplodeGridxNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::ExplodeGridx] = notify;
}

inline int
AnimationaddonOptions::optionGetExplodeGridy ()
{
    return mOptions[AnimationaddonOptions::ExplodeGridy].value ().i ();
}

inline void
AnimationaddonOptions::optionSetExplodeGridyNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::ExplodeGridy] = notify;
}

inline int
AnimationaddonOptions::optionGetExplodeSpokes ()
{
    return mOptions[AnimationaddonOptions::ExplodeSpokes].value ().i ();
}

inline void
AnimationaddonOptions::optionSetExplodeSpokesNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::ExplodeSpokes] = notify;
}

inline int
AnimationaddonOptions::optionGetExplodeTiers ()
{
    return mOptions[AnimationaddonOptions::ExplodeTiers].value ().i ();
}

inline void
AnimationaddonOptions::optionSetExplodeTiersNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::ExplodeTiers] = notify;
}

inline float
AnimationaddonOptions::optionGetExplodeThickness ()
{
    return mOptions[AnimationaddonOptions::ExplodeThickness].value ().f ();
}

inline void
AnimationaddonOptions::optionSetExplodeThicknessNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::ExplodeThickness] = notify;
}

inline int
AnimationaddonOptions::optionGetExplodeTessellation ()
{
    return mOptions[AnimationaddonOptions::ExplodeTessellation].value ().i ();
}

inline void
AnimationaddonOptions::optionSetExplodeTessellationNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::ExplodeTessellation] = notify;
}

inline int
AnimationaddonOptions::optionGetFoldGridx ()
{
    return mOptions[AnimationaddonOptions::FoldGridx].value ().i ();
}

inline void
AnimationaddonOptions::optionSetFoldGridxNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FoldGridx] = notify;
}

inline int
AnimationaddonOptions::optionGetFoldGridy ()
{
    return mOptions[AnimationaddonOptions::FoldGridy].value ().i ();
}

inline void
AnimationaddonOptions::optionSetFoldGridyNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FoldGridy] = notify;
}

inline int
AnimationaddonOptions::optionGetFoldDir ()
{
    return mOptions[AnimationaddonOptions::FoldDir].value ().i ();
}

inline void
AnimationaddonOptions::optionSetFoldDirNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::FoldDir] = notify;
}

inline float
AnimationaddonOptions::optionGetGlide3AwayPosition ()
{
    return mOptions[AnimationaddonOptions::Glide3AwayPosition].value ().f ();
}

inline void
AnimationaddonOptions::optionSetGlide3AwayPositionNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::Glide3AwayPosition] = notify;
}

inline float
AnimationaddonOptions::optionGetGlide3AwayAngle ()
{
    return mOptions[AnimationaddonOptions::Glide3AwayAngle].value ().f ();
}

inline void
AnimationaddonOptions::optionSetGlide3AwayAngleNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::Glide3AwayAngle] = notify;
}

inline float
AnimationaddonOptions::optionGetGlide3Thickness ()
{
    return mOptions[AnimationaddonOptions::Glide3Thickness].value ().f ();
}

inline void
AnimationaddonOptions::optionSetGlide3ThicknessNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::Glide3Thickness] = notify;
}

inline int
AnimationaddonOptions::optionGetRazrDirection ()
{
    return mOptions[AnimationaddonOptions::RazrDirection].value ().i ();
}

inline void
AnimationaddonOptions::optionSetRazrDirectionNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::RazrDirection] = notify;
}

inline int
AnimationaddonOptions::optionGetSkewerDirection ()
{
    return mOptions[AnimationaddonOptions::SkewerDirection].value ().i ();
}

inline void
AnimationaddonOptions::optionSetSkewerDirectionNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::SkewerDirection] = notify;
}

inline int
AnimationaddonOptions::optionGetSkewerTessellation ()
{
    return mOptions[AnimationaddonOptions::SkewerTessellation].value ().i ();
}

inline void
AnimationaddonOptions::optionSetSkewerTessellationNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::SkewerTessellation] = notify;
}

inline int
AnimationaddonOptions::optionGetSkewerGridx ()
{
    return mOptions[AnimationaddonOptions::SkewerGridx].value ().i ();
}

inline void
AnimationaddonOptions::optionSetSkewerGridxNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::SkewerGridx] = notify;
}

inline int
AnimationaddonOptions::optionGetSkewerGridy ()
{
    return mOptions[AnimationaddonOptions::SkewerGridy].value ().i ();
}

inline void
AnimationaddonOptions::optionSetSkewerGridyNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::SkewerGridy] = notify;
}

inline float
AnimationaddonOptions::optionGetSkewerThickness ()
{
    return mOptions[AnimationaddonOptions::SkewerThickness].value ().f ();
}

inline void
AnimationaddonOptions::optionSetSkewerThicknessNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::SkewerThickness] = notify;
}

inline int
AnimationaddonOptions::optionGetSkewerRotation ()
{
    return mOptions[AnimationaddonOptions::SkewerRotation].value ().i ();
}

inline void
AnimationaddonOptions::optionSetSkewerRotationNotify (AnimationaddonOptions::ChangeNotify notify)
{
    mNotify[AnimationaddonOptions::SkewerRotation] = notify;
}



#endif
