/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ANIMATIONJC_OPTIONS_H
#define _ANIMATIONJC_OPTIONS_H

#include <core/core.h>

class AnimationjcOptions : public CompOption::Class {
    public:
        enum Options {
            BlackholeDelay,
            FlickerAmplitude,
            GhostGrid,
            GhostSaturation,
            GhostAmplitude,
            GhostWaveSpeed,
            PopcornKernelHeight,
            RaindropAmplitude,
            RaindropWavelength,
            RaindropNumWaves,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        AnimationjcOptions (bool init = true);
        virtual ~AnimationjcOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        float optionGetBlackholeDelay ();
        void optionSetBlackholeDelayNotify (ChangeNotify notify);

        int optionGetFlickerAmplitude ();
        void optionSetFlickerAmplitudeNotify (ChangeNotify notify);

        int optionGetGhostGrid ();
        void optionSetGhostGridNotify (ChangeNotify notify);

        float optionGetGhostSaturation ();
        void optionSetGhostSaturationNotify (ChangeNotify notify);

        float optionGetGhostAmplitude ();
        void optionSetGhostAmplitudeNotify (ChangeNotify notify);

        float optionGetGhostWaveSpeed ();
        void optionSetGhostWaveSpeedNotify (ChangeNotify notify);

        float optionGetPopcornKernelHeight ();
        void optionSetPopcornKernelHeightNotify (ChangeNotify notify);

        float optionGetRaindropAmplitude ();
        void optionSetRaindropAmplitudeNotify (ChangeNotify notify);

        float optionGetRaindropWavelength ();
        void optionSetRaindropWavelengthNotify (ChangeNotify notify);

        int optionGetRaindropNumWaves ();
        void optionSetRaindropNumWavesNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline float
AnimationjcOptions::optionGetBlackholeDelay ()
{
    return mOptions[AnimationjcOptions::BlackholeDelay].value ().f ();
}

inline void
AnimationjcOptions::optionSetBlackholeDelayNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::BlackholeDelay] = notify;
}

inline int
AnimationjcOptions::optionGetFlickerAmplitude ()
{
    return mOptions[AnimationjcOptions::FlickerAmplitude].value ().i ();
}

inline void
AnimationjcOptions::optionSetFlickerAmplitudeNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::FlickerAmplitude] = notify;
}

inline int
AnimationjcOptions::optionGetGhostGrid ()
{
    return mOptions[AnimationjcOptions::GhostGrid].value ().i ();
}

inline void
AnimationjcOptions::optionSetGhostGridNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::GhostGrid] = notify;
}

inline float
AnimationjcOptions::optionGetGhostSaturation ()
{
    return mOptions[AnimationjcOptions::GhostSaturation].value ().f ();
}

inline void
AnimationjcOptions::optionSetGhostSaturationNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::GhostSaturation] = notify;
}

inline float
AnimationjcOptions::optionGetGhostAmplitude ()
{
    return mOptions[AnimationjcOptions::GhostAmplitude].value ().f ();
}

inline void
AnimationjcOptions::optionSetGhostAmplitudeNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::GhostAmplitude] = notify;
}

inline float
AnimationjcOptions::optionGetGhostWaveSpeed ()
{
    return mOptions[AnimationjcOptions::GhostWaveSpeed].value ().f ();
}

inline void
AnimationjcOptions::optionSetGhostWaveSpeedNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::GhostWaveSpeed] = notify;
}

inline float
AnimationjcOptions::optionGetPopcornKernelHeight ()
{
    return mOptions[AnimationjcOptions::PopcornKernelHeight].value ().f ();
}

inline void
AnimationjcOptions::optionSetPopcornKernelHeightNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::PopcornKernelHeight] = notify;
}

inline float
AnimationjcOptions::optionGetRaindropAmplitude ()
{
    return mOptions[AnimationjcOptions::RaindropAmplitude].value ().f ();
}

inline void
AnimationjcOptions::optionSetRaindropAmplitudeNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::RaindropAmplitude] = notify;
}

inline float
AnimationjcOptions::optionGetRaindropWavelength ()
{
    return mOptions[AnimationjcOptions::RaindropWavelength].value ().f ();
}

inline void
AnimationjcOptions::optionSetRaindropWavelengthNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::RaindropWavelength] = notify;
}

inline int
AnimationjcOptions::optionGetRaindropNumWaves ()
{
    return mOptions[AnimationjcOptions::RaindropNumWaves].value ().i ();
}

inline void
AnimationjcOptions::optionSetRaindropNumWavesNotify (AnimationjcOptions::ChangeNotify notify)
{
    mNotify[AnimationjcOptions::RaindropNumWaves] = notify;
}



#endif
