/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _ANIMATIONPLUS_OPTIONS_H
#define _ANIMATIONPLUS_OPTIONS_H

#include <core/core.h>

class AnimationplusOptions : public CompOption::Class {
    public:
        enum Options {
            HelixNumTwists,
            HelixGridy,
            HelixThickness,
            HelixSpinDirection,
            HelixDirection,
            BlindsNumHalftwists,
            BlindsGridx,
            BlindsThickness,
            ShatterNumSpokes,
            ShatterNumTiers,
            BonanzaParticles,
            BonanzaSize,
            BonanzaLife,
            BonanzaColor,
            BonanzaMystical,
            OptionNum
        };

        enum HelixSpinDirection {
            HelixSpinDirectionCounterClockwise = 0,
            HelixSpinDirectionClockwise = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        AnimationplusOptions (bool init = true);
        virtual ~AnimationplusOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        int optionGetHelixNumTwists ();
        void optionSetHelixNumTwistsNotify (ChangeNotify notify);

        int optionGetHelixGridy ();
        void optionSetHelixGridyNotify (ChangeNotify notify);

        float optionGetHelixThickness ();
        void optionSetHelixThicknessNotify (ChangeNotify notify);

        int optionGetHelixSpinDirection ();
        void optionSetHelixSpinDirectionNotify (ChangeNotify notify);

        bool optionGetHelixDirection ();
        void optionSetHelixDirectionNotify (ChangeNotify notify);

        int optionGetBlindsNumHalftwists ();
        void optionSetBlindsNumHalftwistsNotify (ChangeNotify notify);

        int optionGetBlindsGridx ();
        void optionSetBlindsGridxNotify (ChangeNotify notify);

        float optionGetBlindsThickness ();
        void optionSetBlindsThicknessNotify (ChangeNotify notify);

        int optionGetShatterNumSpokes ();
        void optionSetShatterNumSpokesNotify (ChangeNotify notify);

        int optionGetShatterNumTiers ();
        void optionSetShatterNumTiersNotify (ChangeNotify notify);

        int optionGetBonanzaParticles ();
        void optionSetBonanzaParticlesNotify (ChangeNotify notify);

        float optionGetBonanzaSize ();
        void optionSetBonanzaSizeNotify (ChangeNotify notify);

        float optionGetBonanzaLife ();
        void optionSetBonanzaLifeNotify (ChangeNotify notify);

        unsigned short * optionGetBonanzaColor ();
        unsigned short optionGetBonanzaColorRed ();
        unsigned short optionGetBonanzaColorGreen ();
        unsigned short optionGetBonanzaColorBlue ();
        unsigned short optionGetBonanzaColorAlpha ();
        void optionSetBonanzaColorNotify (ChangeNotify notify);

        bool optionGetBonanzaMystical ();
        void optionSetBonanzaMysticalNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline int
AnimationplusOptions::optionGetHelixNumTwists ()
{
    return mOptions[AnimationplusOptions::HelixNumTwists].value ().i ();
}

inline void
AnimationplusOptions::optionSetHelixNumTwistsNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::HelixNumTwists] = notify;
}

inline int
AnimationplusOptions::optionGetHelixGridy ()
{
    return mOptions[AnimationplusOptions::HelixGridy].value ().i ();
}

inline void
AnimationplusOptions::optionSetHelixGridyNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::HelixGridy] = notify;
}

inline float
AnimationplusOptions::optionGetHelixThickness ()
{
    return mOptions[AnimationplusOptions::HelixThickness].value ().f ();
}

inline void
AnimationplusOptions::optionSetHelixThicknessNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::HelixThickness] = notify;
}

inline int
AnimationplusOptions::optionGetHelixSpinDirection ()
{
    return mOptions[AnimationplusOptions::HelixSpinDirection].value ().i ();
}

inline void
AnimationplusOptions::optionSetHelixSpinDirectionNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::HelixSpinDirection] = notify;
}

inline bool
AnimationplusOptions::optionGetHelixDirection ()
{
    return mOptions[AnimationplusOptions::HelixDirection].value ().b ();
}

inline void
AnimationplusOptions::optionSetHelixDirectionNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::HelixDirection] = notify;
}

inline int
AnimationplusOptions::optionGetBlindsNumHalftwists ()
{
    return mOptions[AnimationplusOptions::BlindsNumHalftwists].value ().i ();
}

inline void
AnimationplusOptions::optionSetBlindsNumHalftwistsNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BlindsNumHalftwists] = notify;
}

inline int
AnimationplusOptions::optionGetBlindsGridx ()
{
    return mOptions[AnimationplusOptions::BlindsGridx].value ().i ();
}

inline void
AnimationplusOptions::optionSetBlindsGridxNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BlindsGridx] = notify;
}

inline float
AnimationplusOptions::optionGetBlindsThickness ()
{
    return mOptions[AnimationplusOptions::BlindsThickness].value ().f ();
}

inline void
AnimationplusOptions::optionSetBlindsThicknessNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BlindsThickness] = notify;
}

inline int
AnimationplusOptions::optionGetShatterNumSpokes ()
{
    return mOptions[AnimationplusOptions::ShatterNumSpokes].value ().i ();
}

inline void
AnimationplusOptions::optionSetShatterNumSpokesNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::ShatterNumSpokes] = notify;
}

inline int
AnimationplusOptions::optionGetShatterNumTiers ()
{
    return mOptions[AnimationplusOptions::ShatterNumTiers].value ().i ();
}

inline void
AnimationplusOptions::optionSetShatterNumTiersNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::ShatterNumTiers] = notify;
}

inline int
AnimationplusOptions::optionGetBonanzaParticles ()
{
    return mOptions[AnimationplusOptions::BonanzaParticles].value ().i ();
}

inline void
AnimationplusOptions::optionSetBonanzaParticlesNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BonanzaParticles] = notify;
}

inline float
AnimationplusOptions::optionGetBonanzaSize ()
{
    return mOptions[AnimationplusOptions::BonanzaSize].value ().f ();
}

inline void
AnimationplusOptions::optionSetBonanzaSizeNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BonanzaSize] = notify;
}

inline float
AnimationplusOptions::optionGetBonanzaLife ()
{
    return mOptions[AnimationplusOptions::BonanzaLife].value ().f ();
}

inline void
AnimationplusOptions::optionSetBonanzaLifeNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BonanzaLife] = notify;
}

inline unsigned short *
AnimationplusOptions::optionGetBonanzaColor ()
{
    return mOptions[AnimationplusOptions::BonanzaColor].value ().c ();
}

inline unsigned short
AnimationplusOptions::optionGetBonanzaColorRed ()
{
    return mOptions[AnimationplusOptions::BonanzaColor].value ().c ()[0];
}

inline unsigned short
AnimationplusOptions::optionGetBonanzaColorGreen ()
{
    return mOptions[AnimationplusOptions::BonanzaColor].value ().c ()[1];
}


inline unsigned short
AnimationplusOptions::optionGetBonanzaColorBlue ()
{
    return mOptions[AnimationplusOptions::BonanzaColor].value ().c ()[2];
}


inline unsigned short
AnimationplusOptions::optionGetBonanzaColorAlpha ()
{
    return mOptions[AnimationplusOptions::BonanzaColor].value ().c ()[3];
}


inline void
AnimationplusOptions::optionSetBonanzaColorNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BonanzaColor] = notify;
}

inline bool
AnimationplusOptions::optionGetBonanzaMystical ()
{
    return mOptions[AnimationplusOptions::BonanzaMystical].value ().b ();
}

inline void
AnimationplusOptions::optionSetBonanzaMysticalNotify (AnimationplusOptions::ChangeNotify notify)
{
    mNotify[AnimationplusOptions::BonanzaMystical] = notify;
}



#endif
