/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _BENCH_OPTIONS_H
#define _BENCH_OPTIONS_H

#include <core/core.h>

class BenchOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateKey,
            FpsLimiterMode,
            OutputScreen,
            PositionX,
            PositionY,
            OutputConsole,
            ConsoleUpdateTime,
            OptionNum
        };

        enum FpsLimiterMode {
            FpsLimiterModeLimiterDisabled = 0,
            FpsLimiterModeDefaultLimiter = 1,
            FpsLimiterModeVSyncLikeLimiter = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        BenchOptions (bool init = true);
        virtual ~BenchOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        int optionGetFpsLimiterMode ();
        void optionSetFpsLimiterModeNotify (ChangeNotify notify);

        bool optionGetOutputScreen ();
        void optionSetOutputScreenNotify (ChangeNotify notify);

        int optionGetPositionX ();
        void optionSetPositionXNotify (ChangeNotify notify);

        int optionGetPositionY ();
        void optionSetPositionYNotify (ChangeNotify notify);

        bool optionGetOutputConsole ();
        void optionSetOutputConsoleNotify (ChangeNotify notify);

        int optionGetConsoleUpdateTime ();
        void optionSetConsoleUpdateTimeNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
BenchOptions::optionGetInitiateKey ()
{
    return mOptions[BenchOptions::InitiateKey].value ().action ();
}

inline void
BenchOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[BenchOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
BenchOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[BenchOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
BenchOptions::optionSetInitiateKeyNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::InitiateKey] = notify;
}

inline int
BenchOptions::optionGetFpsLimiterMode ()
{
    return mOptions[BenchOptions::FpsLimiterMode].value ().i ();
}

inline void
BenchOptions::optionSetFpsLimiterModeNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::FpsLimiterMode] = notify;
}

inline bool
BenchOptions::optionGetOutputScreen ()
{
    return mOptions[BenchOptions::OutputScreen].value ().b ();
}

inline void
BenchOptions::optionSetOutputScreenNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::OutputScreen] = notify;
}

inline int
BenchOptions::optionGetPositionX ()
{
    return mOptions[BenchOptions::PositionX].value ().i ();
}

inline void
BenchOptions::optionSetPositionXNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::PositionX] = notify;
}

inline int
BenchOptions::optionGetPositionY ()
{
    return mOptions[BenchOptions::PositionY].value ().i ();
}

inline void
BenchOptions::optionSetPositionYNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::PositionY] = notify;
}

inline bool
BenchOptions::optionGetOutputConsole ()
{
    return mOptions[BenchOptions::OutputConsole].value ().b ();
}

inline void
BenchOptions::optionSetOutputConsoleNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::OutputConsole] = notify;
}

inline int
BenchOptions::optionGetConsoleUpdateTime ()
{
    return mOptions[BenchOptions::ConsoleUpdateTime].value ().i ();
}

inline void
BenchOptions::optionSetConsoleUpdateTimeNotify (BenchOptions::ChangeNotify notify)
{
    mNotify[BenchOptions::ConsoleUpdateTime] = notify;
}



#endif
