/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _BLUR_OPTIONS_H
#define _BLUR_OPTIONS_H

#include <core/core.h>

class BlurOptions : public CompOption::Class {
    public:
        enum Options {
            Pulse,
            BlurSpeed,
            FocusBlurMatch,
            FocusBlur,
            AlphaBlurMatch,
            AlphaBlur,
            Filter,
            GaussianRadius,
            GaussianStrength,
            MipmapLod,
            Saturation,
            Occlusion,
            IndependentTex,
            OptionNum
        };

        enum Filter {
            Filter4xbilinear = 0,
            FilterGaussian = 1,
            FilterMipmap = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        BlurOptions (bool init = true);
        virtual ~BlurOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetPulse ();
        void optionSetPulseInitiate (CompAction::CallBack init);
        void optionSetPulseTerminate (CompAction::CallBack term);
        void optionSetPulseNotify (ChangeNotify notify);

        float optionGetBlurSpeed ();
        void optionSetBlurSpeedNotify (ChangeNotify notify);

        CompMatch & optionGetFocusBlurMatch ();
        void optionSetFocusBlurMatchNotify (ChangeNotify notify);

        bool optionGetFocusBlur ();
        void optionSetFocusBlurNotify (ChangeNotify notify);

        CompMatch & optionGetAlphaBlurMatch ();
        void optionSetAlphaBlurMatchNotify (ChangeNotify notify);

        bool optionGetAlphaBlur ();
        void optionSetAlphaBlurNotify (ChangeNotify notify);

        int optionGetFilter ();
        void optionSetFilterNotify (ChangeNotify notify);

        int optionGetGaussianRadius ();
        void optionSetGaussianRadiusNotify (ChangeNotify notify);

        float optionGetGaussianStrength ();
        void optionSetGaussianStrengthNotify (ChangeNotify notify);

        float optionGetMipmapLod ();
        void optionSetMipmapLodNotify (ChangeNotify notify);

        int optionGetSaturation ();
        void optionSetSaturationNotify (ChangeNotify notify);

        bool optionGetOcclusion ();
        void optionSetOcclusionNotify (ChangeNotify notify);

        bool optionGetIndependentTex ();
        void optionSetIndependentTexNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
BlurOptions::optionGetPulse ()
{
    return mOptions[BlurOptions::Pulse].value ().action ();
}

inline void
BlurOptions::optionSetPulseInitiate (CompAction::CallBack init)
{
    mOptions[BlurOptions::Pulse].value ().action ().setInitiate (init);
}

inline void
BlurOptions::optionSetPulseTerminate (CompAction::CallBack term)
{
    mOptions[BlurOptions::Pulse].value ().action ().setTerminate (term);
}

inline void
BlurOptions::optionSetPulseNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::Pulse] = notify;
}

inline float
BlurOptions::optionGetBlurSpeed ()
{
    return mOptions[BlurOptions::BlurSpeed].value ().f ();
}

inline void
BlurOptions::optionSetBlurSpeedNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::BlurSpeed] = notify;
}

inline CompMatch &
BlurOptions::optionGetFocusBlurMatch ()
{
    return mOptions[BlurOptions::FocusBlurMatch].value ().match ();
}

inline void
BlurOptions::optionSetFocusBlurMatchNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::FocusBlurMatch] = notify;
}

inline bool
BlurOptions::optionGetFocusBlur ()
{
    return mOptions[BlurOptions::FocusBlur].value ().b ();
}

inline void
BlurOptions::optionSetFocusBlurNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::FocusBlur] = notify;
}

inline CompMatch &
BlurOptions::optionGetAlphaBlurMatch ()
{
    return mOptions[BlurOptions::AlphaBlurMatch].value ().match ();
}

inline void
BlurOptions::optionSetAlphaBlurMatchNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::AlphaBlurMatch] = notify;
}

inline bool
BlurOptions::optionGetAlphaBlur ()
{
    return mOptions[BlurOptions::AlphaBlur].value ().b ();
}

inline void
BlurOptions::optionSetAlphaBlurNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::AlphaBlur] = notify;
}

inline int
BlurOptions::optionGetFilter ()
{
    return mOptions[BlurOptions::Filter].value ().i ();
}

inline void
BlurOptions::optionSetFilterNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::Filter] = notify;
}

inline int
BlurOptions::optionGetGaussianRadius ()
{
    return mOptions[BlurOptions::GaussianRadius].value ().i ();
}

inline void
BlurOptions::optionSetGaussianRadiusNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::GaussianRadius] = notify;
}

inline float
BlurOptions::optionGetGaussianStrength ()
{
    return mOptions[BlurOptions::GaussianStrength].value ().f ();
}

inline void
BlurOptions::optionSetGaussianStrengthNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::GaussianStrength] = notify;
}

inline float
BlurOptions::optionGetMipmapLod ()
{
    return mOptions[BlurOptions::MipmapLod].value ().f ();
}

inline void
BlurOptions::optionSetMipmapLodNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::MipmapLod] = notify;
}

inline int
BlurOptions::optionGetSaturation ()
{
    return mOptions[BlurOptions::Saturation].value ().i ();
}

inline void
BlurOptions::optionSetSaturationNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::Saturation] = notify;
}

inline bool
BlurOptions::optionGetOcclusion ()
{
    return mOptions[BlurOptions::Occlusion].value ().b ();
}

inline void
BlurOptions::optionSetOcclusionNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::Occlusion] = notify;
}

inline bool
BlurOptions::optionGetIndependentTex ()
{
    return mOptions[BlurOptions::IndependentTex].value ().b ();
}

inline void
BlurOptions::optionSetIndependentTexNotify (BlurOptions::ChangeNotify notify)
{
    mNotify[BlurOptions::IndependentTex] = notify;
}



#endif
