/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _CUBE_OPTIONS_H
#define _CUBE_OPTIONS_H

#include <core/core.h>

class CubeOptions : public CompOption::Class {
    public:
        enum Options {
            UnfoldKey,
            Mipmap,
            MultioutputMode,
            In,
            Acceleration,
            Speed,
            Timestep,
            TopColor,
            BottomColor,
            Skydome,
            SkydomeImage,
            SkydomeAnimated,
            SkydomeGradientStartColor,
            SkydomeGradientEndColor,
            ActiveOpacity,
            InactiveOpacity,
            TransparentManualOnly,
            OptionNum
        };

        enum MultioutputMode {
            MultioutputModeAutomatic = 0,
            MultioutputModeMultipleCubes = 1,
            MultioutputModeOneBigCube = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        CubeOptions (bool init = true);
        virtual ~CubeOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetUnfoldKey ();
        void optionSetUnfoldKeyInitiate (CompAction::CallBack init);
        void optionSetUnfoldKeyTerminate (CompAction::CallBack term);
        void optionSetUnfoldKeyNotify (ChangeNotify notify);

        bool optionGetMipmap ();
        void optionSetMipmapNotify (ChangeNotify notify);

        int optionGetMultioutputMode ();
        void optionSetMultioutputModeNotify (ChangeNotify notify);

        bool optionGetIn ();
        void optionSetInNotify (ChangeNotify notify);

        float optionGetAcceleration ();
        void optionSetAccelerationNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        unsigned short * optionGetTopColor ();
        unsigned short optionGetTopColorRed ();
        unsigned short optionGetTopColorGreen ();
        unsigned short optionGetTopColorBlue ();
        unsigned short optionGetTopColorAlpha ();
        void optionSetTopColorNotify (ChangeNotify notify);

        unsigned short * optionGetBottomColor ();
        unsigned short optionGetBottomColorRed ();
        unsigned short optionGetBottomColorGreen ();
        unsigned short optionGetBottomColorBlue ();
        unsigned short optionGetBottomColorAlpha ();
        void optionSetBottomColorNotify (ChangeNotify notify);

        bool optionGetSkydome ();
        void optionSetSkydomeNotify (ChangeNotify notify);

        CompString optionGetSkydomeImage ();
        void optionSetSkydomeImageNotify (ChangeNotify notify);

        bool optionGetSkydomeAnimated ();
        void optionSetSkydomeAnimatedNotify (ChangeNotify notify);

        unsigned short * optionGetSkydomeGradientStartColor ();
        unsigned short optionGetSkydomeGradientStartColorRed ();
        unsigned short optionGetSkydomeGradientStartColorGreen ();
        unsigned short optionGetSkydomeGradientStartColorBlue ();
        unsigned short optionGetSkydomeGradientStartColorAlpha ();
        void optionSetSkydomeGradientStartColorNotify (ChangeNotify notify);

        unsigned short * optionGetSkydomeGradientEndColor ();
        unsigned short optionGetSkydomeGradientEndColorRed ();
        unsigned short optionGetSkydomeGradientEndColorGreen ();
        unsigned short optionGetSkydomeGradientEndColorBlue ();
        unsigned short optionGetSkydomeGradientEndColorAlpha ();
        void optionSetSkydomeGradientEndColorNotify (ChangeNotify notify);

        float optionGetActiveOpacity ();
        void optionSetActiveOpacityNotify (ChangeNotify notify);

        float optionGetInactiveOpacity ();
        void optionSetInactiveOpacityNotify (ChangeNotify notify);

        bool optionGetTransparentManualOnly ();
        void optionSetTransparentManualOnlyNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
CubeOptions::optionGetUnfoldKey ()
{
    return mOptions[CubeOptions::UnfoldKey].value ().action ();
}

inline void
CubeOptions::optionSetUnfoldKeyInitiate (CompAction::CallBack init)
{
    mOptions[CubeOptions::UnfoldKey].value ().action ().setInitiate (init);
}

inline void
CubeOptions::optionSetUnfoldKeyTerminate (CompAction::CallBack term)
{
    mOptions[CubeOptions::UnfoldKey].value ().action ().setTerminate (term);
}

inline void
CubeOptions::optionSetUnfoldKeyNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::UnfoldKey] = notify;
}

inline bool
CubeOptions::optionGetMipmap ()
{
    return mOptions[CubeOptions::Mipmap].value ().b ();
}

inline void
CubeOptions::optionSetMipmapNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::Mipmap] = notify;
}

inline int
CubeOptions::optionGetMultioutputMode ()
{
    return mOptions[CubeOptions::MultioutputMode].value ().i ();
}

inline void
CubeOptions::optionSetMultioutputModeNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::MultioutputMode] = notify;
}

inline bool
CubeOptions::optionGetIn ()
{
    return mOptions[CubeOptions::In].value ().b ();
}

inline void
CubeOptions::optionSetInNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::In] = notify;
}

inline float
CubeOptions::optionGetAcceleration ()
{
    return mOptions[CubeOptions::Acceleration].value ().f ();
}

inline void
CubeOptions::optionSetAccelerationNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::Acceleration] = notify;
}

inline float
CubeOptions::optionGetSpeed ()
{
    return mOptions[CubeOptions::Speed].value ().f ();
}

inline void
CubeOptions::optionSetSpeedNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::Speed] = notify;
}

inline float
CubeOptions::optionGetTimestep ()
{
    return mOptions[CubeOptions::Timestep].value ().f ();
}

inline void
CubeOptions::optionSetTimestepNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::Timestep] = notify;
}

inline unsigned short *
CubeOptions::optionGetTopColor ()
{
    return mOptions[CubeOptions::TopColor].value ().c ();
}

inline unsigned short
CubeOptions::optionGetTopColorRed ()
{
    return mOptions[CubeOptions::TopColor].value ().c ()[0];
}

inline unsigned short
CubeOptions::optionGetTopColorGreen ()
{
    return mOptions[CubeOptions::TopColor].value ().c ()[1];
}


inline unsigned short
CubeOptions::optionGetTopColorBlue ()
{
    return mOptions[CubeOptions::TopColor].value ().c ()[2];
}


inline unsigned short
CubeOptions::optionGetTopColorAlpha ()
{
    return mOptions[CubeOptions::TopColor].value ().c ()[3];
}


inline void
CubeOptions::optionSetTopColorNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::TopColor] = notify;
}

inline unsigned short *
CubeOptions::optionGetBottomColor ()
{
    return mOptions[CubeOptions::BottomColor].value ().c ();
}

inline unsigned short
CubeOptions::optionGetBottomColorRed ()
{
    return mOptions[CubeOptions::BottomColor].value ().c ()[0];
}

inline unsigned short
CubeOptions::optionGetBottomColorGreen ()
{
    return mOptions[CubeOptions::BottomColor].value ().c ()[1];
}


inline unsigned short
CubeOptions::optionGetBottomColorBlue ()
{
    return mOptions[CubeOptions::BottomColor].value ().c ()[2];
}


inline unsigned short
CubeOptions::optionGetBottomColorAlpha ()
{
    return mOptions[CubeOptions::BottomColor].value ().c ()[3];
}


inline void
CubeOptions::optionSetBottomColorNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::BottomColor] = notify;
}

inline bool
CubeOptions::optionGetSkydome ()
{
    return mOptions[CubeOptions::Skydome].value ().b ();
}

inline void
CubeOptions::optionSetSkydomeNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::Skydome] = notify;
}

inline CompString
CubeOptions::optionGetSkydomeImage ()
{
    return mOptions[CubeOptions::SkydomeImage].value ().s ();
}

inline void
CubeOptions::optionSetSkydomeImageNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::SkydomeImage] = notify;
}

inline bool
CubeOptions::optionGetSkydomeAnimated ()
{
    return mOptions[CubeOptions::SkydomeAnimated].value ().b ();
}

inline void
CubeOptions::optionSetSkydomeAnimatedNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::SkydomeAnimated] = notify;
}

inline unsigned short *
CubeOptions::optionGetSkydomeGradientStartColor ()
{
    return mOptions[CubeOptions::SkydomeGradientStartColor].value ().c ();
}

inline unsigned short
CubeOptions::optionGetSkydomeGradientStartColorRed ()
{
    return mOptions[CubeOptions::SkydomeGradientStartColor].value ().c ()[0];
}

inline unsigned short
CubeOptions::optionGetSkydomeGradientStartColorGreen ()
{
    return mOptions[CubeOptions::SkydomeGradientStartColor].value ().c ()[1];
}


inline unsigned short
CubeOptions::optionGetSkydomeGradientStartColorBlue ()
{
    return mOptions[CubeOptions::SkydomeGradientStartColor].value ().c ()[2];
}


inline unsigned short
CubeOptions::optionGetSkydomeGradientStartColorAlpha ()
{
    return mOptions[CubeOptions::SkydomeGradientStartColor].value ().c ()[3];
}


inline void
CubeOptions::optionSetSkydomeGradientStartColorNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::SkydomeGradientStartColor] = notify;
}

inline unsigned short *
CubeOptions::optionGetSkydomeGradientEndColor ()
{
    return mOptions[CubeOptions::SkydomeGradientEndColor].value ().c ();
}

inline unsigned short
CubeOptions::optionGetSkydomeGradientEndColorRed ()
{
    return mOptions[CubeOptions::SkydomeGradientEndColor].value ().c ()[0];
}

inline unsigned short
CubeOptions::optionGetSkydomeGradientEndColorGreen ()
{
    return mOptions[CubeOptions::SkydomeGradientEndColor].value ().c ()[1];
}


inline unsigned short
CubeOptions::optionGetSkydomeGradientEndColorBlue ()
{
    return mOptions[CubeOptions::SkydomeGradientEndColor].value ().c ()[2];
}


inline unsigned short
CubeOptions::optionGetSkydomeGradientEndColorAlpha ()
{
    return mOptions[CubeOptions::SkydomeGradientEndColor].value ().c ()[3];
}


inline void
CubeOptions::optionSetSkydomeGradientEndColorNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::SkydomeGradientEndColor] = notify;
}

inline float
CubeOptions::optionGetActiveOpacity ()
{
    return mOptions[CubeOptions::ActiveOpacity].value ().f ();
}

inline void
CubeOptions::optionSetActiveOpacityNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::ActiveOpacity] = notify;
}

inline float
CubeOptions::optionGetInactiveOpacity ()
{
    return mOptions[CubeOptions::InactiveOpacity].value ().f ();
}

inline void
CubeOptions::optionSetInactiveOpacityNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::InactiveOpacity] = notify;
}

inline bool
CubeOptions::optionGetTransparentManualOnly ()
{
    return mOptions[CubeOptions::TransparentManualOnly].value ().b ();
}

inline void
CubeOptions::optionSetTransparentManualOnlyNotify (CubeOptions::ChangeNotify notify)
{
    mNotify[CubeOptions::TransparentManualOnly] = notify;
}



#endif
