/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _CUBEADDON_OPTIONS_H
#define _CUBEADDON_OPTIONS_H

#include <core/core.h>

class CubeaddonOptions : public CompOption::Class {
    public:
        enum Options {
            TopNextKey,
            TopNextButton,
            TopPrevKey,
            TopPrevButton,
            BottomNextKey,
            BottomNextButton,
            BottomPrevKey,
            BottomPrevButton,
            Reflection,
            GroundColor1,
            GroundColor2,
            GroundSize,
            Intensity,
            AutoZoom,
            ZoomManualOnly,
            Mode,
            Deformation,
            UnfoldDeformation,
            CylinderManualOnly,
            DeformCaps,
            SphereAspect,
            DrawTop,
            DrawBottom,
            AdjustTop,
            AdjustBottom,
            TopScale,
            BottomScale,
            TopAspect,
            BottomAspect,
            TopClamp,
            BottomClamp,
            TopImages,
            BottomImages,
            OptionNum
        };

        enum Mode {
            ModeJumpy = 0,
            ModeJumpyReflection = 1,
            ModeDistance = 2,
            ModeAbove = 3,
        };

        enum Deformation {
            DeformationNone = 0,
            DeformationCylinder = 1,
            DeformationSphere = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        CubeaddonOptions (bool init = true);
        virtual ~CubeaddonOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetTopNextKey ();
        void optionSetTopNextKeyInitiate (CompAction::CallBack init);
        void optionSetTopNextKeyTerminate (CompAction::CallBack term);
        void optionSetTopNextKeyNotify (ChangeNotify notify);

        CompAction & optionGetTopNextButton ();
        void optionSetTopNextButtonInitiate (CompAction::CallBack init);
        void optionSetTopNextButtonTerminate (CompAction::CallBack term);
        void optionSetTopNextButtonNotify (ChangeNotify notify);

        CompAction & optionGetTopPrevKey ();
        void optionSetTopPrevKeyInitiate (CompAction::CallBack init);
        void optionSetTopPrevKeyTerminate (CompAction::CallBack term);
        void optionSetTopPrevKeyNotify (ChangeNotify notify);

        CompAction & optionGetTopPrevButton ();
        void optionSetTopPrevButtonInitiate (CompAction::CallBack init);
        void optionSetTopPrevButtonTerminate (CompAction::CallBack term);
        void optionSetTopPrevButtonNotify (ChangeNotify notify);

        CompAction & optionGetBottomNextKey ();
        void optionSetBottomNextKeyInitiate (CompAction::CallBack init);
        void optionSetBottomNextKeyTerminate (CompAction::CallBack term);
        void optionSetBottomNextKeyNotify (ChangeNotify notify);

        CompAction & optionGetBottomNextButton ();
        void optionSetBottomNextButtonInitiate (CompAction::CallBack init);
        void optionSetBottomNextButtonTerminate (CompAction::CallBack term);
        void optionSetBottomNextButtonNotify (ChangeNotify notify);

        CompAction & optionGetBottomPrevKey ();
        void optionSetBottomPrevKeyInitiate (CompAction::CallBack init);
        void optionSetBottomPrevKeyTerminate (CompAction::CallBack term);
        void optionSetBottomPrevKeyNotify (ChangeNotify notify);

        CompAction & optionGetBottomPrevButton ();
        void optionSetBottomPrevButtonInitiate (CompAction::CallBack init);
        void optionSetBottomPrevButtonTerminate (CompAction::CallBack term);
        void optionSetBottomPrevButtonNotify (ChangeNotify notify);

        bool optionGetReflection ();
        void optionSetReflectionNotify (ChangeNotify notify);

        unsigned short * optionGetGroundColor1 ();
        unsigned short optionGetGroundColor1Red ();
        unsigned short optionGetGroundColor1Green ();
        unsigned short optionGetGroundColor1Blue ();
        unsigned short optionGetGroundColor1Alpha ();
        void optionSetGroundColor1Notify (ChangeNotify notify);

        unsigned short * optionGetGroundColor2 ();
        unsigned short optionGetGroundColor2Red ();
        unsigned short optionGetGroundColor2Green ();
        unsigned short optionGetGroundColor2Blue ();
        unsigned short optionGetGroundColor2Alpha ();
        void optionSetGroundColor2Notify (ChangeNotify notify);

        float optionGetGroundSize ();
        void optionSetGroundSizeNotify (ChangeNotify notify);

        float optionGetIntensity ();
        void optionSetIntensityNotify (ChangeNotify notify);

        bool optionGetAutoZoom ();
        void optionSetAutoZoomNotify (ChangeNotify notify);

        bool optionGetZoomManualOnly ();
        void optionSetZoomManualOnlyNotify (ChangeNotify notify);

        int optionGetMode ();
        void optionSetModeNotify (ChangeNotify notify);

        int optionGetDeformation ();
        void optionSetDeformationNotify (ChangeNotify notify);

        bool optionGetUnfoldDeformation ();
        void optionSetUnfoldDeformationNotify (ChangeNotify notify);

        bool optionGetCylinderManualOnly ();
        void optionSetCylinderManualOnlyNotify (ChangeNotify notify);

        bool optionGetDeformCaps ();
        void optionSetDeformCapsNotify (ChangeNotify notify);

        float optionGetSphereAspect ();
        void optionSetSphereAspectNotify (ChangeNotify notify);

        bool optionGetDrawTop ();
        void optionSetDrawTopNotify (ChangeNotify notify);

        bool optionGetDrawBottom ();
        void optionSetDrawBottomNotify (ChangeNotify notify);

        bool optionGetAdjustTop ();
        void optionSetAdjustTopNotify (ChangeNotify notify);

        bool optionGetAdjustBottom ();
        void optionSetAdjustBottomNotify (ChangeNotify notify);

        bool optionGetTopScale ();
        void optionSetTopScaleNotify (ChangeNotify notify);

        bool optionGetBottomScale ();
        void optionSetBottomScaleNotify (ChangeNotify notify);

        bool optionGetTopAspect ();
        void optionSetTopAspectNotify (ChangeNotify notify);

        bool optionGetBottomAspect ();
        void optionSetBottomAspectNotify (ChangeNotify notify);

        bool optionGetTopClamp ();
        void optionSetTopClampNotify (ChangeNotify notify);

        bool optionGetBottomClamp ();
        void optionSetBottomClampNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetTopImages ();
        void optionSetTopImagesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetBottomImages ();
        void optionSetBottomImagesNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
CubeaddonOptions::optionGetTopNextKey ()
{
    return mOptions[CubeaddonOptions::TopNextKey].value ().action ();
}

inline void
CubeaddonOptions::optionSetTopNextKeyInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::TopNextKey].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetTopNextKeyTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::TopNextKey].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetTopNextKeyNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopNextKey] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetTopNextButton ()
{
    return mOptions[CubeaddonOptions::TopNextButton].value ().action ();
}

inline void
CubeaddonOptions::optionSetTopNextButtonInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::TopNextButton].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetTopNextButtonTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::TopNextButton].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetTopNextButtonNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopNextButton] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetTopPrevKey ()
{
    return mOptions[CubeaddonOptions::TopPrevKey].value ().action ();
}

inline void
CubeaddonOptions::optionSetTopPrevKeyInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::TopPrevKey].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetTopPrevKeyTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::TopPrevKey].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetTopPrevKeyNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopPrevKey] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetTopPrevButton ()
{
    return mOptions[CubeaddonOptions::TopPrevButton].value ().action ();
}

inline void
CubeaddonOptions::optionSetTopPrevButtonInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::TopPrevButton].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetTopPrevButtonTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::TopPrevButton].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetTopPrevButtonNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopPrevButton] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetBottomNextKey ()
{
    return mOptions[CubeaddonOptions::BottomNextKey].value ().action ();
}

inline void
CubeaddonOptions::optionSetBottomNextKeyInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::BottomNextKey].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetBottomNextKeyTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::BottomNextKey].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetBottomNextKeyNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomNextKey] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetBottomNextButton ()
{
    return mOptions[CubeaddonOptions::BottomNextButton].value ().action ();
}

inline void
CubeaddonOptions::optionSetBottomNextButtonInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::BottomNextButton].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetBottomNextButtonTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::BottomNextButton].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetBottomNextButtonNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomNextButton] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetBottomPrevKey ()
{
    return mOptions[CubeaddonOptions::BottomPrevKey].value ().action ();
}

inline void
CubeaddonOptions::optionSetBottomPrevKeyInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::BottomPrevKey].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetBottomPrevKeyTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::BottomPrevKey].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetBottomPrevKeyNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomPrevKey] = notify;
}

inline CompAction &
CubeaddonOptions::optionGetBottomPrevButton ()
{
    return mOptions[CubeaddonOptions::BottomPrevButton].value ().action ();
}

inline void
CubeaddonOptions::optionSetBottomPrevButtonInitiate (CompAction::CallBack init)
{
    mOptions[CubeaddonOptions::BottomPrevButton].value ().action ().setInitiate (init);
}

inline void
CubeaddonOptions::optionSetBottomPrevButtonTerminate (CompAction::CallBack term)
{
    mOptions[CubeaddonOptions::BottomPrevButton].value ().action ().setTerminate (term);
}

inline void
CubeaddonOptions::optionSetBottomPrevButtonNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomPrevButton] = notify;
}

inline bool
CubeaddonOptions::optionGetReflection ()
{
    return mOptions[CubeaddonOptions::Reflection].value ().b ();
}

inline void
CubeaddonOptions::optionSetReflectionNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::Reflection] = notify;
}

inline unsigned short *
CubeaddonOptions::optionGetGroundColor1 ()
{
    return mOptions[CubeaddonOptions::GroundColor1].value ().c ();
}

inline unsigned short
CubeaddonOptions::optionGetGroundColor1Red ()
{
    return mOptions[CubeaddonOptions::GroundColor1].value ().c ()[0];
}

inline unsigned short
CubeaddonOptions::optionGetGroundColor1Green ()
{
    return mOptions[CubeaddonOptions::GroundColor1].value ().c ()[1];
}


inline unsigned short
CubeaddonOptions::optionGetGroundColor1Blue ()
{
    return mOptions[CubeaddonOptions::GroundColor1].value ().c ()[2];
}


inline unsigned short
CubeaddonOptions::optionGetGroundColor1Alpha ()
{
    return mOptions[CubeaddonOptions::GroundColor1].value ().c ()[3];
}


inline void
CubeaddonOptions::optionSetGroundColor1Notify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::GroundColor1] = notify;
}

inline unsigned short *
CubeaddonOptions::optionGetGroundColor2 ()
{
    return mOptions[CubeaddonOptions::GroundColor2].value ().c ();
}

inline unsigned short
CubeaddonOptions::optionGetGroundColor2Red ()
{
    return mOptions[CubeaddonOptions::GroundColor2].value ().c ()[0];
}

inline unsigned short
CubeaddonOptions::optionGetGroundColor2Green ()
{
    return mOptions[CubeaddonOptions::GroundColor2].value ().c ()[1];
}


inline unsigned short
CubeaddonOptions::optionGetGroundColor2Blue ()
{
    return mOptions[CubeaddonOptions::GroundColor2].value ().c ()[2];
}


inline unsigned short
CubeaddonOptions::optionGetGroundColor2Alpha ()
{
    return mOptions[CubeaddonOptions::GroundColor2].value ().c ()[3];
}


inline void
CubeaddonOptions::optionSetGroundColor2Notify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::GroundColor2] = notify;
}

inline float
CubeaddonOptions::optionGetGroundSize ()
{
    return mOptions[CubeaddonOptions::GroundSize].value ().f ();
}

inline void
CubeaddonOptions::optionSetGroundSizeNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::GroundSize] = notify;
}

inline float
CubeaddonOptions::optionGetIntensity ()
{
    return mOptions[CubeaddonOptions::Intensity].value ().f ();
}

inline void
CubeaddonOptions::optionSetIntensityNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::Intensity] = notify;
}

inline bool
CubeaddonOptions::optionGetAutoZoom ()
{
    return mOptions[CubeaddonOptions::AutoZoom].value ().b ();
}

inline void
CubeaddonOptions::optionSetAutoZoomNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::AutoZoom] = notify;
}

inline bool
CubeaddonOptions::optionGetZoomManualOnly ()
{
    return mOptions[CubeaddonOptions::ZoomManualOnly].value ().b ();
}

inline void
CubeaddonOptions::optionSetZoomManualOnlyNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::ZoomManualOnly] = notify;
}

inline int
CubeaddonOptions::optionGetMode ()
{
    return mOptions[CubeaddonOptions::Mode].value ().i ();
}

inline void
CubeaddonOptions::optionSetModeNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::Mode] = notify;
}

inline int
CubeaddonOptions::optionGetDeformation ()
{
    return mOptions[CubeaddonOptions::Deformation].value ().i ();
}

inline void
CubeaddonOptions::optionSetDeformationNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::Deformation] = notify;
}

inline bool
CubeaddonOptions::optionGetUnfoldDeformation ()
{
    return mOptions[CubeaddonOptions::UnfoldDeformation].value ().b ();
}

inline void
CubeaddonOptions::optionSetUnfoldDeformationNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::UnfoldDeformation] = notify;
}

inline bool
CubeaddonOptions::optionGetCylinderManualOnly ()
{
    return mOptions[CubeaddonOptions::CylinderManualOnly].value ().b ();
}

inline void
CubeaddonOptions::optionSetCylinderManualOnlyNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::CylinderManualOnly] = notify;
}

inline bool
CubeaddonOptions::optionGetDeformCaps ()
{
    return mOptions[CubeaddonOptions::DeformCaps].value ().b ();
}

inline void
CubeaddonOptions::optionSetDeformCapsNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::DeformCaps] = notify;
}

inline float
CubeaddonOptions::optionGetSphereAspect ()
{
    return mOptions[CubeaddonOptions::SphereAspect].value ().f ();
}

inline void
CubeaddonOptions::optionSetSphereAspectNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::SphereAspect] = notify;
}

inline bool
CubeaddonOptions::optionGetDrawTop ()
{
    return mOptions[CubeaddonOptions::DrawTop].value ().b ();
}

inline void
CubeaddonOptions::optionSetDrawTopNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::DrawTop] = notify;
}

inline bool
CubeaddonOptions::optionGetDrawBottom ()
{
    return mOptions[CubeaddonOptions::DrawBottom].value ().b ();
}

inline void
CubeaddonOptions::optionSetDrawBottomNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::DrawBottom] = notify;
}

inline bool
CubeaddonOptions::optionGetAdjustTop ()
{
    return mOptions[CubeaddonOptions::AdjustTop].value ().b ();
}

inline void
CubeaddonOptions::optionSetAdjustTopNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::AdjustTop] = notify;
}

inline bool
CubeaddonOptions::optionGetAdjustBottom ()
{
    return mOptions[CubeaddonOptions::AdjustBottom].value ().b ();
}

inline void
CubeaddonOptions::optionSetAdjustBottomNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::AdjustBottom] = notify;
}

inline bool
CubeaddonOptions::optionGetTopScale ()
{
    return mOptions[CubeaddonOptions::TopScale].value ().b ();
}

inline void
CubeaddonOptions::optionSetTopScaleNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopScale] = notify;
}

inline bool
CubeaddonOptions::optionGetBottomScale ()
{
    return mOptions[CubeaddonOptions::BottomScale].value ().b ();
}

inline void
CubeaddonOptions::optionSetBottomScaleNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomScale] = notify;
}

inline bool
CubeaddonOptions::optionGetTopAspect ()
{
    return mOptions[CubeaddonOptions::TopAspect].value ().b ();
}

inline void
CubeaddonOptions::optionSetTopAspectNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopAspect] = notify;
}

inline bool
CubeaddonOptions::optionGetBottomAspect ()
{
    return mOptions[CubeaddonOptions::BottomAspect].value ().b ();
}

inline void
CubeaddonOptions::optionSetBottomAspectNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomAspect] = notify;
}

inline bool
CubeaddonOptions::optionGetTopClamp ()
{
    return mOptions[CubeaddonOptions::TopClamp].value ().b ();
}

inline void
CubeaddonOptions::optionSetTopClampNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopClamp] = notify;
}

inline bool
CubeaddonOptions::optionGetBottomClamp ()
{
    return mOptions[CubeaddonOptions::BottomClamp].value ().b ();
}

inline void
CubeaddonOptions::optionSetBottomClampNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomClamp] = notify;
}

inline CompOption::Value::Vector &
CubeaddonOptions::optionGetTopImages ()
{
    return mOptions[CubeaddonOptions::TopImages].value ().list ();
}

inline void
CubeaddonOptions::optionSetTopImagesNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::TopImages] = notify;
}

inline CompOption::Value::Vector &
CubeaddonOptions::optionGetBottomImages ()
{
    return mOptions[CubeaddonOptions::BottomImages].value ().list ();
}

inline void
CubeaddonOptions::optionSetBottomImagesNotify (CubeaddonOptions::ChangeNotify notify)
{
    mNotify[CubeaddonOptions::BottomImages] = notify;
}



#endif
