/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _DECOR_OPTIONS_H
#define _DECOR_OPTIONS_H

#include <core/core.h>

class DecorOptions : public CompOption::Class {
    public:
        enum Options {
            ActiveShadowRadius,
            ActiveShadowOpacity,
            ActiveShadowColor,
            ActiveShadowXOffset,
            ActiveShadowYOffset,
            InactiveShadowRadius,
            InactiveShadowOpacity,
            InactiveShadowColor,
            InactiveShadowXOffset,
            InactiveShadowYOffset,
            Command,
            Mipmap,
            DecorationMatch,
            ShadowMatch,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        DecorOptions (bool init = true);
        virtual ~DecorOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        float optionGetActiveShadowRadius ();
        void optionSetActiveShadowRadiusNotify (ChangeNotify notify);

        float optionGetActiveShadowOpacity ();
        void optionSetActiveShadowOpacityNotify (ChangeNotify notify);

        unsigned short * optionGetActiveShadowColor ();
        unsigned short optionGetActiveShadowColorRed ();
        unsigned short optionGetActiveShadowColorGreen ();
        unsigned short optionGetActiveShadowColorBlue ();
        unsigned short optionGetActiveShadowColorAlpha ();
        void optionSetActiveShadowColorNotify (ChangeNotify notify);

        int optionGetActiveShadowXOffset ();
        void optionSetActiveShadowXOffsetNotify (ChangeNotify notify);

        int optionGetActiveShadowYOffset ();
        void optionSetActiveShadowYOffsetNotify (ChangeNotify notify);

        float optionGetInactiveShadowRadius ();
        void optionSetInactiveShadowRadiusNotify (ChangeNotify notify);

        float optionGetInactiveShadowOpacity ();
        void optionSetInactiveShadowOpacityNotify (ChangeNotify notify);

        unsigned short * optionGetInactiveShadowColor ();
        unsigned short optionGetInactiveShadowColorRed ();
        unsigned short optionGetInactiveShadowColorGreen ();
        unsigned short optionGetInactiveShadowColorBlue ();
        unsigned short optionGetInactiveShadowColorAlpha ();
        void optionSetInactiveShadowColorNotify (ChangeNotify notify);

        int optionGetInactiveShadowXOffset ();
        void optionSetInactiveShadowXOffsetNotify (ChangeNotify notify);

        int optionGetInactiveShadowYOffset ();
        void optionSetInactiveShadowYOffsetNotify (ChangeNotify notify);

        CompString optionGetCommand ();
        void optionSetCommandNotify (ChangeNotify notify);

        bool optionGetMipmap ();
        void optionSetMipmapNotify (ChangeNotify notify);

        CompMatch & optionGetDecorationMatch ();
        void optionSetDecorationMatchNotify (ChangeNotify notify);

        CompMatch & optionGetShadowMatch ();
        void optionSetShadowMatchNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline float
DecorOptions::optionGetActiveShadowRadius ()
{
    return mOptions[DecorOptions::ActiveShadowRadius].value ().f ();
}

inline void
DecorOptions::optionSetActiveShadowRadiusNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::ActiveShadowRadius] = notify;
}

inline float
DecorOptions::optionGetActiveShadowOpacity ()
{
    return mOptions[DecorOptions::ActiveShadowOpacity].value ().f ();
}

inline void
DecorOptions::optionSetActiveShadowOpacityNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::ActiveShadowOpacity] = notify;
}

inline unsigned short *
DecorOptions::optionGetActiveShadowColor ()
{
    return mOptions[DecorOptions::ActiveShadowColor].value ().c ();
}

inline unsigned short
DecorOptions::optionGetActiveShadowColorRed ()
{
    return mOptions[DecorOptions::ActiveShadowColor].value ().c ()[0];
}

inline unsigned short
DecorOptions::optionGetActiveShadowColorGreen ()
{
    return mOptions[DecorOptions::ActiveShadowColor].value ().c ()[1];
}


inline unsigned short
DecorOptions::optionGetActiveShadowColorBlue ()
{
    return mOptions[DecorOptions::ActiveShadowColor].value ().c ()[2];
}


inline unsigned short
DecorOptions::optionGetActiveShadowColorAlpha ()
{
    return mOptions[DecorOptions::ActiveShadowColor].value ().c ()[3];
}


inline void
DecorOptions::optionSetActiveShadowColorNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::ActiveShadowColor] = notify;
}

inline int
DecorOptions::optionGetActiveShadowXOffset ()
{
    return mOptions[DecorOptions::ActiveShadowXOffset].value ().i ();
}

inline void
DecorOptions::optionSetActiveShadowXOffsetNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::ActiveShadowXOffset] = notify;
}

inline int
DecorOptions::optionGetActiveShadowYOffset ()
{
    return mOptions[DecorOptions::ActiveShadowYOffset].value ().i ();
}

inline void
DecorOptions::optionSetActiveShadowYOffsetNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::ActiveShadowYOffset] = notify;
}

inline float
DecorOptions::optionGetInactiveShadowRadius ()
{
    return mOptions[DecorOptions::InactiveShadowRadius].value ().f ();
}

inline void
DecorOptions::optionSetInactiveShadowRadiusNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::InactiveShadowRadius] = notify;
}

inline float
DecorOptions::optionGetInactiveShadowOpacity ()
{
    return mOptions[DecorOptions::InactiveShadowOpacity].value ().f ();
}

inline void
DecorOptions::optionSetInactiveShadowOpacityNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::InactiveShadowOpacity] = notify;
}

inline unsigned short *
DecorOptions::optionGetInactiveShadowColor ()
{
    return mOptions[DecorOptions::InactiveShadowColor].value ().c ();
}

inline unsigned short
DecorOptions::optionGetInactiveShadowColorRed ()
{
    return mOptions[DecorOptions::InactiveShadowColor].value ().c ()[0];
}

inline unsigned short
DecorOptions::optionGetInactiveShadowColorGreen ()
{
    return mOptions[DecorOptions::InactiveShadowColor].value ().c ()[1];
}


inline unsigned short
DecorOptions::optionGetInactiveShadowColorBlue ()
{
    return mOptions[DecorOptions::InactiveShadowColor].value ().c ()[2];
}


inline unsigned short
DecorOptions::optionGetInactiveShadowColorAlpha ()
{
    return mOptions[DecorOptions::InactiveShadowColor].value ().c ()[3];
}


inline void
DecorOptions::optionSetInactiveShadowColorNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::InactiveShadowColor] = notify;
}

inline int
DecorOptions::optionGetInactiveShadowXOffset ()
{
    return mOptions[DecorOptions::InactiveShadowXOffset].value ().i ();
}

inline void
DecorOptions::optionSetInactiveShadowXOffsetNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::InactiveShadowXOffset] = notify;
}

inline int
DecorOptions::optionGetInactiveShadowYOffset ()
{
    return mOptions[DecorOptions::InactiveShadowYOffset].value ().i ();
}

inline void
DecorOptions::optionSetInactiveShadowYOffsetNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::InactiveShadowYOffset] = notify;
}

inline CompString
DecorOptions::optionGetCommand ()
{
    return mOptions[DecorOptions::Command].value ().s ();
}

inline void
DecorOptions::optionSetCommandNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::Command] = notify;
}

inline bool
DecorOptions::optionGetMipmap ()
{
    return mOptions[DecorOptions::Mipmap].value ().b ();
}

inline void
DecorOptions::optionSetMipmapNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::Mipmap] = notify;
}

inline CompMatch &
DecorOptions::optionGetDecorationMatch ()
{
    return mOptions[DecorOptions::DecorationMatch].value ().match ();
}

inline void
DecorOptions::optionSetDecorationMatchNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::DecorationMatch] = notify;
}

inline CompMatch &
DecorOptions::optionGetShadowMatch ()
{
    return mOptions[DecorOptions::ShadowMatch].value ().match ();
}

inline void
DecorOptions::optionSetShadowMatchNotify (DecorOptions::ChangeNotify notify)
{
    mNotify[DecorOptions::ShadowMatch] = notify;
}



#endif
