/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _EXPO_OPTIONS_H
#define _EXPO_OPTIONS_H

#include <core/core.h>

class ExpoOptions : public CompOption::Class {
    public:
        enum Options {
            ExpoKey,
            ExpoButton,
            ExpoEdge,
            DoubleClickTime,
            DndButton,
            ExitButton,
            NextVpButton,
            PrevVpButton,
            ZoomTime,
            ExpoImmediateMove,
            ExpoAnimation,
            Deform,
            Curve,
            XOffset,
            YOffset,
            YBottomOffset,
            Distance,
            VpDistance,
            AspectRatio,
            HideDocks,
            Mipmaps,
            MultioutputMode,
            VpBrightness,
            VpSaturation,
            SelectedColor,
            Reflection,
            GroundColor1,
            GroundColor2,
            GroundSize,
            ScaleFactor,
            OptionNum
        };

        enum ExpoAnimation {
            ExpoAnimationZoom = 0,
            ExpoAnimationFadeZoom = 1,
            ExpoAnimationVortex = 2,
            ExpoAnimationNone = 3,
        };

        enum Deform {
            DeformNone = 0,
            DeformTilt = 1,
            DeformCurve = 2,
        };

        enum MultioutputMode {
            MultioutputModeOneBigWall = 0,
            MultioutputModeOneWallPerOutput = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ExpoOptions (bool init = true);
        virtual ~ExpoOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetExpoKey ();
        void optionSetExpoKeyInitiate (CompAction::CallBack init);
        void optionSetExpoKeyTerminate (CompAction::CallBack term);
        void optionSetExpoKeyNotify (ChangeNotify notify);

        CompAction & optionGetExpoButton ();
        void optionSetExpoButtonInitiate (CompAction::CallBack init);
        void optionSetExpoButtonTerminate (CompAction::CallBack term);
        void optionSetExpoButtonNotify (ChangeNotify notify);

        CompAction & optionGetExpoEdge ();
        void optionSetExpoEdgeInitiate (CompAction::CallBack init);
        void optionSetExpoEdgeTerminate (CompAction::CallBack term);
        void optionSetExpoEdgeNotify (ChangeNotify notify);

        int optionGetDoubleClickTime ();
        void optionSetDoubleClickTimeNotify (ChangeNotify notify);

        CompAction & optionGetDndButton ();
        void optionSetDndButtonInitiate (CompAction::CallBack init);
        void optionSetDndButtonTerminate (CompAction::CallBack term);
        void optionSetDndButtonNotify (ChangeNotify notify);

        CompAction & optionGetExitButton ();
        void optionSetExitButtonInitiate (CompAction::CallBack init);
        void optionSetExitButtonTerminate (CompAction::CallBack term);
        void optionSetExitButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextVpButton ();
        void optionSetNextVpButtonInitiate (CompAction::CallBack init);
        void optionSetNextVpButtonTerminate (CompAction::CallBack term);
        void optionSetNextVpButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevVpButton ();
        void optionSetPrevVpButtonInitiate (CompAction::CallBack init);
        void optionSetPrevVpButtonTerminate (CompAction::CallBack term);
        void optionSetPrevVpButtonNotify (ChangeNotify notify);

        float optionGetZoomTime ();
        void optionSetZoomTimeNotify (ChangeNotify notify);

        bool optionGetExpoImmediateMove ();
        void optionSetExpoImmediateMoveNotify (ChangeNotify notify);

        int optionGetExpoAnimation ();
        void optionSetExpoAnimationNotify (ChangeNotify notify);

        int optionGetDeform ();
        void optionSetDeformNotify (ChangeNotify notify);

        float optionGetCurve ();
        void optionSetCurveNotify (ChangeNotify notify);

        int optionGetXOffset ();
        void optionSetXOffsetNotify (ChangeNotify notify);

        int optionGetYOffset ();
        void optionSetYOffsetNotify (ChangeNotify notify);

        int optionGetYBottomOffset ();
        void optionSetYBottomOffsetNotify (ChangeNotify notify);

        float optionGetDistance ();
        void optionSetDistanceNotify (ChangeNotify notify);

        float optionGetVpDistance ();
        void optionSetVpDistanceNotify (ChangeNotify notify);

        float optionGetAspectRatio ();
        void optionSetAspectRatioNotify (ChangeNotify notify);

        bool optionGetHideDocks ();
        void optionSetHideDocksNotify (ChangeNotify notify);

        bool optionGetMipmaps ();
        void optionSetMipmapsNotify (ChangeNotify notify);

        int optionGetMultioutputMode ();
        void optionSetMultioutputModeNotify (ChangeNotify notify);

        float optionGetVpBrightness ();
        void optionSetVpBrightnessNotify (ChangeNotify notify);

        float optionGetVpSaturation ();
        void optionSetVpSaturationNotify (ChangeNotify notify);

        unsigned short * optionGetSelectedColor ();
        unsigned short optionGetSelectedColorRed ();
        unsigned short optionGetSelectedColorGreen ();
        unsigned short optionGetSelectedColorBlue ();
        unsigned short optionGetSelectedColorAlpha ();
        void optionSetSelectedColorNotify (ChangeNotify notify);

        bool optionGetReflection ();
        void optionSetReflectionNotify (ChangeNotify notify);

        unsigned short * optionGetGroundColor1 ();
        unsigned short optionGetGroundColor1Red ();
        unsigned short optionGetGroundColor1Green ();
        unsigned short optionGetGroundColor1Blue ();
        unsigned short optionGetGroundColor1Alpha ();
        void optionSetGroundColor1Notify (ChangeNotify notify);

        unsigned short * optionGetGroundColor2 ();
        unsigned short optionGetGroundColor2Red ();
        unsigned short optionGetGroundColor2Green ();
        unsigned short optionGetGroundColor2Blue ();
        unsigned short optionGetGroundColor2Alpha ();
        void optionSetGroundColor2Notify (ChangeNotify notify);

        float optionGetGroundSize ();
        void optionSetGroundSizeNotify (ChangeNotify notify);

        float optionGetScaleFactor ();
        void optionSetScaleFactorNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
ExpoOptions::optionGetExpoKey ()
{
    return mOptions[ExpoOptions::ExpoKey].value ().action ();
}

inline void
ExpoOptions::optionSetExpoKeyInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::ExpoKey].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetExpoKeyTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::ExpoKey].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetExpoKeyNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ExpoKey] = notify;
}

inline CompAction &
ExpoOptions::optionGetExpoButton ()
{
    return mOptions[ExpoOptions::ExpoButton].value ().action ();
}

inline void
ExpoOptions::optionSetExpoButtonInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::ExpoButton].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetExpoButtonTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::ExpoButton].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetExpoButtonNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ExpoButton] = notify;
}

inline CompAction &
ExpoOptions::optionGetExpoEdge ()
{
    return mOptions[ExpoOptions::ExpoEdge].value ().action ();
}

inline void
ExpoOptions::optionSetExpoEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::ExpoEdge].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetExpoEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::ExpoEdge].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetExpoEdgeNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ExpoEdge] = notify;
}

inline int
ExpoOptions::optionGetDoubleClickTime ()
{
    return mOptions[ExpoOptions::DoubleClickTime].value ().i ();
}

inline void
ExpoOptions::optionSetDoubleClickTimeNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::DoubleClickTime] = notify;
}

inline CompAction &
ExpoOptions::optionGetDndButton ()
{
    return mOptions[ExpoOptions::DndButton].value ().action ();
}

inline void
ExpoOptions::optionSetDndButtonInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::DndButton].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetDndButtonTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::DndButton].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetDndButtonNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::DndButton] = notify;
}

inline CompAction &
ExpoOptions::optionGetExitButton ()
{
    return mOptions[ExpoOptions::ExitButton].value ().action ();
}

inline void
ExpoOptions::optionSetExitButtonInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::ExitButton].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetExitButtonTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::ExitButton].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetExitButtonNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ExitButton] = notify;
}

inline CompAction &
ExpoOptions::optionGetNextVpButton ()
{
    return mOptions[ExpoOptions::NextVpButton].value ().action ();
}

inline void
ExpoOptions::optionSetNextVpButtonInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::NextVpButton].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetNextVpButtonTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::NextVpButton].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetNextVpButtonNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::NextVpButton] = notify;
}

inline CompAction &
ExpoOptions::optionGetPrevVpButton ()
{
    return mOptions[ExpoOptions::PrevVpButton].value ().action ();
}

inline void
ExpoOptions::optionSetPrevVpButtonInitiate (CompAction::CallBack init)
{
    mOptions[ExpoOptions::PrevVpButton].value ().action ().setInitiate (init);
}

inline void
ExpoOptions::optionSetPrevVpButtonTerminate (CompAction::CallBack term)
{
    mOptions[ExpoOptions::PrevVpButton].value ().action ().setTerminate (term);
}

inline void
ExpoOptions::optionSetPrevVpButtonNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::PrevVpButton] = notify;
}

inline float
ExpoOptions::optionGetZoomTime ()
{
    return mOptions[ExpoOptions::ZoomTime].value ().f ();
}

inline void
ExpoOptions::optionSetZoomTimeNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ZoomTime] = notify;
}

inline bool
ExpoOptions::optionGetExpoImmediateMove ()
{
    return mOptions[ExpoOptions::ExpoImmediateMove].value ().b ();
}

inline void
ExpoOptions::optionSetExpoImmediateMoveNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ExpoImmediateMove] = notify;
}

inline int
ExpoOptions::optionGetExpoAnimation ()
{
    return mOptions[ExpoOptions::ExpoAnimation].value ().i ();
}

inline void
ExpoOptions::optionSetExpoAnimationNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ExpoAnimation] = notify;
}

inline int
ExpoOptions::optionGetDeform ()
{
    return mOptions[ExpoOptions::Deform].value ().i ();
}

inline void
ExpoOptions::optionSetDeformNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::Deform] = notify;
}

inline float
ExpoOptions::optionGetCurve ()
{
    return mOptions[ExpoOptions::Curve].value ().f ();
}

inline void
ExpoOptions::optionSetCurveNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::Curve] = notify;
}

inline int
ExpoOptions::optionGetXOffset ()
{
    return mOptions[ExpoOptions::XOffset].value ().i ();
}

inline void
ExpoOptions::optionSetXOffsetNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::XOffset] = notify;
}

inline int
ExpoOptions::optionGetYOffset ()
{
    return mOptions[ExpoOptions::YOffset].value ().i ();
}

inline void
ExpoOptions::optionSetYOffsetNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::YOffset] = notify;
}

inline int
ExpoOptions::optionGetYBottomOffset ()
{
    return mOptions[ExpoOptions::YBottomOffset].value ().i ();
}

inline void
ExpoOptions::optionSetYBottomOffsetNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::YBottomOffset] = notify;
}

inline float
ExpoOptions::optionGetDistance ()
{
    return mOptions[ExpoOptions::Distance].value ().f ();
}

inline void
ExpoOptions::optionSetDistanceNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::Distance] = notify;
}

inline float
ExpoOptions::optionGetVpDistance ()
{
    return mOptions[ExpoOptions::VpDistance].value ().f ();
}

inline void
ExpoOptions::optionSetVpDistanceNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::VpDistance] = notify;
}

inline float
ExpoOptions::optionGetAspectRatio ()
{
    return mOptions[ExpoOptions::AspectRatio].value ().f ();
}

inline void
ExpoOptions::optionSetAspectRatioNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::AspectRatio] = notify;
}

inline bool
ExpoOptions::optionGetHideDocks ()
{
    return mOptions[ExpoOptions::HideDocks].value ().b ();
}

inline void
ExpoOptions::optionSetHideDocksNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::HideDocks] = notify;
}

inline bool
ExpoOptions::optionGetMipmaps ()
{
    return mOptions[ExpoOptions::Mipmaps].value ().b ();
}

inline void
ExpoOptions::optionSetMipmapsNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::Mipmaps] = notify;
}

inline int
ExpoOptions::optionGetMultioutputMode ()
{
    return mOptions[ExpoOptions::MultioutputMode].value ().i ();
}

inline void
ExpoOptions::optionSetMultioutputModeNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::MultioutputMode] = notify;
}

inline float
ExpoOptions::optionGetVpBrightness ()
{
    return mOptions[ExpoOptions::VpBrightness].value ().f ();
}

inline void
ExpoOptions::optionSetVpBrightnessNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::VpBrightness] = notify;
}

inline float
ExpoOptions::optionGetVpSaturation ()
{
    return mOptions[ExpoOptions::VpSaturation].value ().f ();
}

inline void
ExpoOptions::optionSetVpSaturationNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::VpSaturation] = notify;
}

inline unsigned short *
ExpoOptions::optionGetSelectedColor ()
{
    return mOptions[ExpoOptions::SelectedColor].value ().c ();
}

inline unsigned short
ExpoOptions::optionGetSelectedColorRed ()
{
    return mOptions[ExpoOptions::SelectedColor].value ().c ()[0];
}

inline unsigned short
ExpoOptions::optionGetSelectedColorGreen ()
{
    return mOptions[ExpoOptions::SelectedColor].value ().c ()[1];
}


inline unsigned short
ExpoOptions::optionGetSelectedColorBlue ()
{
    return mOptions[ExpoOptions::SelectedColor].value ().c ()[2];
}


inline unsigned short
ExpoOptions::optionGetSelectedColorAlpha ()
{
    return mOptions[ExpoOptions::SelectedColor].value ().c ()[3];
}


inline void
ExpoOptions::optionSetSelectedColorNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::SelectedColor] = notify;
}

inline bool
ExpoOptions::optionGetReflection ()
{
    return mOptions[ExpoOptions::Reflection].value ().b ();
}

inline void
ExpoOptions::optionSetReflectionNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::Reflection] = notify;
}

inline unsigned short *
ExpoOptions::optionGetGroundColor1 ()
{
    return mOptions[ExpoOptions::GroundColor1].value ().c ();
}

inline unsigned short
ExpoOptions::optionGetGroundColor1Red ()
{
    return mOptions[ExpoOptions::GroundColor1].value ().c ()[0];
}

inline unsigned short
ExpoOptions::optionGetGroundColor1Green ()
{
    return mOptions[ExpoOptions::GroundColor1].value ().c ()[1];
}


inline unsigned short
ExpoOptions::optionGetGroundColor1Blue ()
{
    return mOptions[ExpoOptions::GroundColor1].value ().c ()[2];
}


inline unsigned short
ExpoOptions::optionGetGroundColor1Alpha ()
{
    return mOptions[ExpoOptions::GroundColor1].value ().c ()[3];
}


inline void
ExpoOptions::optionSetGroundColor1Notify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::GroundColor1] = notify;
}

inline unsigned short *
ExpoOptions::optionGetGroundColor2 ()
{
    return mOptions[ExpoOptions::GroundColor2].value ().c ();
}

inline unsigned short
ExpoOptions::optionGetGroundColor2Red ()
{
    return mOptions[ExpoOptions::GroundColor2].value ().c ()[0];
}

inline unsigned short
ExpoOptions::optionGetGroundColor2Green ()
{
    return mOptions[ExpoOptions::GroundColor2].value ().c ()[1];
}


inline unsigned short
ExpoOptions::optionGetGroundColor2Blue ()
{
    return mOptions[ExpoOptions::GroundColor2].value ().c ()[2];
}


inline unsigned short
ExpoOptions::optionGetGroundColor2Alpha ()
{
    return mOptions[ExpoOptions::GroundColor2].value ().c ()[3];
}


inline void
ExpoOptions::optionSetGroundColor2Notify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::GroundColor2] = notify;
}

inline float
ExpoOptions::optionGetGroundSize ()
{
    return mOptions[ExpoOptions::GroundSize].value ().f ();
}

inline void
ExpoOptions::optionSetGroundSizeNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::GroundSize] = notify;
}

inline float
ExpoOptions::optionGetScaleFactor ()
{
    return mOptions[ExpoOptions::ScaleFactor].value ().f ();
}

inline void
ExpoOptions::optionSetScaleFactorNotify (ExpoOptions::ChangeNotify notify)
{
    mNotify[ExpoOptions::ScaleFactor] = notify;
}



#endif
