/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _EXTRAWM_OPTIONS_H
#define _EXTRAWM_OPTIONS_H

#include <core/core.h>

class ExtrawmOptions : public CompOption::Class {
    public:
        enum Options {
            Activate,
            ToggleRedirectKey,
            ToggleFullscreenKey,
            ToggleAlwaysOnTopKey,
            ToggleStickyKey,
            ActivateDemandsAttentionKey,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ExtrawmOptions (bool init = true);
        virtual ~ExtrawmOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetActivate ();
        void optionSetActivateInitiate (CompAction::CallBack init);
        void optionSetActivateTerminate (CompAction::CallBack term);
        void optionSetActivateNotify (ChangeNotify notify);

        CompAction & optionGetToggleRedirectKey ();
        void optionSetToggleRedirectKeyInitiate (CompAction::CallBack init);
        void optionSetToggleRedirectKeyTerminate (CompAction::CallBack term);
        void optionSetToggleRedirectKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleFullscreenKey ();
        void optionSetToggleFullscreenKeyInitiate (CompAction::CallBack init);
        void optionSetToggleFullscreenKeyTerminate (CompAction::CallBack term);
        void optionSetToggleFullscreenKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleAlwaysOnTopKey ();
        void optionSetToggleAlwaysOnTopKeyInitiate (CompAction::CallBack init);
        void optionSetToggleAlwaysOnTopKeyTerminate (CompAction::CallBack term);
        void optionSetToggleAlwaysOnTopKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleStickyKey ();
        void optionSetToggleStickyKeyInitiate (CompAction::CallBack init);
        void optionSetToggleStickyKeyTerminate (CompAction::CallBack term);
        void optionSetToggleStickyKeyNotify (ChangeNotify notify);

        CompAction & optionGetActivateDemandsAttentionKey ();
        void optionSetActivateDemandsAttentionKeyInitiate (CompAction::CallBack init);
        void optionSetActivateDemandsAttentionKeyTerminate (CompAction::CallBack term);
        void optionSetActivateDemandsAttentionKeyNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
ExtrawmOptions::optionGetActivate ()
{
    return mOptions[ExtrawmOptions::Activate].value ().action ();
}

inline void
ExtrawmOptions::optionSetActivateInitiate (CompAction::CallBack init)
{
    mOptions[ExtrawmOptions::Activate].value ().action ().setInitiate (init);
}

inline void
ExtrawmOptions::optionSetActivateTerminate (CompAction::CallBack term)
{
    mOptions[ExtrawmOptions::Activate].value ().action ().setTerminate (term);
}

inline void
ExtrawmOptions::optionSetActivateNotify (ExtrawmOptions::ChangeNotify notify)
{
    mNotify[ExtrawmOptions::Activate] = notify;
}

inline CompAction &
ExtrawmOptions::optionGetToggleRedirectKey ()
{
    return mOptions[ExtrawmOptions::ToggleRedirectKey].value ().action ();
}

inline void
ExtrawmOptions::optionSetToggleRedirectKeyInitiate (CompAction::CallBack init)
{
    mOptions[ExtrawmOptions::ToggleRedirectKey].value ().action ().setInitiate (init);
}

inline void
ExtrawmOptions::optionSetToggleRedirectKeyTerminate (CompAction::CallBack term)
{
    mOptions[ExtrawmOptions::ToggleRedirectKey].value ().action ().setTerminate (term);
}

inline void
ExtrawmOptions::optionSetToggleRedirectKeyNotify (ExtrawmOptions::ChangeNotify notify)
{
    mNotify[ExtrawmOptions::ToggleRedirectKey] = notify;
}

inline CompAction &
ExtrawmOptions::optionGetToggleFullscreenKey ()
{
    return mOptions[ExtrawmOptions::ToggleFullscreenKey].value ().action ();
}

inline void
ExtrawmOptions::optionSetToggleFullscreenKeyInitiate (CompAction::CallBack init)
{
    mOptions[ExtrawmOptions::ToggleFullscreenKey].value ().action ().setInitiate (init);
}

inline void
ExtrawmOptions::optionSetToggleFullscreenKeyTerminate (CompAction::CallBack term)
{
    mOptions[ExtrawmOptions::ToggleFullscreenKey].value ().action ().setTerminate (term);
}

inline void
ExtrawmOptions::optionSetToggleFullscreenKeyNotify (ExtrawmOptions::ChangeNotify notify)
{
    mNotify[ExtrawmOptions::ToggleFullscreenKey] = notify;
}

inline CompAction &
ExtrawmOptions::optionGetToggleAlwaysOnTopKey ()
{
    return mOptions[ExtrawmOptions::ToggleAlwaysOnTopKey].value ().action ();
}

inline void
ExtrawmOptions::optionSetToggleAlwaysOnTopKeyInitiate (CompAction::CallBack init)
{
    mOptions[ExtrawmOptions::ToggleAlwaysOnTopKey].value ().action ().setInitiate (init);
}

inline void
ExtrawmOptions::optionSetToggleAlwaysOnTopKeyTerminate (CompAction::CallBack term)
{
    mOptions[ExtrawmOptions::ToggleAlwaysOnTopKey].value ().action ().setTerminate (term);
}

inline void
ExtrawmOptions::optionSetToggleAlwaysOnTopKeyNotify (ExtrawmOptions::ChangeNotify notify)
{
    mNotify[ExtrawmOptions::ToggleAlwaysOnTopKey] = notify;
}

inline CompAction &
ExtrawmOptions::optionGetToggleStickyKey ()
{
    return mOptions[ExtrawmOptions::ToggleStickyKey].value ().action ();
}

inline void
ExtrawmOptions::optionSetToggleStickyKeyInitiate (CompAction::CallBack init)
{
    mOptions[ExtrawmOptions::ToggleStickyKey].value ().action ().setInitiate (init);
}

inline void
ExtrawmOptions::optionSetToggleStickyKeyTerminate (CompAction::CallBack term)
{
    mOptions[ExtrawmOptions::ToggleStickyKey].value ().action ().setTerminate (term);
}

inline void
ExtrawmOptions::optionSetToggleStickyKeyNotify (ExtrawmOptions::ChangeNotify notify)
{
    mNotify[ExtrawmOptions::ToggleStickyKey] = notify;
}

inline CompAction &
ExtrawmOptions::optionGetActivateDemandsAttentionKey ()
{
    return mOptions[ExtrawmOptions::ActivateDemandsAttentionKey].value ().action ();
}

inline void
ExtrawmOptions::optionSetActivateDemandsAttentionKeyInitiate (CompAction::CallBack init)
{
    mOptions[ExtrawmOptions::ActivateDemandsAttentionKey].value ().action ().setInitiate (init);
}

inline void
ExtrawmOptions::optionSetActivateDemandsAttentionKeyTerminate (CompAction::CallBack term)
{
    mOptions[ExtrawmOptions::ActivateDemandsAttentionKey].value ().action ().setTerminate (term);
}

inline void
ExtrawmOptions::optionSetActivateDemandsAttentionKeyNotify (ExtrawmOptions::ChangeNotify notify)
{
    mNotify[ExtrawmOptions::ActivateDemandsAttentionKey] = notify;
}



#endif
