/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _FADE_OPTIONS_H
#define _FADE_OPTIONS_H

#include <core/core.h>

class FadeOptions : public CompOption::Class {
    public:
        enum Options {
            FadeMode,
            FadeSpeed,
            FadeTime,
            WindowMatch,
            VisualBell,
            FullscreenVisualBell,
            DimUnresponsive,
            UnresponsiveBrightness,
            UnresponsiveSaturation,
            OptionNum
        };

        enum FadeMode {
            FadeModeConstantSpeed = 0,
            FadeModeConstantTime = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        FadeOptions (bool init = true);
        virtual ~FadeOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        int optionGetFadeMode ();
        void optionSetFadeModeNotify (ChangeNotify notify);

        float optionGetFadeSpeed ();
        void optionSetFadeSpeedNotify (ChangeNotify notify);

        int optionGetFadeTime ();
        void optionSetFadeTimeNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        CompAction & optionGetVisualBell ();
        void optionSetVisualBellInitiate (CompAction::CallBack init);
        void optionSetVisualBellTerminate (CompAction::CallBack term);
        void optionSetVisualBellNotify (ChangeNotify notify);

        bool optionGetFullscreenVisualBell ();
        void optionSetFullscreenVisualBellNotify (ChangeNotify notify);

        bool optionGetDimUnresponsive ();
        void optionSetDimUnresponsiveNotify (ChangeNotify notify);

        int optionGetUnresponsiveBrightness ();
        void optionSetUnresponsiveBrightnessNotify (ChangeNotify notify);

        int optionGetUnresponsiveSaturation ();
        void optionSetUnresponsiveSaturationNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline int
FadeOptions::optionGetFadeMode ()
{
    return mOptions[FadeOptions::FadeMode].value ().i ();
}

inline void
FadeOptions::optionSetFadeModeNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::FadeMode] = notify;
}

inline float
FadeOptions::optionGetFadeSpeed ()
{
    return mOptions[FadeOptions::FadeSpeed].value ().f ();
}

inline void
FadeOptions::optionSetFadeSpeedNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::FadeSpeed] = notify;
}

inline int
FadeOptions::optionGetFadeTime ()
{
    return mOptions[FadeOptions::FadeTime].value ().i ();
}

inline void
FadeOptions::optionSetFadeTimeNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::FadeTime] = notify;
}

inline CompMatch &
FadeOptions::optionGetWindowMatch ()
{
    return mOptions[FadeOptions::WindowMatch].value ().match ();
}

inline void
FadeOptions::optionSetWindowMatchNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::WindowMatch] = notify;
}

inline CompAction &
FadeOptions::optionGetVisualBell ()
{
    return mOptions[FadeOptions::VisualBell].value ().action ();
}

inline void
FadeOptions::optionSetVisualBellInitiate (CompAction::CallBack init)
{
    mOptions[FadeOptions::VisualBell].value ().action ().setInitiate (init);
}

inline void
FadeOptions::optionSetVisualBellTerminate (CompAction::CallBack term)
{
    mOptions[FadeOptions::VisualBell].value ().action ().setTerminate (term);
}

inline void
FadeOptions::optionSetVisualBellNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::VisualBell] = notify;
}

inline bool
FadeOptions::optionGetFullscreenVisualBell ()
{
    return mOptions[FadeOptions::FullscreenVisualBell].value ().b ();
}

inline void
FadeOptions::optionSetFullscreenVisualBellNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::FullscreenVisualBell] = notify;
}

inline bool
FadeOptions::optionGetDimUnresponsive ()
{
    return mOptions[FadeOptions::DimUnresponsive].value ().b ();
}

inline void
FadeOptions::optionSetDimUnresponsiveNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::DimUnresponsive] = notify;
}

inline int
FadeOptions::optionGetUnresponsiveBrightness ()
{
    return mOptions[FadeOptions::UnresponsiveBrightness].value ().i ();
}

inline void
FadeOptions::optionSetUnresponsiveBrightnessNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::UnresponsiveBrightness] = notify;
}

inline int
FadeOptions::optionGetUnresponsiveSaturation ()
{
    return mOptions[FadeOptions::UnresponsiveSaturation].value ().i ();
}

inline void
FadeOptions::optionSetUnresponsiveSaturationNotify (FadeOptions::ChangeNotify notify)
{
    mNotify[FadeOptions::UnresponsiveSaturation] = notify;
}



#endif
