/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _FIREPAINT_OPTIONS_H
#define _FIREPAINT_OPTIONS_H

#include <core/core.h>

class FirepaintOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateKey,
            InitiateButton,
            ClearKey,
            ClearButton,
            BgBrightness,
            AddParticle,
            NumParticles,
            FireSize,
            FireSlowdown,
            FireLife,
            FireColor,
            FireMystical,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        FirepaintOptions (bool init = true);
        virtual ~FirepaintOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetClearKey ();
        void optionSetClearKeyInitiate (CompAction::CallBack init);
        void optionSetClearKeyTerminate (CompAction::CallBack term);
        void optionSetClearKeyNotify (ChangeNotify notify);

        CompAction & optionGetClearButton ();
        void optionSetClearButtonInitiate (CompAction::CallBack init);
        void optionSetClearButtonTerminate (CompAction::CallBack term);
        void optionSetClearButtonNotify (ChangeNotify notify);

        float optionGetBgBrightness ();
        void optionSetBgBrightnessNotify (ChangeNotify notify);

        CompAction & optionGetAddParticle ();
        void optionSetAddParticleInitiate (CompAction::CallBack init);
        void optionSetAddParticleTerminate (CompAction::CallBack term);
        void optionSetAddParticleNotify (ChangeNotify notify);

        int optionGetNumParticles ();
        void optionSetNumParticlesNotify (ChangeNotify notify);

        float optionGetFireSize ();
        void optionSetFireSizeNotify (ChangeNotify notify);

        float optionGetFireSlowdown ();
        void optionSetFireSlowdownNotify (ChangeNotify notify);

        float optionGetFireLife ();
        void optionSetFireLifeNotify (ChangeNotify notify);

        unsigned short * optionGetFireColor ();
        unsigned short optionGetFireColorRed ();
        unsigned short optionGetFireColorGreen ();
        unsigned short optionGetFireColorBlue ();
        unsigned short optionGetFireColorAlpha ();
        void optionSetFireColorNotify (ChangeNotify notify);

        bool optionGetFireMystical ();
        void optionSetFireMysticalNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
FirepaintOptions::optionGetInitiateKey ()
{
    return mOptions[FirepaintOptions::InitiateKey].value ().action ();
}

inline void
FirepaintOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[FirepaintOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
FirepaintOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[FirepaintOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
FirepaintOptions::optionSetInitiateKeyNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::InitiateKey] = notify;
}

inline CompAction &
FirepaintOptions::optionGetInitiateButton ()
{
    return mOptions[FirepaintOptions::InitiateButton].value ().action ();
}

inline void
FirepaintOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[FirepaintOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
FirepaintOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[FirepaintOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
FirepaintOptions::optionSetInitiateButtonNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::InitiateButton] = notify;
}

inline CompAction &
FirepaintOptions::optionGetClearKey ()
{
    return mOptions[FirepaintOptions::ClearKey].value ().action ();
}

inline void
FirepaintOptions::optionSetClearKeyInitiate (CompAction::CallBack init)
{
    mOptions[FirepaintOptions::ClearKey].value ().action ().setInitiate (init);
}

inline void
FirepaintOptions::optionSetClearKeyTerminate (CompAction::CallBack term)
{
    mOptions[FirepaintOptions::ClearKey].value ().action ().setTerminate (term);
}

inline void
FirepaintOptions::optionSetClearKeyNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::ClearKey] = notify;
}

inline CompAction &
FirepaintOptions::optionGetClearButton ()
{
    return mOptions[FirepaintOptions::ClearButton].value ().action ();
}

inline void
FirepaintOptions::optionSetClearButtonInitiate (CompAction::CallBack init)
{
    mOptions[FirepaintOptions::ClearButton].value ().action ().setInitiate (init);
}

inline void
FirepaintOptions::optionSetClearButtonTerminate (CompAction::CallBack term)
{
    mOptions[FirepaintOptions::ClearButton].value ().action ().setTerminate (term);
}

inline void
FirepaintOptions::optionSetClearButtonNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::ClearButton] = notify;
}

inline float
FirepaintOptions::optionGetBgBrightness ()
{
    return mOptions[FirepaintOptions::BgBrightness].value ().f ();
}

inline void
FirepaintOptions::optionSetBgBrightnessNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::BgBrightness] = notify;
}

inline CompAction &
FirepaintOptions::optionGetAddParticle ()
{
    return mOptions[FirepaintOptions::AddParticle].value ().action ();
}

inline void
FirepaintOptions::optionSetAddParticleInitiate (CompAction::CallBack init)
{
    mOptions[FirepaintOptions::AddParticle].value ().action ().setInitiate (init);
}

inline void
FirepaintOptions::optionSetAddParticleTerminate (CompAction::CallBack term)
{
    mOptions[FirepaintOptions::AddParticle].value ().action ().setTerminate (term);
}

inline void
FirepaintOptions::optionSetAddParticleNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::AddParticle] = notify;
}

inline int
FirepaintOptions::optionGetNumParticles ()
{
    return mOptions[FirepaintOptions::NumParticles].value ().i ();
}

inline void
FirepaintOptions::optionSetNumParticlesNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::NumParticles] = notify;
}

inline float
FirepaintOptions::optionGetFireSize ()
{
    return mOptions[FirepaintOptions::FireSize].value ().f ();
}

inline void
FirepaintOptions::optionSetFireSizeNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::FireSize] = notify;
}

inline float
FirepaintOptions::optionGetFireSlowdown ()
{
    return mOptions[FirepaintOptions::FireSlowdown].value ().f ();
}

inline void
FirepaintOptions::optionSetFireSlowdownNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::FireSlowdown] = notify;
}

inline float
FirepaintOptions::optionGetFireLife ()
{
    return mOptions[FirepaintOptions::FireLife].value ().f ();
}

inline void
FirepaintOptions::optionSetFireLifeNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::FireLife] = notify;
}

inline unsigned short *
FirepaintOptions::optionGetFireColor ()
{
    return mOptions[FirepaintOptions::FireColor].value ().c ();
}

inline unsigned short
FirepaintOptions::optionGetFireColorRed ()
{
    return mOptions[FirepaintOptions::FireColor].value ().c ()[0];
}

inline unsigned short
FirepaintOptions::optionGetFireColorGreen ()
{
    return mOptions[FirepaintOptions::FireColor].value ().c ()[1];
}


inline unsigned short
FirepaintOptions::optionGetFireColorBlue ()
{
    return mOptions[FirepaintOptions::FireColor].value ().c ()[2];
}


inline unsigned short
FirepaintOptions::optionGetFireColorAlpha ()
{
    return mOptions[FirepaintOptions::FireColor].value ().c ()[3];
}


inline void
FirepaintOptions::optionSetFireColorNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::FireColor] = notify;
}

inline bool
FirepaintOptions::optionGetFireMystical ()
{
    return mOptions[FirepaintOptions::FireMystical].value ().b ();
}

inline void
FirepaintOptions::optionSetFireMysticalNotify (FirepaintOptions::ChangeNotify notify)
{
    mNotify[FirepaintOptions::FireMystical] = notify;
}



#endif
