/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _FREEWINS_OPTIONS_H
#define _FREEWINS_OPTIONS_H

#include <core/core.h>

class FreewinsOptions : public CompOption::Class {
    public:
        enum Options {
            Rotate,
            IncrementRotate,
            Scale,
            InitiateRotationButton,
            InitiateScaleButton,
            ResetButton,
            ResetKey,
            ToggleAxisKey,
            SnapMods,
            InvertMods,
            ScaleUpButton,
            ScaleDownButton,
            ScaleUpKey,
            ScaleDownKey,
            RotateUpKey,
            RotateDownKey,
            RotateLeftKey,
            RotateRightKey,
            RotateCKey,
            RotateCcKey,
            Snap,
            SnapThreshold,
            MouseSensitivity,
            ScaleMode,
            AllowNegative,
            ScaleUniform,
            MinScale,
            ZAxisRotation,
            RotationAxis,
            TdPercent,
            AutoZoom,
            DisableOnTransformedScreen,
            Speed,
            RotateIncrementAmount,
            ScaleIncrementAmount,
            ShapeWindowTypes,
            DoShapeInput,
            ImmediateMoves,
            CircleColor,
            LineColor,
            CrossLineColor,
            ShowCircle,
            ShowGizmo,
            ShowCross,
            ShowRegion,
            OptionNum
        };

        enum SnapMods {
            SnapModsShift = 0,
            SnapModsAlt = 1,
            SnapModsControl = 2,
            SnapModsMeta = 3,
        };

        enum InvertMods {
            InvertModsShift = 0,
            InvertModsAlt = 1,
            InvertModsControl = 2,
            InvertModsMeta = 3,
        };

        enum ScaleMode {
            ScaleModeToCentre = 0,
            ScaleModeToOppositeCorner = 1,
        };

        enum ZAxisRotation {
            ZAxisRotationAlways2d = 0,
            ZAxisRotationAlways3d = 1,
            ZAxisRotationDetermineOnClick = 2,
            ZAxisRotationInterchangeable = 3,
            ZAxisRotationSwitch = 4,
            ZAxisRotationTrackball = 5,
        };

        enum RotationAxis {
            RotationAxisAlwaysCentre = 0,
            RotationAxisClickPoint = 1,
            RotationAxisOppositeToClick = 2,
            RotationAxisNearestCorner = 3,
        };

        #define SnapModsShiftMask (1 << 0)
        #define SnapModsAltMask (1 << 1)
        #define SnapModsControlMask (1 << 2)
        #define SnapModsMetaMask (1 << 3)


        #define InvertModsShiftMask (1 << 0)
        #define InvertModsAltMask (1 << 1)
        #define InvertModsControlMask (1 << 2)
        #define InvertModsMetaMask (1 << 3)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        FreewinsOptions (bool init = true);
        virtual ~FreewinsOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetRotate ();
        void optionSetRotateInitiate (CompAction::CallBack init);
        void optionSetRotateTerminate (CompAction::CallBack term);
        void optionSetRotateNotify (ChangeNotify notify);

        CompAction & optionGetIncrementRotate ();
        void optionSetIncrementRotateInitiate (CompAction::CallBack init);
        void optionSetIncrementRotateTerminate (CompAction::CallBack term);
        void optionSetIncrementRotateNotify (ChangeNotify notify);

        CompAction & optionGetScale ();
        void optionSetScaleInitiate (CompAction::CallBack init);
        void optionSetScaleTerminate (CompAction::CallBack term);
        void optionSetScaleNotify (ChangeNotify notify);

        CompAction & optionGetInitiateRotationButton ();
        void optionSetInitiateRotationButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateRotationButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateRotationButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateScaleButton ();
        void optionSetInitiateScaleButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateScaleButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateScaleButtonNotify (ChangeNotify notify);

        CompAction & optionGetResetButton ();
        void optionSetResetButtonInitiate (CompAction::CallBack init);
        void optionSetResetButtonTerminate (CompAction::CallBack term);
        void optionSetResetButtonNotify (ChangeNotify notify);

        CompAction & optionGetResetKey ();
        void optionSetResetKeyInitiate (CompAction::CallBack init);
        void optionSetResetKeyTerminate (CompAction::CallBack term);
        void optionSetResetKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleAxisKey ();
        void optionSetToggleAxisKeyInitiate (CompAction::CallBack init);
        void optionSetToggleAxisKeyTerminate (CompAction::CallBack term);
        void optionSetToggleAxisKeyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetSnapMods ();
        unsigned int optionGetSnapModsMask ();
        void optionSetSnapModsNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetInvertMods ();
        unsigned int optionGetInvertModsMask ();
        void optionSetInvertModsNotify (ChangeNotify notify);

        CompAction & optionGetScaleUpButton ();
        void optionSetScaleUpButtonInitiate (CompAction::CallBack init);
        void optionSetScaleUpButtonTerminate (CompAction::CallBack term);
        void optionSetScaleUpButtonNotify (ChangeNotify notify);

        CompAction & optionGetScaleDownButton ();
        void optionSetScaleDownButtonInitiate (CompAction::CallBack init);
        void optionSetScaleDownButtonTerminate (CompAction::CallBack term);
        void optionSetScaleDownButtonNotify (ChangeNotify notify);

        CompAction & optionGetScaleUpKey ();
        void optionSetScaleUpKeyInitiate (CompAction::CallBack init);
        void optionSetScaleUpKeyTerminate (CompAction::CallBack term);
        void optionSetScaleUpKeyNotify (ChangeNotify notify);

        CompAction & optionGetScaleDownKey ();
        void optionSetScaleDownKeyInitiate (CompAction::CallBack init);
        void optionSetScaleDownKeyTerminate (CompAction::CallBack term);
        void optionSetScaleDownKeyNotify (ChangeNotify notify);

        CompAction & optionGetRotateUpKey ();
        void optionSetRotateUpKeyInitiate (CompAction::CallBack init);
        void optionSetRotateUpKeyTerminate (CompAction::CallBack term);
        void optionSetRotateUpKeyNotify (ChangeNotify notify);

        CompAction & optionGetRotateDownKey ();
        void optionSetRotateDownKeyInitiate (CompAction::CallBack init);
        void optionSetRotateDownKeyTerminate (CompAction::CallBack term);
        void optionSetRotateDownKeyNotify (ChangeNotify notify);

        CompAction & optionGetRotateLeftKey ();
        void optionSetRotateLeftKeyInitiate (CompAction::CallBack init);
        void optionSetRotateLeftKeyTerminate (CompAction::CallBack term);
        void optionSetRotateLeftKeyNotify (ChangeNotify notify);

        CompAction & optionGetRotateRightKey ();
        void optionSetRotateRightKeyInitiate (CompAction::CallBack init);
        void optionSetRotateRightKeyTerminate (CompAction::CallBack term);
        void optionSetRotateRightKeyNotify (ChangeNotify notify);

        CompAction & optionGetRotateCKey ();
        void optionSetRotateCKeyInitiate (CompAction::CallBack init);
        void optionSetRotateCKeyTerminate (CompAction::CallBack term);
        void optionSetRotateCKeyNotify (ChangeNotify notify);

        CompAction & optionGetRotateCcKey ();
        void optionSetRotateCcKeyInitiate (CompAction::CallBack init);
        void optionSetRotateCcKeyTerminate (CompAction::CallBack term);
        void optionSetRotateCcKeyNotify (ChangeNotify notify);

        bool optionGetSnap ();
        void optionSetSnapNotify (ChangeNotify notify);

        int optionGetSnapThreshold ();
        void optionSetSnapThresholdNotify (ChangeNotify notify);

        float optionGetMouseSensitivity ();
        void optionSetMouseSensitivityNotify (ChangeNotify notify);

        int optionGetScaleMode ();
        void optionSetScaleModeNotify (ChangeNotify notify);

        bool optionGetAllowNegative ();
        void optionSetAllowNegativeNotify (ChangeNotify notify);

        bool optionGetScaleUniform ();
        void optionSetScaleUniformNotify (ChangeNotify notify);

        float optionGetMinScale ();
        void optionSetMinScaleNotify (ChangeNotify notify);

        int optionGetZAxisRotation ();
        void optionSetZAxisRotationNotify (ChangeNotify notify);

        int optionGetRotationAxis ();
        void optionSetRotationAxisNotify (ChangeNotify notify);

        float optionGetTdPercent ();
        void optionSetTdPercentNotify (ChangeNotify notify);

        bool optionGetAutoZoom ();
        void optionSetAutoZoomNotify (ChangeNotify notify);

        bool optionGetDisableOnTransformedScreen ();
        void optionSetDisableOnTransformedScreenNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetRotateIncrementAmount ();
        void optionSetRotateIncrementAmountNotify (ChangeNotify notify);

        float optionGetScaleIncrementAmount ();
        void optionSetScaleIncrementAmountNotify (ChangeNotify notify);

        CompMatch & optionGetShapeWindowTypes ();
        void optionSetShapeWindowTypesNotify (ChangeNotify notify);

        bool optionGetDoShapeInput ();
        void optionSetDoShapeInputNotify (ChangeNotify notify);

        bool optionGetImmediateMoves ();
        void optionSetImmediateMovesNotify (ChangeNotify notify);

        unsigned short * optionGetCircleColor ();
        unsigned short optionGetCircleColorRed ();
        unsigned short optionGetCircleColorGreen ();
        unsigned short optionGetCircleColorBlue ();
        unsigned short optionGetCircleColorAlpha ();
        void optionSetCircleColorNotify (ChangeNotify notify);

        unsigned short * optionGetLineColor ();
        unsigned short optionGetLineColorRed ();
        unsigned short optionGetLineColorGreen ();
        unsigned short optionGetLineColorBlue ();
        unsigned short optionGetLineColorAlpha ();
        void optionSetLineColorNotify (ChangeNotify notify);

        unsigned short * optionGetCrossLineColor ();
        unsigned short optionGetCrossLineColorRed ();
        unsigned short optionGetCrossLineColorGreen ();
        unsigned short optionGetCrossLineColorBlue ();
        unsigned short optionGetCrossLineColorAlpha ();
        void optionSetCrossLineColorNotify (ChangeNotify notify);

        bool optionGetShowCircle ();
        void optionSetShowCircleNotify (ChangeNotify notify);

        bool optionGetShowGizmo ();
        void optionSetShowGizmoNotify (ChangeNotify notify);

        bool optionGetShowCross ();
        void optionSetShowCrossNotify (ChangeNotify notify);

        bool optionGetShowRegion ();
        void optionSetShowRegionNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mSnapModsMask;
        unsigned int mInvertModsMask;

};


inline CompAction &
FreewinsOptions::optionGetRotate ()
{
    return mOptions[FreewinsOptions::Rotate].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::Rotate].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::Rotate].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::Rotate] = notify;
}

inline CompAction &
FreewinsOptions::optionGetIncrementRotate ()
{
    return mOptions[FreewinsOptions::IncrementRotate].value ().action ();
}

inline void
FreewinsOptions::optionSetIncrementRotateInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::IncrementRotate].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetIncrementRotateTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::IncrementRotate].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetIncrementRotateNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::IncrementRotate] = notify;
}

inline CompAction &
FreewinsOptions::optionGetScale ()
{
    return mOptions[FreewinsOptions::Scale].value ().action ();
}

inline void
FreewinsOptions::optionSetScaleInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::Scale].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetScaleTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::Scale].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetScaleNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::Scale] = notify;
}

inline CompAction &
FreewinsOptions::optionGetInitiateRotationButton ()
{
    return mOptions[FreewinsOptions::InitiateRotationButton].value ().action ();
}

inline void
FreewinsOptions::optionSetInitiateRotationButtonInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::InitiateRotationButton].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetInitiateRotationButtonTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::InitiateRotationButton].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetInitiateRotationButtonNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::InitiateRotationButton] = notify;
}

inline CompAction &
FreewinsOptions::optionGetInitiateScaleButton ()
{
    return mOptions[FreewinsOptions::InitiateScaleButton].value ().action ();
}

inline void
FreewinsOptions::optionSetInitiateScaleButtonInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::InitiateScaleButton].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetInitiateScaleButtonTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::InitiateScaleButton].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetInitiateScaleButtonNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::InitiateScaleButton] = notify;
}

inline CompAction &
FreewinsOptions::optionGetResetButton ()
{
    return mOptions[FreewinsOptions::ResetButton].value ().action ();
}

inline void
FreewinsOptions::optionSetResetButtonInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ResetButton].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetResetButtonTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ResetButton].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetResetButtonNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ResetButton] = notify;
}

inline CompAction &
FreewinsOptions::optionGetResetKey ()
{
    return mOptions[FreewinsOptions::ResetKey].value ().action ();
}

inline void
FreewinsOptions::optionSetResetKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ResetKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetResetKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ResetKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetResetKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ResetKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetToggleAxisKey ()
{
    return mOptions[FreewinsOptions::ToggleAxisKey].value ().action ();
}

inline void
FreewinsOptions::optionSetToggleAxisKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ToggleAxisKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetToggleAxisKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ToggleAxisKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetToggleAxisKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ToggleAxisKey] = notify;
}

inline CompOption::Value::Vector &
FreewinsOptions::optionGetSnapMods ()
{
    return mOptions[FreewinsOptions::SnapMods].value ().list ();
}

inline unsigned int
FreewinsOptions::optionGetSnapModsMask ()
{
    return mSnapModsMask;
}

inline void
FreewinsOptions::optionSetSnapModsNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::SnapMods] = notify;
}

inline CompOption::Value::Vector &
FreewinsOptions::optionGetInvertMods ()
{
    return mOptions[FreewinsOptions::InvertMods].value ().list ();
}

inline unsigned int
FreewinsOptions::optionGetInvertModsMask ()
{
    return mInvertModsMask;
}

inline void
FreewinsOptions::optionSetInvertModsNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::InvertMods] = notify;
}

inline CompAction &
FreewinsOptions::optionGetScaleUpButton ()
{
    return mOptions[FreewinsOptions::ScaleUpButton].value ().action ();
}

inline void
FreewinsOptions::optionSetScaleUpButtonInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ScaleUpButton].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetScaleUpButtonTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ScaleUpButton].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetScaleUpButtonNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleUpButton] = notify;
}

inline CompAction &
FreewinsOptions::optionGetScaleDownButton ()
{
    return mOptions[FreewinsOptions::ScaleDownButton].value ().action ();
}

inline void
FreewinsOptions::optionSetScaleDownButtonInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ScaleDownButton].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetScaleDownButtonTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ScaleDownButton].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetScaleDownButtonNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleDownButton] = notify;
}

inline CompAction &
FreewinsOptions::optionGetScaleUpKey ()
{
    return mOptions[FreewinsOptions::ScaleUpKey].value ().action ();
}

inline void
FreewinsOptions::optionSetScaleUpKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ScaleUpKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetScaleUpKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ScaleUpKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetScaleUpKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleUpKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetScaleDownKey ()
{
    return mOptions[FreewinsOptions::ScaleDownKey].value ().action ();
}

inline void
FreewinsOptions::optionSetScaleDownKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::ScaleDownKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetScaleDownKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::ScaleDownKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetScaleDownKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleDownKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetRotateUpKey ()
{
    return mOptions[FreewinsOptions::RotateUpKey].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateUpKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::RotateUpKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateUpKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::RotateUpKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateUpKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateUpKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetRotateDownKey ()
{
    return mOptions[FreewinsOptions::RotateDownKey].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateDownKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::RotateDownKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateDownKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::RotateDownKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateDownKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateDownKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetRotateLeftKey ()
{
    return mOptions[FreewinsOptions::RotateLeftKey].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateLeftKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::RotateLeftKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateLeftKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::RotateLeftKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateLeftKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateLeftKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetRotateRightKey ()
{
    return mOptions[FreewinsOptions::RotateRightKey].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateRightKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::RotateRightKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateRightKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::RotateRightKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateRightKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateRightKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetRotateCKey ()
{
    return mOptions[FreewinsOptions::RotateCKey].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateCKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::RotateCKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateCKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::RotateCKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateCKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateCKey] = notify;
}

inline CompAction &
FreewinsOptions::optionGetRotateCcKey ()
{
    return mOptions[FreewinsOptions::RotateCcKey].value ().action ();
}

inline void
FreewinsOptions::optionSetRotateCcKeyInitiate (CompAction::CallBack init)
{
    mOptions[FreewinsOptions::RotateCcKey].value ().action ().setInitiate (init);
}

inline void
FreewinsOptions::optionSetRotateCcKeyTerminate (CompAction::CallBack term)
{
    mOptions[FreewinsOptions::RotateCcKey].value ().action ().setTerminate (term);
}

inline void
FreewinsOptions::optionSetRotateCcKeyNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateCcKey] = notify;
}

inline bool
FreewinsOptions::optionGetSnap ()
{
    return mOptions[FreewinsOptions::Snap].value ().b ();
}

inline void
FreewinsOptions::optionSetSnapNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::Snap] = notify;
}

inline int
FreewinsOptions::optionGetSnapThreshold ()
{
    return mOptions[FreewinsOptions::SnapThreshold].value ().i ();
}

inline void
FreewinsOptions::optionSetSnapThresholdNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::SnapThreshold] = notify;
}

inline float
FreewinsOptions::optionGetMouseSensitivity ()
{
    return mOptions[FreewinsOptions::MouseSensitivity].value ().f ();
}

inline void
FreewinsOptions::optionSetMouseSensitivityNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::MouseSensitivity] = notify;
}

inline int
FreewinsOptions::optionGetScaleMode ()
{
    return mOptions[FreewinsOptions::ScaleMode].value ().i ();
}

inline void
FreewinsOptions::optionSetScaleModeNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleMode] = notify;
}

inline bool
FreewinsOptions::optionGetAllowNegative ()
{
    return mOptions[FreewinsOptions::AllowNegative].value ().b ();
}

inline void
FreewinsOptions::optionSetAllowNegativeNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::AllowNegative] = notify;
}

inline bool
FreewinsOptions::optionGetScaleUniform ()
{
    return mOptions[FreewinsOptions::ScaleUniform].value ().b ();
}

inline void
FreewinsOptions::optionSetScaleUniformNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleUniform] = notify;
}

inline float
FreewinsOptions::optionGetMinScale ()
{
    return mOptions[FreewinsOptions::MinScale].value ().f ();
}

inline void
FreewinsOptions::optionSetMinScaleNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::MinScale] = notify;
}

inline int
FreewinsOptions::optionGetZAxisRotation ()
{
    return mOptions[FreewinsOptions::ZAxisRotation].value ().i ();
}

inline void
FreewinsOptions::optionSetZAxisRotationNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ZAxisRotation] = notify;
}

inline int
FreewinsOptions::optionGetRotationAxis ()
{
    return mOptions[FreewinsOptions::RotationAxis].value ().i ();
}

inline void
FreewinsOptions::optionSetRotationAxisNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotationAxis] = notify;
}

inline float
FreewinsOptions::optionGetTdPercent ()
{
    return mOptions[FreewinsOptions::TdPercent].value ().f ();
}

inline void
FreewinsOptions::optionSetTdPercentNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::TdPercent] = notify;
}

inline bool
FreewinsOptions::optionGetAutoZoom ()
{
    return mOptions[FreewinsOptions::AutoZoom].value ().b ();
}

inline void
FreewinsOptions::optionSetAutoZoomNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::AutoZoom] = notify;
}

inline bool
FreewinsOptions::optionGetDisableOnTransformedScreen ()
{
    return mOptions[FreewinsOptions::DisableOnTransformedScreen].value ().b ();
}

inline void
FreewinsOptions::optionSetDisableOnTransformedScreenNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::DisableOnTransformedScreen] = notify;
}

inline float
FreewinsOptions::optionGetSpeed ()
{
    return mOptions[FreewinsOptions::Speed].value ().f ();
}

inline void
FreewinsOptions::optionSetSpeedNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::Speed] = notify;
}

inline float
FreewinsOptions::optionGetRotateIncrementAmount ()
{
    return mOptions[FreewinsOptions::RotateIncrementAmount].value ().f ();
}

inline void
FreewinsOptions::optionSetRotateIncrementAmountNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::RotateIncrementAmount] = notify;
}

inline float
FreewinsOptions::optionGetScaleIncrementAmount ()
{
    return mOptions[FreewinsOptions::ScaleIncrementAmount].value ().f ();
}

inline void
FreewinsOptions::optionSetScaleIncrementAmountNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ScaleIncrementAmount] = notify;
}

inline CompMatch &
FreewinsOptions::optionGetShapeWindowTypes ()
{
    return mOptions[FreewinsOptions::ShapeWindowTypes].value ().match ();
}

inline void
FreewinsOptions::optionSetShapeWindowTypesNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ShapeWindowTypes] = notify;
}

inline bool
FreewinsOptions::optionGetDoShapeInput ()
{
    return mOptions[FreewinsOptions::DoShapeInput].value ().b ();
}

inline void
FreewinsOptions::optionSetDoShapeInputNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::DoShapeInput] = notify;
}

inline bool
FreewinsOptions::optionGetImmediateMoves ()
{
    return mOptions[FreewinsOptions::ImmediateMoves].value ().b ();
}

inline void
FreewinsOptions::optionSetImmediateMovesNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ImmediateMoves] = notify;
}

inline unsigned short *
FreewinsOptions::optionGetCircleColor ()
{
    return mOptions[FreewinsOptions::CircleColor].value ().c ();
}

inline unsigned short
FreewinsOptions::optionGetCircleColorRed ()
{
    return mOptions[FreewinsOptions::CircleColor].value ().c ()[0];
}

inline unsigned short
FreewinsOptions::optionGetCircleColorGreen ()
{
    return mOptions[FreewinsOptions::CircleColor].value ().c ()[1];
}


inline unsigned short
FreewinsOptions::optionGetCircleColorBlue ()
{
    return mOptions[FreewinsOptions::CircleColor].value ().c ()[2];
}


inline unsigned short
FreewinsOptions::optionGetCircleColorAlpha ()
{
    return mOptions[FreewinsOptions::CircleColor].value ().c ()[3];
}


inline void
FreewinsOptions::optionSetCircleColorNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::CircleColor] = notify;
}

inline unsigned short *
FreewinsOptions::optionGetLineColor ()
{
    return mOptions[FreewinsOptions::LineColor].value ().c ();
}

inline unsigned short
FreewinsOptions::optionGetLineColorRed ()
{
    return mOptions[FreewinsOptions::LineColor].value ().c ()[0];
}

inline unsigned short
FreewinsOptions::optionGetLineColorGreen ()
{
    return mOptions[FreewinsOptions::LineColor].value ().c ()[1];
}


inline unsigned short
FreewinsOptions::optionGetLineColorBlue ()
{
    return mOptions[FreewinsOptions::LineColor].value ().c ()[2];
}


inline unsigned short
FreewinsOptions::optionGetLineColorAlpha ()
{
    return mOptions[FreewinsOptions::LineColor].value ().c ()[3];
}


inline void
FreewinsOptions::optionSetLineColorNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::LineColor] = notify;
}

inline unsigned short *
FreewinsOptions::optionGetCrossLineColor ()
{
    return mOptions[FreewinsOptions::CrossLineColor].value ().c ();
}

inline unsigned short
FreewinsOptions::optionGetCrossLineColorRed ()
{
    return mOptions[FreewinsOptions::CrossLineColor].value ().c ()[0];
}

inline unsigned short
FreewinsOptions::optionGetCrossLineColorGreen ()
{
    return mOptions[FreewinsOptions::CrossLineColor].value ().c ()[1];
}


inline unsigned short
FreewinsOptions::optionGetCrossLineColorBlue ()
{
    return mOptions[FreewinsOptions::CrossLineColor].value ().c ()[2];
}


inline unsigned short
FreewinsOptions::optionGetCrossLineColorAlpha ()
{
    return mOptions[FreewinsOptions::CrossLineColor].value ().c ()[3];
}


inline void
FreewinsOptions::optionSetCrossLineColorNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::CrossLineColor] = notify;
}

inline bool
FreewinsOptions::optionGetShowCircle ()
{
    return mOptions[FreewinsOptions::ShowCircle].value ().b ();
}

inline void
FreewinsOptions::optionSetShowCircleNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ShowCircle] = notify;
}

inline bool
FreewinsOptions::optionGetShowGizmo ()
{
    return mOptions[FreewinsOptions::ShowGizmo].value ().b ();
}

inline void
FreewinsOptions::optionSetShowGizmoNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ShowGizmo] = notify;
}

inline bool
FreewinsOptions::optionGetShowCross ()
{
    return mOptions[FreewinsOptions::ShowCross].value ().b ();
}

inline void
FreewinsOptions::optionSetShowCrossNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ShowCross] = notify;
}

inline bool
FreewinsOptions::optionGetShowRegion ()
{
    return mOptions[FreewinsOptions::ShowRegion].value ().b ();
}

inline void
FreewinsOptions::optionSetShowRegionNotify (FreewinsOptions::ChangeNotify notify)
{
    mNotify[FreewinsOptions::ShowRegion] = notify;
}



#endif
