/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _GNOMECOMPAT_OPTIONS_H
#define _GNOMECOMPAT_OPTIONS_H

#include <core/core.h>

class GnomecompatOptions : public CompOption::Class {
    public:
        enum Options {
            MainMenuKey,
            RunKey,
            CommandScreenshot,
            RunCommandScreenshotKey,
            CommandWindowScreenshot,
            RunCommandWindowScreenshotKey,
            CommandTerminal,
            RunCommandTerminalKey,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        GnomecompatOptions (bool init = true);
        virtual ~GnomecompatOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetMainMenuKey ();
        void optionSetMainMenuKeyInitiate (CompAction::CallBack init);
        void optionSetMainMenuKeyTerminate (CompAction::CallBack term);
        void optionSetMainMenuKeyNotify (ChangeNotify notify);

        CompAction & optionGetRunKey ();
        void optionSetRunKeyInitiate (CompAction::CallBack init);
        void optionSetRunKeyTerminate (CompAction::CallBack term);
        void optionSetRunKeyNotify (ChangeNotify notify);

        CompString optionGetCommandScreenshot ();
        void optionSetCommandScreenshotNotify (ChangeNotify notify);

        CompAction & optionGetRunCommandScreenshotKey ();
        void optionSetRunCommandScreenshotKeyInitiate (CompAction::CallBack init);
        void optionSetRunCommandScreenshotKeyTerminate (CompAction::CallBack term);
        void optionSetRunCommandScreenshotKeyNotify (ChangeNotify notify);

        CompString optionGetCommandWindowScreenshot ();
        void optionSetCommandWindowScreenshotNotify (ChangeNotify notify);

        CompAction & optionGetRunCommandWindowScreenshotKey ();
        void optionSetRunCommandWindowScreenshotKeyInitiate (CompAction::CallBack init);
        void optionSetRunCommandWindowScreenshotKeyTerminate (CompAction::CallBack term);
        void optionSetRunCommandWindowScreenshotKeyNotify (ChangeNotify notify);

        CompString optionGetCommandTerminal ();
        void optionSetCommandTerminalNotify (ChangeNotify notify);

        CompAction & optionGetRunCommandTerminalKey ();
        void optionSetRunCommandTerminalKeyInitiate (CompAction::CallBack init);
        void optionSetRunCommandTerminalKeyTerminate (CompAction::CallBack term);
        void optionSetRunCommandTerminalKeyNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
GnomecompatOptions::optionGetMainMenuKey ()
{
    return mOptions[GnomecompatOptions::MainMenuKey].value ().action ();
}

inline void
GnomecompatOptions::optionSetMainMenuKeyInitiate (CompAction::CallBack init)
{
    mOptions[GnomecompatOptions::MainMenuKey].value ().action ().setInitiate (init);
}

inline void
GnomecompatOptions::optionSetMainMenuKeyTerminate (CompAction::CallBack term)
{
    mOptions[GnomecompatOptions::MainMenuKey].value ().action ().setTerminate (term);
}

inline void
GnomecompatOptions::optionSetMainMenuKeyNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::MainMenuKey] = notify;
}

inline CompAction &
GnomecompatOptions::optionGetRunKey ()
{
    return mOptions[GnomecompatOptions::RunKey].value ().action ();
}

inline void
GnomecompatOptions::optionSetRunKeyInitiate (CompAction::CallBack init)
{
    mOptions[GnomecompatOptions::RunKey].value ().action ().setInitiate (init);
}

inline void
GnomecompatOptions::optionSetRunKeyTerminate (CompAction::CallBack term)
{
    mOptions[GnomecompatOptions::RunKey].value ().action ().setTerminate (term);
}

inline void
GnomecompatOptions::optionSetRunKeyNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::RunKey] = notify;
}

inline CompString
GnomecompatOptions::optionGetCommandScreenshot ()
{
    return mOptions[GnomecompatOptions::CommandScreenshot].value ().s ();
}

inline void
GnomecompatOptions::optionSetCommandScreenshotNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::CommandScreenshot] = notify;
}

inline CompAction &
GnomecompatOptions::optionGetRunCommandScreenshotKey ()
{
    return mOptions[GnomecompatOptions::RunCommandScreenshotKey].value ().action ();
}

inline void
GnomecompatOptions::optionSetRunCommandScreenshotKeyInitiate (CompAction::CallBack init)
{
    mOptions[GnomecompatOptions::RunCommandScreenshotKey].value ().action ().setInitiate (init);
}

inline void
GnomecompatOptions::optionSetRunCommandScreenshotKeyTerminate (CompAction::CallBack term)
{
    mOptions[GnomecompatOptions::RunCommandScreenshotKey].value ().action ().setTerminate (term);
}

inline void
GnomecompatOptions::optionSetRunCommandScreenshotKeyNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::RunCommandScreenshotKey] = notify;
}

inline CompString
GnomecompatOptions::optionGetCommandWindowScreenshot ()
{
    return mOptions[GnomecompatOptions::CommandWindowScreenshot].value ().s ();
}

inline void
GnomecompatOptions::optionSetCommandWindowScreenshotNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::CommandWindowScreenshot] = notify;
}

inline CompAction &
GnomecompatOptions::optionGetRunCommandWindowScreenshotKey ()
{
    return mOptions[GnomecompatOptions::RunCommandWindowScreenshotKey].value ().action ();
}

inline void
GnomecompatOptions::optionSetRunCommandWindowScreenshotKeyInitiate (CompAction::CallBack init)
{
    mOptions[GnomecompatOptions::RunCommandWindowScreenshotKey].value ().action ().setInitiate (init);
}

inline void
GnomecompatOptions::optionSetRunCommandWindowScreenshotKeyTerminate (CompAction::CallBack term)
{
    mOptions[GnomecompatOptions::RunCommandWindowScreenshotKey].value ().action ().setTerminate (term);
}

inline void
GnomecompatOptions::optionSetRunCommandWindowScreenshotKeyNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::RunCommandWindowScreenshotKey] = notify;
}

inline CompString
GnomecompatOptions::optionGetCommandTerminal ()
{
    return mOptions[GnomecompatOptions::CommandTerminal].value ().s ();
}

inline void
GnomecompatOptions::optionSetCommandTerminalNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::CommandTerminal] = notify;
}

inline CompAction &
GnomecompatOptions::optionGetRunCommandTerminalKey ()
{
    return mOptions[GnomecompatOptions::RunCommandTerminalKey].value ().action ();
}

inline void
GnomecompatOptions::optionSetRunCommandTerminalKeyInitiate (CompAction::CallBack init)
{
    mOptions[GnomecompatOptions::RunCommandTerminalKey].value ().action ().setInitiate (init);
}

inline void
GnomecompatOptions::optionSetRunCommandTerminalKeyTerminate (CompAction::CallBack term)
{
    mOptions[GnomecompatOptions::RunCommandTerminalKey].value ().action ().setTerminate (term);
}

inline void
GnomecompatOptions::optionSetRunCommandTerminalKeyNotify (GnomecompatOptions::ChangeNotify notify)
{
    mNotify[GnomecompatOptions::RunCommandTerminalKey] = notify;
}



#endif
