/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _MAG_OPTIONS_H
#define _MAG_OPTIONS_H

#include <core/core.h>

class MagOptions : public CompOption::Class {
    public:
        enum Options {
            Initiate,
            ZoomInButton,
            ZoomOutButton,
            Mode,
            ZoomFactor,
            Speed,
            Timestep,
            KeepScreen,
            BoxWidth,
            BoxHeight,
            Border,
            BoxColor,
            Overlay,
            Mask,
            XOffset,
            YOffset,
            Radius,
            OptionNum
        };

        enum Mode {
            ModeSimple = 0,
            ModeImageOverlay = 1,
            ModeFisheye = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        MagOptions (bool init = true);
        virtual ~MagOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiate ();
        void optionSetInitiateInitiate (CompAction::CallBack init);
        void optionSetInitiateTerminate (CompAction::CallBack term);
        void optionSetInitiateNotify (ChangeNotify notify);

        CompAction & optionGetZoomInButton ();
        void optionSetZoomInButtonInitiate (CompAction::CallBack init);
        void optionSetZoomInButtonTerminate (CompAction::CallBack term);
        void optionSetZoomInButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomOutButton ();
        void optionSetZoomOutButtonInitiate (CompAction::CallBack init);
        void optionSetZoomOutButtonTerminate (CompAction::CallBack term);
        void optionSetZoomOutButtonNotify (ChangeNotify notify);

        int optionGetMode ();
        void optionSetModeNotify (ChangeNotify notify);

        float optionGetZoomFactor ();
        void optionSetZoomFactorNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        bool optionGetKeepScreen ();
        void optionSetKeepScreenNotify (ChangeNotify notify);

        int optionGetBoxWidth ();
        void optionSetBoxWidthNotify (ChangeNotify notify);

        int optionGetBoxHeight ();
        void optionSetBoxHeightNotify (ChangeNotify notify);

        int optionGetBorder ();
        void optionSetBorderNotify (ChangeNotify notify);

        unsigned short * optionGetBoxColor ();
        unsigned short optionGetBoxColorRed ();
        unsigned short optionGetBoxColorGreen ();
        unsigned short optionGetBoxColorBlue ();
        unsigned short optionGetBoxColorAlpha ();
        void optionSetBoxColorNotify (ChangeNotify notify);

        CompString optionGetOverlay ();
        void optionSetOverlayNotify (ChangeNotify notify);

        CompString optionGetMask ();
        void optionSetMaskNotify (ChangeNotify notify);

        int optionGetXOffset ();
        void optionSetXOffsetNotify (ChangeNotify notify);

        int optionGetYOffset ();
        void optionSetYOffsetNotify (ChangeNotify notify);

        int optionGetRadius ();
        void optionSetRadiusNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
MagOptions::optionGetInitiate ()
{
    return mOptions[MagOptions::Initiate].value ().action ();
}

inline void
MagOptions::optionSetInitiateInitiate (CompAction::CallBack init)
{
    mOptions[MagOptions::Initiate].value ().action ().setInitiate (init);
}

inline void
MagOptions::optionSetInitiateTerminate (CompAction::CallBack term)
{
    mOptions[MagOptions::Initiate].value ().action ().setTerminate (term);
}

inline void
MagOptions::optionSetInitiateNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Initiate] = notify;
}

inline CompAction &
MagOptions::optionGetZoomInButton ()
{
    return mOptions[MagOptions::ZoomInButton].value ().action ();
}

inline void
MagOptions::optionSetZoomInButtonInitiate (CompAction::CallBack init)
{
    mOptions[MagOptions::ZoomInButton].value ().action ().setInitiate (init);
}

inline void
MagOptions::optionSetZoomInButtonTerminate (CompAction::CallBack term)
{
    mOptions[MagOptions::ZoomInButton].value ().action ().setTerminate (term);
}

inline void
MagOptions::optionSetZoomInButtonNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::ZoomInButton] = notify;
}

inline CompAction &
MagOptions::optionGetZoomOutButton ()
{
    return mOptions[MagOptions::ZoomOutButton].value ().action ();
}

inline void
MagOptions::optionSetZoomOutButtonInitiate (CompAction::CallBack init)
{
    mOptions[MagOptions::ZoomOutButton].value ().action ().setInitiate (init);
}

inline void
MagOptions::optionSetZoomOutButtonTerminate (CompAction::CallBack term)
{
    mOptions[MagOptions::ZoomOutButton].value ().action ().setTerminate (term);
}

inline void
MagOptions::optionSetZoomOutButtonNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::ZoomOutButton] = notify;
}

inline int
MagOptions::optionGetMode ()
{
    return mOptions[MagOptions::Mode].value ().i ();
}

inline void
MagOptions::optionSetModeNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Mode] = notify;
}

inline float
MagOptions::optionGetZoomFactor ()
{
    return mOptions[MagOptions::ZoomFactor].value ().f ();
}

inline void
MagOptions::optionSetZoomFactorNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::ZoomFactor] = notify;
}

inline float
MagOptions::optionGetSpeed ()
{
    return mOptions[MagOptions::Speed].value ().f ();
}

inline void
MagOptions::optionSetSpeedNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Speed] = notify;
}

inline float
MagOptions::optionGetTimestep ()
{
    return mOptions[MagOptions::Timestep].value ().f ();
}

inline void
MagOptions::optionSetTimestepNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Timestep] = notify;
}

inline bool
MagOptions::optionGetKeepScreen ()
{
    return mOptions[MagOptions::KeepScreen].value ().b ();
}

inline void
MagOptions::optionSetKeepScreenNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::KeepScreen] = notify;
}

inline int
MagOptions::optionGetBoxWidth ()
{
    return mOptions[MagOptions::BoxWidth].value ().i ();
}

inline void
MagOptions::optionSetBoxWidthNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::BoxWidth] = notify;
}

inline int
MagOptions::optionGetBoxHeight ()
{
    return mOptions[MagOptions::BoxHeight].value ().i ();
}

inline void
MagOptions::optionSetBoxHeightNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::BoxHeight] = notify;
}

inline int
MagOptions::optionGetBorder ()
{
    return mOptions[MagOptions::Border].value ().i ();
}

inline void
MagOptions::optionSetBorderNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Border] = notify;
}

inline unsigned short *
MagOptions::optionGetBoxColor ()
{
    return mOptions[MagOptions::BoxColor].value ().c ();
}

inline unsigned short
MagOptions::optionGetBoxColorRed ()
{
    return mOptions[MagOptions::BoxColor].value ().c ()[0];
}

inline unsigned short
MagOptions::optionGetBoxColorGreen ()
{
    return mOptions[MagOptions::BoxColor].value ().c ()[1];
}


inline unsigned short
MagOptions::optionGetBoxColorBlue ()
{
    return mOptions[MagOptions::BoxColor].value ().c ()[2];
}


inline unsigned short
MagOptions::optionGetBoxColorAlpha ()
{
    return mOptions[MagOptions::BoxColor].value ().c ()[3];
}


inline void
MagOptions::optionSetBoxColorNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::BoxColor] = notify;
}

inline CompString
MagOptions::optionGetOverlay ()
{
    return mOptions[MagOptions::Overlay].value ().s ();
}

inline void
MagOptions::optionSetOverlayNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Overlay] = notify;
}

inline CompString
MagOptions::optionGetMask ()
{
    return mOptions[MagOptions::Mask].value ().s ();
}

inline void
MagOptions::optionSetMaskNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Mask] = notify;
}

inline int
MagOptions::optionGetXOffset ()
{
    return mOptions[MagOptions::XOffset].value ().i ();
}

inline void
MagOptions::optionSetXOffsetNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::XOffset] = notify;
}

inline int
MagOptions::optionGetYOffset ()
{
    return mOptions[MagOptions::YOffset].value ().i ();
}

inline void
MagOptions::optionSetYOffsetNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::YOffset] = notify;
}

inline int
MagOptions::optionGetRadius ()
{
    return mOptions[MagOptions::Radius].value ().i ();
}

inline void
MagOptions::optionSetRadiusNotify (MagOptions::ChangeNotify notify)
{
    mNotify[MagOptions::Radius] = notify;
}



#endif
