/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _MATECOMPAT_OPTIONS_H
#define _MATECOMPAT_OPTIONS_H

#include <core/core.h>

class MatecompatOptions : public CompOption::Class {
    public:
        enum Options {
            MainMenuKey,
            RunKey,
            CommandScreenshot,
            RunCommandScreenshotKey,
            CommandWindowScreenshot,
            RunCommandWindowScreenshotKey,
            CommandTerminal,
            RunCommandTerminalKey,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        MatecompatOptions (bool init = true);
        virtual ~MatecompatOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetMainMenuKey ();
        void optionSetMainMenuKeyInitiate (CompAction::CallBack init);
        void optionSetMainMenuKeyTerminate (CompAction::CallBack term);
        void optionSetMainMenuKeyNotify (ChangeNotify notify);

        CompAction & optionGetRunKey ();
        void optionSetRunKeyInitiate (CompAction::CallBack init);
        void optionSetRunKeyTerminate (CompAction::CallBack term);
        void optionSetRunKeyNotify (ChangeNotify notify);

        CompString optionGetCommandScreenshot ();
        void optionSetCommandScreenshotNotify (ChangeNotify notify);

        CompAction & optionGetRunCommandScreenshotKey ();
        void optionSetRunCommandScreenshotKeyInitiate (CompAction::CallBack init);
        void optionSetRunCommandScreenshotKeyTerminate (CompAction::CallBack term);
        void optionSetRunCommandScreenshotKeyNotify (ChangeNotify notify);

        CompString optionGetCommandWindowScreenshot ();
        void optionSetCommandWindowScreenshotNotify (ChangeNotify notify);

        CompAction & optionGetRunCommandWindowScreenshotKey ();
        void optionSetRunCommandWindowScreenshotKeyInitiate (CompAction::CallBack init);
        void optionSetRunCommandWindowScreenshotKeyTerminate (CompAction::CallBack term);
        void optionSetRunCommandWindowScreenshotKeyNotify (ChangeNotify notify);

        CompString optionGetCommandTerminal ();
        void optionSetCommandTerminalNotify (ChangeNotify notify);

        CompAction & optionGetRunCommandTerminalKey ();
        void optionSetRunCommandTerminalKeyInitiate (CompAction::CallBack init);
        void optionSetRunCommandTerminalKeyTerminate (CompAction::CallBack term);
        void optionSetRunCommandTerminalKeyNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
MatecompatOptions::optionGetMainMenuKey ()
{
    return mOptions[MatecompatOptions::MainMenuKey].value ().action ();
}

inline void
MatecompatOptions::optionSetMainMenuKeyInitiate (CompAction::CallBack init)
{
    mOptions[MatecompatOptions::MainMenuKey].value ().action ().setInitiate (init);
}

inline void
MatecompatOptions::optionSetMainMenuKeyTerminate (CompAction::CallBack term)
{
    mOptions[MatecompatOptions::MainMenuKey].value ().action ().setTerminate (term);
}

inline void
MatecompatOptions::optionSetMainMenuKeyNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::MainMenuKey] = notify;
}

inline CompAction &
MatecompatOptions::optionGetRunKey ()
{
    return mOptions[MatecompatOptions::RunKey].value ().action ();
}

inline void
MatecompatOptions::optionSetRunKeyInitiate (CompAction::CallBack init)
{
    mOptions[MatecompatOptions::RunKey].value ().action ().setInitiate (init);
}

inline void
MatecompatOptions::optionSetRunKeyTerminate (CompAction::CallBack term)
{
    mOptions[MatecompatOptions::RunKey].value ().action ().setTerminate (term);
}

inline void
MatecompatOptions::optionSetRunKeyNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::RunKey] = notify;
}

inline CompString
MatecompatOptions::optionGetCommandScreenshot ()
{
    return mOptions[MatecompatOptions::CommandScreenshot].value ().s ();
}

inline void
MatecompatOptions::optionSetCommandScreenshotNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::CommandScreenshot] = notify;
}

inline CompAction &
MatecompatOptions::optionGetRunCommandScreenshotKey ()
{
    return mOptions[MatecompatOptions::RunCommandScreenshotKey].value ().action ();
}

inline void
MatecompatOptions::optionSetRunCommandScreenshotKeyInitiate (CompAction::CallBack init)
{
    mOptions[MatecompatOptions::RunCommandScreenshotKey].value ().action ().setInitiate (init);
}

inline void
MatecompatOptions::optionSetRunCommandScreenshotKeyTerminate (CompAction::CallBack term)
{
    mOptions[MatecompatOptions::RunCommandScreenshotKey].value ().action ().setTerminate (term);
}

inline void
MatecompatOptions::optionSetRunCommandScreenshotKeyNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::RunCommandScreenshotKey] = notify;
}

inline CompString
MatecompatOptions::optionGetCommandWindowScreenshot ()
{
    return mOptions[MatecompatOptions::CommandWindowScreenshot].value ().s ();
}

inline void
MatecompatOptions::optionSetCommandWindowScreenshotNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::CommandWindowScreenshot] = notify;
}

inline CompAction &
MatecompatOptions::optionGetRunCommandWindowScreenshotKey ()
{
    return mOptions[MatecompatOptions::RunCommandWindowScreenshotKey].value ().action ();
}

inline void
MatecompatOptions::optionSetRunCommandWindowScreenshotKeyInitiate (CompAction::CallBack init)
{
    mOptions[MatecompatOptions::RunCommandWindowScreenshotKey].value ().action ().setInitiate (init);
}

inline void
MatecompatOptions::optionSetRunCommandWindowScreenshotKeyTerminate (CompAction::CallBack term)
{
    mOptions[MatecompatOptions::RunCommandWindowScreenshotKey].value ().action ().setTerminate (term);
}

inline void
MatecompatOptions::optionSetRunCommandWindowScreenshotKeyNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::RunCommandWindowScreenshotKey] = notify;
}

inline CompString
MatecompatOptions::optionGetCommandTerminal ()
{
    return mOptions[MatecompatOptions::CommandTerminal].value ().s ();
}

inline void
MatecompatOptions::optionSetCommandTerminalNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::CommandTerminal] = notify;
}

inline CompAction &
MatecompatOptions::optionGetRunCommandTerminalKey ()
{
    return mOptions[MatecompatOptions::RunCommandTerminalKey].value ().action ();
}

inline void
MatecompatOptions::optionSetRunCommandTerminalKeyInitiate (CompAction::CallBack init)
{
    mOptions[MatecompatOptions::RunCommandTerminalKey].value ().action ().setInitiate (init);
}

inline void
MatecompatOptions::optionSetRunCommandTerminalKeyTerminate (CompAction::CallBack term)
{
    mOptions[MatecompatOptions::RunCommandTerminalKey].value ().action ().setTerminate (term);
}

inline void
MatecompatOptions::optionSetRunCommandTerminalKeyNotify (MatecompatOptions::ChangeNotify notify)
{
    mNotify[MatecompatOptions::RunCommandTerminalKey] = notify;
}



#endif
