/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _MBLUR_OPTIONS_H
#define _MBLUR_OPTIONS_H

#include <core/core.h>

class MblurOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateKey,
            Mode,
            Strength,
            OnTransformedScreen,
            OptionNum
        };

        enum Mode {
            ModeTextureCopy = 0,
            ModeAccumulationBuffer = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        MblurOptions (bool init = true);
        virtual ~MblurOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        int optionGetMode ();
        void optionSetModeNotify (ChangeNotify notify);

        float optionGetStrength ();
        void optionSetStrengthNotify (ChangeNotify notify);

        bool optionGetOnTransformedScreen ();
        void optionSetOnTransformedScreenNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
MblurOptions::optionGetInitiateKey ()
{
    return mOptions[MblurOptions::InitiateKey].value ().action ();
}

inline void
MblurOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[MblurOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
MblurOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[MblurOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
MblurOptions::optionSetInitiateKeyNotify (MblurOptions::ChangeNotify notify)
{
    mNotify[MblurOptions::InitiateKey] = notify;
}

inline int
MblurOptions::optionGetMode ()
{
    return mOptions[MblurOptions::Mode].value ().i ();
}

inline void
MblurOptions::optionSetModeNotify (MblurOptions::ChangeNotify notify)
{
    mNotify[MblurOptions::Mode] = notify;
}

inline float
MblurOptions::optionGetStrength ()
{
    return mOptions[MblurOptions::Strength].value ().f ();
}

inline void
MblurOptions::optionSetStrengthNotify (MblurOptions::ChangeNotify notify)
{
    mNotify[MblurOptions::Strength] = notify;
}

inline bool
MblurOptions::optionGetOnTransformedScreen ()
{
    return mOptions[MblurOptions::OnTransformedScreen].value ().b ();
}

inline void
MblurOptions::optionSetOnTransformedScreenNotify (MblurOptions::ChangeNotify notify)
{
    mNotify[MblurOptions::OnTransformedScreen] = notify;
}



#endif
