/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _NEG_OPTIONS_H
#define _NEG_OPTIONS_H

#include <core/core.h>

class NegOptions : public CompOption::Class {
    public:
        enum Options {
            WindowToggleKey,
            ActivateAtStartup,
            ScreenToggleKey,
            NegMatch,
            ExcludeMatch,
            NegDecorations,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        NegOptions (bool init = true);
        virtual ~NegOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetWindowToggleKey ();
        void optionSetWindowToggleKeyInitiate (CompAction::CallBack init);
        void optionSetWindowToggleKeyTerminate (CompAction::CallBack term);
        void optionSetWindowToggleKeyNotify (ChangeNotify notify);

        bool optionGetActivateAtStartup ();
        void optionSetActivateAtStartupNotify (ChangeNotify notify);

        CompAction & optionGetScreenToggleKey ();
        void optionSetScreenToggleKeyInitiate (CompAction::CallBack init);
        void optionSetScreenToggleKeyTerminate (CompAction::CallBack term);
        void optionSetScreenToggleKeyNotify (ChangeNotify notify);

        CompMatch & optionGetNegMatch ();
        void optionSetNegMatchNotify (ChangeNotify notify);

        CompMatch & optionGetExcludeMatch ();
        void optionSetExcludeMatchNotify (ChangeNotify notify);

        bool optionGetNegDecorations ();
        void optionSetNegDecorationsNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
NegOptions::optionGetWindowToggleKey ()
{
    return mOptions[NegOptions::WindowToggleKey].value ().action ();
}

inline void
NegOptions::optionSetWindowToggleKeyInitiate (CompAction::CallBack init)
{
    mOptions[NegOptions::WindowToggleKey].value ().action ().setInitiate (init);
}

inline void
NegOptions::optionSetWindowToggleKeyTerminate (CompAction::CallBack term)
{
    mOptions[NegOptions::WindowToggleKey].value ().action ().setTerminate (term);
}

inline void
NegOptions::optionSetWindowToggleKeyNotify (NegOptions::ChangeNotify notify)
{
    mNotify[NegOptions::WindowToggleKey] = notify;
}

inline bool
NegOptions::optionGetActivateAtStartup ()
{
    return mOptions[NegOptions::ActivateAtStartup].value ().b ();
}

inline void
NegOptions::optionSetActivateAtStartupNotify (NegOptions::ChangeNotify notify)
{
    mNotify[NegOptions::ActivateAtStartup] = notify;
}

inline CompAction &
NegOptions::optionGetScreenToggleKey ()
{
    return mOptions[NegOptions::ScreenToggleKey].value ().action ();
}

inline void
NegOptions::optionSetScreenToggleKeyInitiate (CompAction::CallBack init)
{
    mOptions[NegOptions::ScreenToggleKey].value ().action ().setInitiate (init);
}

inline void
NegOptions::optionSetScreenToggleKeyTerminate (CompAction::CallBack term)
{
    mOptions[NegOptions::ScreenToggleKey].value ().action ().setTerminate (term);
}

inline void
NegOptions::optionSetScreenToggleKeyNotify (NegOptions::ChangeNotify notify)
{
    mNotify[NegOptions::ScreenToggleKey] = notify;
}

inline CompMatch &
NegOptions::optionGetNegMatch ()
{
    return mOptions[NegOptions::NegMatch].value ().match ();
}

inline void
NegOptions::optionSetNegMatchNotify (NegOptions::ChangeNotify notify)
{
    mNotify[NegOptions::NegMatch] = notify;
}

inline CompMatch &
NegOptions::optionGetExcludeMatch ()
{
    return mOptions[NegOptions::ExcludeMatch].value ().match ();
}

inline void
NegOptions::optionSetExcludeMatchNotify (NegOptions::ChangeNotify notify)
{
    mNotify[NegOptions::ExcludeMatch] = notify;
}

inline bool
NegOptions::optionGetNegDecorations ()
{
    return mOptions[NegOptions::NegDecorations].value ().b ();
}

inline void
NegOptions::optionSetNegDecorationsNotify (NegOptions::ChangeNotify notify)
{
    mNotify[NegOptions::NegDecorations] = notify;
}



#endif
