/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _OPACIFY_OPTIONS_H
#define _OPACIFY_OPTIONS_H

#include <core/core.h>

class OpacifyOptions : public CompOption::Class {
    public:
        enum Options {
            ToggleKey,
            ToggleReset,
            Timeout,
            InitToggle,
            OnlyIfBlock,
            FocusInstant,
            NoDelayChange,
            WindowMatch,
            ActiveOpacity,
            PassiveOpacity,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        OpacifyOptions (bool init = true);
        virtual ~OpacifyOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetToggleKey ();
        void optionSetToggleKeyInitiate (CompAction::CallBack init);
        void optionSetToggleKeyTerminate (CompAction::CallBack term);
        void optionSetToggleKeyNotify (ChangeNotify notify);

        bool optionGetToggleReset ();
        void optionSetToggleResetNotify (ChangeNotify notify);

        int optionGetTimeout ();
        void optionSetTimeoutNotify (ChangeNotify notify);

        bool optionGetInitToggle ();
        void optionSetInitToggleNotify (ChangeNotify notify);

        bool optionGetOnlyIfBlock ();
        void optionSetOnlyIfBlockNotify (ChangeNotify notify);

        bool optionGetFocusInstant ();
        void optionSetFocusInstantNotify (ChangeNotify notify);

        bool optionGetNoDelayChange ();
        void optionSetNoDelayChangeNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        int optionGetActiveOpacity ();
        void optionSetActiveOpacityNotify (ChangeNotify notify);

        int optionGetPassiveOpacity ();
        void optionSetPassiveOpacityNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
OpacifyOptions::optionGetToggleKey ()
{
    return mOptions[OpacifyOptions::ToggleKey].value ().action ();
}

inline void
OpacifyOptions::optionSetToggleKeyInitiate (CompAction::CallBack init)
{
    mOptions[OpacifyOptions::ToggleKey].value ().action ().setInitiate (init);
}

inline void
OpacifyOptions::optionSetToggleKeyTerminate (CompAction::CallBack term)
{
    mOptions[OpacifyOptions::ToggleKey].value ().action ().setTerminate (term);
}

inline void
OpacifyOptions::optionSetToggleKeyNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::ToggleKey] = notify;
}

inline bool
OpacifyOptions::optionGetToggleReset ()
{
    return mOptions[OpacifyOptions::ToggleReset].value ().b ();
}

inline void
OpacifyOptions::optionSetToggleResetNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::ToggleReset] = notify;
}

inline int
OpacifyOptions::optionGetTimeout ()
{
    return mOptions[OpacifyOptions::Timeout].value ().i ();
}

inline void
OpacifyOptions::optionSetTimeoutNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::Timeout] = notify;
}

inline bool
OpacifyOptions::optionGetInitToggle ()
{
    return mOptions[OpacifyOptions::InitToggle].value ().b ();
}

inline void
OpacifyOptions::optionSetInitToggleNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::InitToggle] = notify;
}

inline bool
OpacifyOptions::optionGetOnlyIfBlock ()
{
    return mOptions[OpacifyOptions::OnlyIfBlock].value ().b ();
}

inline void
OpacifyOptions::optionSetOnlyIfBlockNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::OnlyIfBlock] = notify;
}

inline bool
OpacifyOptions::optionGetFocusInstant ()
{
    return mOptions[OpacifyOptions::FocusInstant].value ().b ();
}

inline void
OpacifyOptions::optionSetFocusInstantNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::FocusInstant] = notify;
}

inline bool
OpacifyOptions::optionGetNoDelayChange ()
{
    return mOptions[OpacifyOptions::NoDelayChange].value ().b ();
}

inline void
OpacifyOptions::optionSetNoDelayChangeNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::NoDelayChange] = notify;
}

inline CompMatch &
OpacifyOptions::optionGetWindowMatch ()
{
    return mOptions[OpacifyOptions::WindowMatch].value ().match ();
}

inline void
OpacifyOptions::optionSetWindowMatchNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::WindowMatch] = notify;
}

inline int
OpacifyOptions::optionGetActiveOpacity ()
{
    return mOptions[OpacifyOptions::ActiveOpacity].value ().i ();
}

inline void
OpacifyOptions::optionSetActiveOpacityNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::ActiveOpacity] = notify;
}

inline int
OpacifyOptions::optionGetPassiveOpacity ()
{
    return mOptions[OpacifyOptions::PassiveOpacity].value ().i ();
}

inline void
OpacifyOptions::optionSetPassiveOpacityNotify (OpacifyOptions::ChangeNotify notify)
{
    mNotify[OpacifyOptions::PassiveOpacity] = notify;
}



#endif
