/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _PLACE_OPTIONS_H
#define _PLACE_OPTIONS_H

#include <core/core.h>

class PlaceOptions : public CompOption::Class {
    public:
        enum Options {
            Workarounds,
            Mode,
            MultioutputMode,
            ForcePlacementMatch,
            PositionMatches,
            PositionXValues,
            PositionYValues,
            PositionConstrainWorkarea,
            ModeMatches,
            ModeModes,
            ViewportMatches,
            ViewportXValues,
            ViewportYValues,
            OptionNum
        };

        enum Mode {
            ModeCascade = 0,
            ModeCentered = 1,
            ModeSmart = 2,
            ModeMaximize = 3,
            ModeRandom = 4,
            ModePointer = 5,
        };

        enum MultioutputMode {
            MultioutputModeUseActiveOutputDevice = 0,
            MultioutputModeUseOutputDeviceWithPointer = 1,
            MultioutputModeUseOutputDeviceOfFocussedWindow = 2,
            MultioutputModePlaceAcrossAllOutputs = 3,
        };

        enum ModeModes {
            ModeModesCascade = 0,
            ModeModesCentered = 1,
            ModeModesSmart = 2,
            ModeModesMaximize = 3,
            ModeModesRandom = 4,
            ModeModesPointer = 5,
        };

        #define ModeModesCascadeMask (1 << 0)
        #define ModeModesCenteredMask (1 << 1)
        #define ModeModesSmartMask (1 << 2)
        #define ModeModesMaximizeMask (1 << 3)
        #define ModeModesRandomMask (1 << 4)
        #define ModeModesPointerMask (1 << 5)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        PlaceOptions (bool init = true);
        virtual ~PlaceOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        bool optionGetWorkarounds ();
        void optionSetWorkaroundsNotify (ChangeNotify notify);

        int optionGetMode ();
        void optionSetModeNotify (ChangeNotify notify);

        int optionGetMultioutputMode ();
        void optionSetMultioutputModeNotify (ChangeNotify notify);

        CompMatch & optionGetForcePlacementMatch ();
        void optionSetForcePlacementMatchNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPositionMatches ();
        void optionSetPositionMatchesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPositionXValues ();
        void optionSetPositionXValuesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPositionYValues ();
        void optionSetPositionYValuesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetPositionConstrainWorkarea ();
        void optionSetPositionConstrainWorkareaNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModeMatches ();
        void optionSetModeMatchesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModeModes ();
        unsigned int optionGetModeModesMask ();
        void optionSetModeModesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetViewportMatches ();
        void optionSetViewportMatchesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetViewportXValues ();
        void optionSetViewportXValuesNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetViewportYValues ();
        void optionSetViewportYValuesNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mModeModesMask;

};


inline bool
PlaceOptions::optionGetWorkarounds ()
{
    return mOptions[PlaceOptions::Workarounds].value ().b ();
}

inline void
PlaceOptions::optionSetWorkaroundsNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::Workarounds] = notify;
}

inline int
PlaceOptions::optionGetMode ()
{
    return mOptions[PlaceOptions::Mode].value ().i ();
}

inline void
PlaceOptions::optionSetModeNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::Mode] = notify;
}

inline int
PlaceOptions::optionGetMultioutputMode ()
{
    return mOptions[PlaceOptions::MultioutputMode].value ().i ();
}

inline void
PlaceOptions::optionSetMultioutputModeNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::MultioutputMode] = notify;
}

inline CompMatch &
PlaceOptions::optionGetForcePlacementMatch ()
{
    return mOptions[PlaceOptions::ForcePlacementMatch].value ().match ();
}

inline void
PlaceOptions::optionSetForcePlacementMatchNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::ForcePlacementMatch] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetPositionMatches ()
{
    return mOptions[PlaceOptions::PositionMatches].value ().list ();
}

inline void
PlaceOptions::optionSetPositionMatchesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::PositionMatches] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetPositionXValues ()
{
    return mOptions[PlaceOptions::PositionXValues].value ().list ();
}

inline void
PlaceOptions::optionSetPositionXValuesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::PositionXValues] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetPositionYValues ()
{
    return mOptions[PlaceOptions::PositionYValues].value ().list ();
}

inline void
PlaceOptions::optionSetPositionYValuesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::PositionYValues] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetPositionConstrainWorkarea ()
{
    return mOptions[PlaceOptions::PositionConstrainWorkarea].value ().list ();
}

inline void
PlaceOptions::optionSetPositionConstrainWorkareaNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::PositionConstrainWorkarea] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetModeMatches ()
{
    return mOptions[PlaceOptions::ModeMatches].value ().list ();
}

inline void
PlaceOptions::optionSetModeMatchesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::ModeMatches] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetModeModes ()
{
    return mOptions[PlaceOptions::ModeModes].value ().list ();
}

inline unsigned int
PlaceOptions::optionGetModeModesMask ()
{
    return mModeModesMask;
}

inline void
PlaceOptions::optionSetModeModesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::ModeModes] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetViewportMatches ()
{
    return mOptions[PlaceOptions::ViewportMatches].value ().list ();
}

inline void
PlaceOptions::optionSetViewportMatchesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::ViewportMatches] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetViewportXValues ()
{
    return mOptions[PlaceOptions::ViewportXValues].value ().list ();
}

inline void
PlaceOptions::optionSetViewportXValuesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::ViewportXValues] = notify;
}

inline CompOption::Value::Vector &
PlaceOptions::optionGetViewportYValues ()
{
    return mOptions[PlaceOptions::ViewportYValues].value ().list ();
}

inline void
PlaceOptions::optionSetViewportYValuesNotify (PlaceOptions::ChangeNotify notify)
{
    mNotify[PlaceOptions::ViewportYValues] = notify;
}



#endif
