/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _RESIZE_OPTIONS_H
#define _RESIZE_OPTIONS_H

#include <core/core.h>

class ResizeOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateButton,
            InitiateKey,
            Mode,
            ResizeFromCenter,
            MaximizeVertically,
            IncreaseBorderContrast,
            UseDesktopAverageColor,
            BorderColor,
            FillColor,
            DisableBlend,
            NormalMatch,
            OutlineMatch,
            RectangleMatch,
            StretchMatch,
            ResizeFromCenterMatch,
            OutlineModifier,
            RectangleModifier,
            StretchModifier,
            CenteredModifier,
            OptionNum
        };

        enum Mode {
            ModeNormal = 0,
            ModeOutline = 1,
            ModeRectangle = 2,
            ModeStretch = 3,
        };

        enum OutlineModifier {
            OutlineModifierShift = 0,
            OutlineModifierAlt = 1,
            OutlineModifierControl = 2,
            OutlineModifierMeta = 3,
        };

        enum RectangleModifier {
            RectangleModifierShift = 0,
            RectangleModifierAlt = 1,
            RectangleModifierControl = 2,
            RectangleModifierMeta = 3,
        };

        enum StretchModifier {
            StretchModifierShift = 0,
            StretchModifierAlt = 1,
            StretchModifierControl = 2,
            StretchModifierMeta = 3,
        };

        enum CenteredModifier {
            CenteredModifierShift = 0,
            CenteredModifierAlt = 1,
            CenteredModifierControl = 2,
            CenteredModifierMeta = 3,
        };

        #define OutlineModifierShiftMask (1 << 0)
        #define OutlineModifierAltMask (1 << 1)
        #define OutlineModifierControlMask (1 << 2)
        #define OutlineModifierMetaMask (1 << 3)


        #define RectangleModifierShiftMask (1 << 0)
        #define RectangleModifierAltMask (1 << 1)
        #define RectangleModifierControlMask (1 << 2)
        #define RectangleModifierMetaMask (1 << 3)


        #define StretchModifierShiftMask (1 << 0)
        #define StretchModifierAltMask (1 << 1)
        #define StretchModifierControlMask (1 << 2)
        #define StretchModifierMetaMask (1 << 3)


        #define CenteredModifierShiftMask (1 << 0)
        #define CenteredModifierAltMask (1 << 1)
        #define CenteredModifierControlMask (1 << 2)
        #define CenteredModifierMetaMask (1 << 3)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ResizeOptions (bool init = true);
        virtual ~ResizeOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        int optionGetMode ();
        void optionSetModeNotify (ChangeNotify notify);

        bool optionGetResizeFromCenter ();
        void optionSetResizeFromCenterNotify (ChangeNotify notify);

        bool optionGetMaximizeVertically ();
        void optionSetMaximizeVerticallyNotify (ChangeNotify notify);

        bool optionGetIncreaseBorderContrast ();
        void optionSetIncreaseBorderContrastNotify (ChangeNotify notify);

        bool optionGetUseDesktopAverageColor ();
        void optionSetUseDesktopAverageColorNotify (ChangeNotify notify);

        unsigned short * optionGetBorderColor ();
        unsigned short optionGetBorderColorRed ();
        unsigned short optionGetBorderColorGreen ();
        unsigned short optionGetBorderColorBlue ();
        unsigned short optionGetBorderColorAlpha ();
        void optionSetBorderColorNotify (ChangeNotify notify);

        unsigned short * optionGetFillColor ();
        unsigned short optionGetFillColorRed ();
        unsigned short optionGetFillColorGreen ();
        unsigned short optionGetFillColorBlue ();
        unsigned short optionGetFillColorAlpha ();
        void optionSetFillColorNotify (ChangeNotify notify);

        bool optionGetDisableBlend ();
        void optionSetDisableBlendNotify (ChangeNotify notify);

        CompMatch & optionGetNormalMatch ();
        void optionSetNormalMatchNotify (ChangeNotify notify);

        CompMatch & optionGetOutlineMatch ();
        void optionSetOutlineMatchNotify (ChangeNotify notify);

        CompMatch & optionGetRectangleMatch ();
        void optionSetRectangleMatchNotify (ChangeNotify notify);

        CompMatch & optionGetStretchMatch ();
        void optionSetStretchMatchNotify (ChangeNotify notify);

        CompMatch & optionGetResizeFromCenterMatch ();
        void optionSetResizeFromCenterMatchNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetOutlineModifier ();
        unsigned int optionGetOutlineModifierMask ();
        void optionSetOutlineModifierNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetRectangleModifier ();
        unsigned int optionGetRectangleModifierMask ();
        void optionSetRectangleModifierNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetStretchModifier ();
        unsigned int optionGetStretchModifierMask ();
        void optionSetStretchModifierNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetCenteredModifier ();
        unsigned int optionGetCenteredModifierMask ();
        void optionSetCenteredModifierNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mOutlineModifierMask;
        unsigned int mRectangleModifierMask;
        unsigned int mStretchModifierMask;
        unsigned int mCenteredModifierMask;

};


inline CompAction &
ResizeOptions::optionGetInitiateButton ()
{
    return mOptions[ResizeOptions::InitiateButton].value ().action ();
}

inline void
ResizeOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[ResizeOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
ResizeOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[ResizeOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
ResizeOptions::optionSetInitiateButtonNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::InitiateButton] = notify;
}

inline CompAction &
ResizeOptions::optionGetInitiateKey ()
{
    return mOptions[ResizeOptions::InitiateKey].value ().action ();
}

inline void
ResizeOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[ResizeOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
ResizeOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[ResizeOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
ResizeOptions::optionSetInitiateKeyNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::InitiateKey] = notify;
}

inline int
ResizeOptions::optionGetMode ()
{
    return mOptions[ResizeOptions::Mode].value ().i ();
}

inline void
ResizeOptions::optionSetModeNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::Mode] = notify;
}

inline bool
ResizeOptions::optionGetResizeFromCenter ()
{
    return mOptions[ResizeOptions::ResizeFromCenter].value ().b ();
}

inline void
ResizeOptions::optionSetResizeFromCenterNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::ResizeFromCenter] = notify;
}

inline bool
ResizeOptions::optionGetMaximizeVertically ()
{
    return mOptions[ResizeOptions::MaximizeVertically].value ().b ();
}

inline void
ResizeOptions::optionSetMaximizeVerticallyNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::MaximizeVertically] = notify;
}

inline bool
ResizeOptions::optionGetIncreaseBorderContrast ()
{
    return mOptions[ResizeOptions::IncreaseBorderContrast].value ().b ();
}

inline void
ResizeOptions::optionSetIncreaseBorderContrastNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::IncreaseBorderContrast] = notify;
}

inline bool
ResizeOptions::optionGetUseDesktopAverageColor ()
{
    return mOptions[ResizeOptions::UseDesktopAverageColor].value ().b ();
}

inline void
ResizeOptions::optionSetUseDesktopAverageColorNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::UseDesktopAverageColor] = notify;
}

inline unsigned short *
ResizeOptions::optionGetBorderColor ()
{
    return mOptions[ResizeOptions::BorderColor].value ().c ();
}

inline unsigned short
ResizeOptions::optionGetBorderColorRed ()
{
    return mOptions[ResizeOptions::BorderColor].value ().c ()[0];
}

inline unsigned short
ResizeOptions::optionGetBorderColorGreen ()
{
    return mOptions[ResizeOptions::BorderColor].value ().c ()[1];
}


inline unsigned short
ResizeOptions::optionGetBorderColorBlue ()
{
    return mOptions[ResizeOptions::BorderColor].value ().c ()[2];
}


inline unsigned short
ResizeOptions::optionGetBorderColorAlpha ()
{
    return mOptions[ResizeOptions::BorderColor].value ().c ()[3];
}


inline void
ResizeOptions::optionSetBorderColorNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::BorderColor] = notify;
}

inline unsigned short *
ResizeOptions::optionGetFillColor ()
{
    return mOptions[ResizeOptions::FillColor].value ().c ();
}

inline unsigned short
ResizeOptions::optionGetFillColorRed ()
{
    return mOptions[ResizeOptions::FillColor].value ().c ()[0];
}

inline unsigned short
ResizeOptions::optionGetFillColorGreen ()
{
    return mOptions[ResizeOptions::FillColor].value ().c ()[1];
}


inline unsigned short
ResizeOptions::optionGetFillColorBlue ()
{
    return mOptions[ResizeOptions::FillColor].value ().c ()[2];
}


inline unsigned short
ResizeOptions::optionGetFillColorAlpha ()
{
    return mOptions[ResizeOptions::FillColor].value ().c ()[3];
}


inline void
ResizeOptions::optionSetFillColorNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::FillColor] = notify;
}

inline bool
ResizeOptions::optionGetDisableBlend ()
{
    return mOptions[ResizeOptions::DisableBlend].value ().b ();
}

inline void
ResizeOptions::optionSetDisableBlendNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::DisableBlend] = notify;
}

inline CompMatch &
ResizeOptions::optionGetNormalMatch ()
{
    return mOptions[ResizeOptions::NormalMatch].value ().match ();
}

inline void
ResizeOptions::optionSetNormalMatchNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::NormalMatch] = notify;
}

inline CompMatch &
ResizeOptions::optionGetOutlineMatch ()
{
    return mOptions[ResizeOptions::OutlineMatch].value ().match ();
}

inline void
ResizeOptions::optionSetOutlineMatchNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::OutlineMatch] = notify;
}

inline CompMatch &
ResizeOptions::optionGetRectangleMatch ()
{
    return mOptions[ResizeOptions::RectangleMatch].value ().match ();
}

inline void
ResizeOptions::optionSetRectangleMatchNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::RectangleMatch] = notify;
}

inline CompMatch &
ResizeOptions::optionGetStretchMatch ()
{
    return mOptions[ResizeOptions::StretchMatch].value ().match ();
}

inline void
ResizeOptions::optionSetStretchMatchNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::StretchMatch] = notify;
}

inline CompMatch &
ResizeOptions::optionGetResizeFromCenterMatch ()
{
    return mOptions[ResizeOptions::ResizeFromCenterMatch].value ().match ();
}

inline void
ResizeOptions::optionSetResizeFromCenterMatchNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::ResizeFromCenterMatch] = notify;
}

inline CompOption::Value::Vector &
ResizeOptions::optionGetOutlineModifier ()
{
    return mOptions[ResizeOptions::OutlineModifier].value ().list ();
}

inline unsigned int
ResizeOptions::optionGetOutlineModifierMask ()
{
    return mOutlineModifierMask;
}

inline void
ResizeOptions::optionSetOutlineModifierNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::OutlineModifier] = notify;
}

inline CompOption::Value::Vector &
ResizeOptions::optionGetRectangleModifier ()
{
    return mOptions[ResizeOptions::RectangleModifier].value ().list ();
}

inline unsigned int
ResizeOptions::optionGetRectangleModifierMask ()
{
    return mRectangleModifierMask;
}

inline void
ResizeOptions::optionSetRectangleModifierNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::RectangleModifier] = notify;
}

inline CompOption::Value::Vector &
ResizeOptions::optionGetStretchModifier ()
{
    return mOptions[ResizeOptions::StretchModifier].value ().list ();
}

inline unsigned int
ResizeOptions::optionGetStretchModifierMask ()
{
    return mStretchModifierMask;
}

inline void
ResizeOptions::optionSetStretchModifierNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::StretchModifier] = notify;
}

inline CompOption::Value::Vector &
ResizeOptions::optionGetCenteredModifier ()
{
    return mOptions[ResizeOptions::CenteredModifier].value ().list ();
}

inline unsigned int
ResizeOptions::optionGetCenteredModifierMask ()
{
    return mCenteredModifierMask;
}

inline void
ResizeOptions::optionSetCenteredModifierNotify (ResizeOptions::ChangeNotify notify)
{
    mNotify[ResizeOptions::CenteredModifier] = notify;
}



#endif
