/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _RING_OPTIONS_H
#define _RING_OPTIONS_H

#include <core/core.h>

class RingOptions : public CompOption::Class {
    public:
        enum Options {
            NextKey,
            NextButton,
            PrevKey,
            PrevButton,
            NextAllKey,
            NextAllButton,
            PrevAllKey,
            PrevAllButton,
            NextGroupKey,
            NextGroupButton,
            PrevGroupKey,
            PrevGroupButton,
            WindowMatch,
            OverlayIcon,
            Speed,
            Timestep,
            InactiveOpacity,
            DarkenBack,
            Minimized,
            SelectWithMouse,
            RingClockwise,
            RingWidth,
            RingHeight,
            ThumbWidth,
            ThumbHeight,
            MinBrightness,
            MinScale,
            WindowTitle,
            TitleFontBold,
            TitleFontSize,
            TitleBackColor,
            TitleFontColor,
            TitleTextPlacement,
            VerticalOffset,
            OptionNum
        };

        enum OverlayIcon {
            OverlayIconNone = 0,
            OverlayIconEmblem = 1,
            OverlayIconBig = 2,
        };

        enum TitleTextPlacement {
            TitleTextPlacementCenteredOnScreen = 0,
            TitleTextPlacementTopOfScreenMinusOffset = 1,
            TitleTextPlacementBottomOfScreenPlusOffset = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        RingOptions (bool init = true);
        virtual ~RingOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetNextKey ();
        void optionSetNextKeyInitiate (CompAction::CallBack init);
        void optionSetNextKeyTerminate (CompAction::CallBack term);
        void optionSetNextKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextButton ();
        void optionSetNextButtonInitiate (CompAction::CallBack init);
        void optionSetNextButtonTerminate (CompAction::CallBack term);
        void optionSetNextButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevKey ();
        void optionSetPrevKeyInitiate (CompAction::CallBack init);
        void optionSetPrevKeyTerminate (CompAction::CallBack term);
        void optionSetPrevKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevButton ();
        void optionSetPrevButtonInitiate (CompAction::CallBack init);
        void optionSetPrevButtonTerminate (CompAction::CallBack term);
        void optionSetPrevButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextAllKey ();
        void optionSetNextAllKeyInitiate (CompAction::CallBack init);
        void optionSetNextAllKeyTerminate (CompAction::CallBack term);
        void optionSetNextAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextAllButton ();
        void optionSetNextAllButtonInitiate (CompAction::CallBack init);
        void optionSetNextAllButtonTerminate (CompAction::CallBack term);
        void optionSetNextAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevAllKey ();
        void optionSetPrevAllKeyInitiate (CompAction::CallBack init);
        void optionSetPrevAllKeyTerminate (CompAction::CallBack term);
        void optionSetPrevAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevAllButton ();
        void optionSetPrevAllButtonInitiate (CompAction::CallBack init);
        void optionSetPrevAllButtonTerminate (CompAction::CallBack term);
        void optionSetPrevAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextGroupKey ();
        void optionSetNextGroupKeyInitiate (CompAction::CallBack init);
        void optionSetNextGroupKeyTerminate (CompAction::CallBack term);
        void optionSetNextGroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextGroupButton ();
        void optionSetNextGroupButtonInitiate (CompAction::CallBack init);
        void optionSetNextGroupButtonTerminate (CompAction::CallBack term);
        void optionSetNextGroupButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevGroupKey ();
        void optionSetPrevGroupKeyInitiate (CompAction::CallBack init);
        void optionSetPrevGroupKeyTerminate (CompAction::CallBack term);
        void optionSetPrevGroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevGroupButton ();
        void optionSetPrevGroupButtonInitiate (CompAction::CallBack init);
        void optionSetPrevGroupButtonTerminate (CompAction::CallBack term);
        void optionSetPrevGroupButtonNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        int optionGetOverlayIcon ();
        void optionSetOverlayIconNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        int optionGetInactiveOpacity ();
        void optionSetInactiveOpacityNotify (ChangeNotify notify);

        bool optionGetDarkenBack ();
        void optionSetDarkenBackNotify (ChangeNotify notify);

        bool optionGetMinimized ();
        void optionSetMinimizedNotify (ChangeNotify notify);

        bool optionGetSelectWithMouse ();
        void optionSetSelectWithMouseNotify (ChangeNotify notify);

        bool optionGetRingClockwise ();
        void optionSetRingClockwiseNotify (ChangeNotify notify);

        int optionGetRingWidth ();
        void optionSetRingWidthNotify (ChangeNotify notify);

        int optionGetRingHeight ();
        void optionSetRingHeightNotify (ChangeNotify notify);

        int optionGetThumbWidth ();
        void optionSetThumbWidthNotify (ChangeNotify notify);

        int optionGetThumbHeight ();
        void optionSetThumbHeightNotify (ChangeNotify notify);

        float optionGetMinBrightness ();
        void optionSetMinBrightnessNotify (ChangeNotify notify);

        float optionGetMinScale ();
        void optionSetMinScaleNotify (ChangeNotify notify);

        bool optionGetWindowTitle ();
        void optionSetWindowTitleNotify (ChangeNotify notify);

        bool optionGetTitleFontBold ();
        void optionSetTitleFontBoldNotify (ChangeNotify notify);

        int optionGetTitleFontSize ();
        void optionSetTitleFontSizeNotify (ChangeNotify notify);

        unsigned short * optionGetTitleBackColor ();
        unsigned short optionGetTitleBackColorRed ();
        unsigned short optionGetTitleBackColorGreen ();
        unsigned short optionGetTitleBackColorBlue ();
        unsigned short optionGetTitleBackColorAlpha ();
        void optionSetTitleBackColorNotify (ChangeNotify notify);

        unsigned short * optionGetTitleFontColor ();
        unsigned short optionGetTitleFontColorRed ();
        unsigned short optionGetTitleFontColorGreen ();
        unsigned short optionGetTitleFontColorBlue ();
        unsigned short optionGetTitleFontColorAlpha ();
        void optionSetTitleFontColorNotify (ChangeNotify notify);

        int optionGetTitleTextPlacement ();
        void optionSetTitleTextPlacementNotify (ChangeNotify notify);

        int optionGetVerticalOffset ();
        void optionSetVerticalOffsetNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
RingOptions::optionGetNextKey ()
{
    return mOptions[RingOptions::NextKey].value ().action ();
}

inline void
RingOptions::optionSetNextKeyInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::NextKey].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetNextKeyTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::NextKey].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetNextKeyNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::NextKey] = notify;
}

inline CompAction &
RingOptions::optionGetNextButton ()
{
    return mOptions[RingOptions::NextButton].value ().action ();
}

inline void
RingOptions::optionSetNextButtonInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::NextButton].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetNextButtonTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::NextButton].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetNextButtonNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::NextButton] = notify;
}

inline CompAction &
RingOptions::optionGetPrevKey ()
{
    return mOptions[RingOptions::PrevKey].value ().action ();
}

inline void
RingOptions::optionSetPrevKeyInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::PrevKey].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetPrevKeyTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::PrevKey].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetPrevKeyNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::PrevKey] = notify;
}

inline CompAction &
RingOptions::optionGetPrevButton ()
{
    return mOptions[RingOptions::PrevButton].value ().action ();
}

inline void
RingOptions::optionSetPrevButtonInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::PrevButton].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetPrevButtonTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::PrevButton].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetPrevButtonNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::PrevButton] = notify;
}

inline CompAction &
RingOptions::optionGetNextAllKey ()
{
    return mOptions[RingOptions::NextAllKey].value ().action ();
}

inline void
RingOptions::optionSetNextAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::NextAllKey].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetNextAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::NextAllKey].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetNextAllKeyNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::NextAllKey] = notify;
}

inline CompAction &
RingOptions::optionGetNextAllButton ()
{
    return mOptions[RingOptions::NextAllButton].value ().action ();
}

inline void
RingOptions::optionSetNextAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::NextAllButton].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetNextAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::NextAllButton].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetNextAllButtonNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::NextAllButton] = notify;
}

inline CompAction &
RingOptions::optionGetPrevAllKey ()
{
    return mOptions[RingOptions::PrevAllKey].value ().action ();
}

inline void
RingOptions::optionSetPrevAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::PrevAllKey].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetPrevAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::PrevAllKey].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetPrevAllKeyNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::PrevAllKey] = notify;
}

inline CompAction &
RingOptions::optionGetPrevAllButton ()
{
    return mOptions[RingOptions::PrevAllButton].value ().action ();
}

inline void
RingOptions::optionSetPrevAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::PrevAllButton].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetPrevAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::PrevAllButton].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetPrevAllButtonNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::PrevAllButton] = notify;
}

inline CompAction &
RingOptions::optionGetNextGroupKey ()
{
    return mOptions[RingOptions::NextGroupKey].value ().action ();
}

inline void
RingOptions::optionSetNextGroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::NextGroupKey].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetNextGroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::NextGroupKey].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetNextGroupKeyNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::NextGroupKey] = notify;
}

inline CompAction &
RingOptions::optionGetNextGroupButton ()
{
    return mOptions[RingOptions::NextGroupButton].value ().action ();
}

inline void
RingOptions::optionSetNextGroupButtonInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::NextGroupButton].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetNextGroupButtonTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::NextGroupButton].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetNextGroupButtonNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::NextGroupButton] = notify;
}

inline CompAction &
RingOptions::optionGetPrevGroupKey ()
{
    return mOptions[RingOptions::PrevGroupKey].value ().action ();
}

inline void
RingOptions::optionSetPrevGroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::PrevGroupKey].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetPrevGroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::PrevGroupKey].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetPrevGroupKeyNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::PrevGroupKey] = notify;
}

inline CompAction &
RingOptions::optionGetPrevGroupButton ()
{
    return mOptions[RingOptions::PrevGroupButton].value ().action ();
}

inline void
RingOptions::optionSetPrevGroupButtonInitiate (CompAction::CallBack init)
{
    mOptions[RingOptions::PrevGroupButton].value ().action ().setInitiate (init);
}

inline void
RingOptions::optionSetPrevGroupButtonTerminate (CompAction::CallBack term)
{
    mOptions[RingOptions::PrevGroupButton].value ().action ().setTerminate (term);
}

inline void
RingOptions::optionSetPrevGroupButtonNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::PrevGroupButton] = notify;
}

inline CompMatch &
RingOptions::optionGetWindowMatch ()
{
    return mOptions[RingOptions::WindowMatch].value ().match ();
}

inline void
RingOptions::optionSetWindowMatchNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::WindowMatch] = notify;
}

inline int
RingOptions::optionGetOverlayIcon ()
{
    return mOptions[RingOptions::OverlayIcon].value ().i ();
}

inline void
RingOptions::optionSetOverlayIconNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::OverlayIcon] = notify;
}

inline float
RingOptions::optionGetSpeed ()
{
    return mOptions[RingOptions::Speed].value ().f ();
}

inline void
RingOptions::optionSetSpeedNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::Speed] = notify;
}

inline float
RingOptions::optionGetTimestep ()
{
    return mOptions[RingOptions::Timestep].value ().f ();
}

inline void
RingOptions::optionSetTimestepNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::Timestep] = notify;
}

inline int
RingOptions::optionGetInactiveOpacity ()
{
    return mOptions[RingOptions::InactiveOpacity].value ().i ();
}

inline void
RingOptions::optionSetInactiveOpacityNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::InactiveOpacity] = notify;
}

inline bool
RingOptions::optionGetDarkenBack ()
{
    return mOptions[RingOptions::DarkenBack].value ().b ();
}

inline void
RingOptions::optionSetDarkenBackNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::DarkenBack] = notify;
}

inline bool
RingOptions::optionGetMinimized ()
{
    return mOptions[RingOptions::Minimized].value ().b ();
}

inline void
RingOptions::optionSetMinimizedNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::Minimized] = notify;
}

inline bool
RingOptions::optionGetSelectWithMouse ()
{
    return mOptions[RingOptions::SelectWithMouse].value ().b ();
}

inline void
RingOptions::optionSetSelectWithMouseNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::SelectWithMouse] = notify;
}

inline bool
RingOptions::optionGetRingClockwise ()
{
    return mOptions[RingOptions::RingClockwise].value ().b ();
}

inline void
RingOptions::optionSetRingClockwiseNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::RingClockwise] = notify;
}

inline int
RingOptions::optionGetRingWidth ()
{
    return mOptions[RingOptions::RingWidth].value ().i ();
}

inline void
RingOptions::optionSetRingWidthNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::RingWidth] = notify;
}

inline int
RingOptions::optionGetRingHeight ()
{
    return mOptions[RingOptions::RingHeight].value ().i ();
}

inline void
RingOptions::optionSetRingHeightNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::RingHeight] = notify;
}

inline int
RingOptions::optionGetThumbWidth ()
{
    return mOptions[RingOptions::ThumbWidth].value ().i ();
}

inline void
RingOptions::optionSetThumbWidthNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::ThumbWidth] = notify;
}

inline int
RingOptions::optionGetThumbHeight ()
{
    return mOptions[RingOptions::ThumbHeight].value ().i ();
}

inline void
RingOptions::optionSetThumbHeightNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::ThumbHeight] = notify;
}

inline float
RingOptions::optionGetMinBrightness ()
{
    return mOptions[RingOptions::MinBrightness].value ().f ();
}

inline void
RingOptions::optionSetMinBrightnessNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::MinBrightness] = notify;
}

inline float
RingOptions::optionGetMinScale ()
{
    return mOptions[RingOptions::MinScale].value ().f ();
}

inline void
RingOptions::optionSetMinScaleNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::MinScale] = notify;
}

inline bool
RingOptions::optionGetWindowTitle ()
{
    return mOptions[RingOptions::WindowTitle].value ().b ();
}

inline void
RingOptions::optionSetWindowTitleNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::WindowTitle] = notify;
}

inline bool
RingOptions::optionGetTitleFontBold ()
{
    return mOptions[RingOptions::TitleFontBold].value ().b ();
}

inline void
RingOptions::optionSetTitleFontBoldNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::TitleFontBold] = notify;
}

inline int
RingOptions::optionGetTitleFontSize ()
{
    return mOptions[RingOptions::TitleFontSize].value ().i ();
}

inline void
RingOptions::optionSetTitleFontSizeNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::TitleFontSize] = notify;
}

inline unsigned short *
RingOptions::optionGetTitleBackColor ()
{
    return mOptions[RingOptions::TitleBackColor].value ().c ();
}

inline unsigned short
RingOptions::optionGetTitleBackColorRed ()
{
    return mOptions[RingOptions::TitleBackColor].value ().c ()[0];
}

inline unsigned short
RingOptions::optionGetTitleBackColorGreen ()
{
    return mOptions[RingOptions::TitleBackColor].value ().c ()[1];
}


inline unsigned short
RingOptions::optionGetTitleBackColorBlue ()
{
    return mOptions[RingOptions::TitleBackColor].value ().c ()[2];
}


inline unsigned short
RingOptions::optionGetTitleBackColorAlpha ()
{
    return mOptions[RingOptions::TitleBackColor].value ().c ()[3];
}


inline void
RingOptions::optionSetTitleBackColorNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::TitleBackColor] = notify;
}

inline unsigned short *
RingOptions::optionGetTitleFontColor ()
{
    return mOptions[RingOptions::TitleFontColor].value ().c ();
}

inline unsigned short
RingOptions::optionGetTitleFontColorRed ()
{
    return mOptions[RingOptions::TitleFontColor].value ().c ()[0];
}

inline unsigned short
RingOptions::optionGetTitleFontColorGreen ()
{
    return mOptions[RingOptions::TitleFontColor].value ().c ()[1];
}


inline unsigned short
RingOptions::optionGetTitleFontColorBlue ()
{
    return mOptions[RingOptions::TitleFontColor].value ().c ()[2];
}


inline unsigned short
RingOptions::optionGetTitleFontColorAlpha ()
{
    return mOptions[RingOptions::TitleFontColor].value ().c ()[3];
}


inline void
RingOptions::optionSetTitleFontColorNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::TitleFontColor] = notify;
}

inline int
RingOptions::optionGetTitleTextPlacement ()
{
    return mOptions[RingOptions::TitleTextPlacement].value ().i ();
}

inline void
RingOptions::optionSetTitleTextPlacementNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::TitleTextPlacement] = notify;
}

inline int
RingOptions::optionGetVerticalOffset ()
{
    return mOptions[RingOptions::VerticalOffset].value ().i ();
}

inline void
RingOptions::optionSetVerticalOffsetNotify (RingOptions::ChangeNotify notify)
{
    mNotify[RingOptions::VerticalOffset] = notify;
}



#endif
