/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SCALE_OPTIONS_H
#define _SCALE_OPTIONS_H

#include <core/core.h>

class ScaleOptions : public CompOption::Class {
    public:
        enum Options {
            Spacing,
            XOffset,
            YOffset,
            YBottomOffset,
            Speed,
            Timestep,
            DarkenBack,
            Opacity,
            OverlayIcon,
            WindowMatch,
            HoverTime,
            DndDistance,
            DndTimeoutSpinner,
            DndTimeoutSpinnerSpeed,
            MultioutputMode,
            SkipAnimation,
            KeyBindingsToggle,
            ButtonBindingsToggle,
            InitiateEdge,
            InitiateKey,
            InitiateButton,
            InitiateAllEdge,
            InitiateAllButton,
            InitiateAllKey,
            InitiateGroupEdge,
            InitiateGroupButton,
            InitiateGroupKey,
            InitiateOutputEdge,
            InitiateOutputButton,
            InitiateOutputKey,
            ClickOnDesktop,
            OptionNum
        };

        enum OverlayIcon {
            OverlayIconNone = 0,
            OverlayIconEmblem = 1,
            OverlayIconBig = 2,
        };

        enum MultioutputMode {
            MultioutputModeOnCurrentOutputDevice = 0,
            MultioutputModeOnAllOutputDevices = 1,
        };

        enum ClickOnDesktop {
            ClickOnDesktopNone = 0,
            ClickOnDesktopShowDesktop = 1,
            ClickOnDesktopTerminateScale = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ScaleOptions (bool init = true);
        virtual ~ScaleOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        int optionGetSpacing ();
        void optionSetSpacingNotify (ChangeNotify notify);

        int optionGetXOffset ();
        void optionSetXOffsetNotify (ChangeNotify notify);

        int optionGetYOffset ();
        void optionSetYOffsetNotify (ChangeNotify notify);

        int optionGetYBottomOffset ();
        void optionSetYBottomOffsetNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        bool optionGetDarkenBack ();
        void optionSetDarkenBackNotify (ChangeNotify notify);

        int optionGetOpacity ();
        void optionSetOpacityNotify (ChangeNotify notify);

        int optionGetOverlayIcon ();
        void optionSetOverlayIconNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        int optionGetHoverTime ();
        void optionSetHoverTimeNotify (ChangeNotify notify);

        int optionGetDndDistance ();
        void optionSetDndDistanceNotify (ChangeNotify notify);

        bool optionGetDndTimeoutSpinner ();
        void optionSetDndTimeoutSpinnerNotify (ChangeNotify notify);

        int optionGetDndTimeoutSpinnerSpeed ();
        void optionSetDndTimeoutSpinnerSpeedNotify (ChangeNotify notify);

        int optionGetMultioutputMode ();
        void optionSetMultioutputModeNotify (ChangeNotify notify);

        bool optionGetSkipAnimation ();
        void optionSetSkipAnimationNotify (ChangeNotify notify);

        bool optionGetKeyBindingsToggle ();
        void optionSetKeyBindingsToggleNotify (ChangeNotify notify);

        bool optionGetButtonBindingsToggle ();
        void optionSetButtonBindingsToggleNotify (ChangeNotify notify);

        CompAction & optionGetInitiateEdge ();
        void optionSetInitiateEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateEdgeNotify (ChangeNotify notify);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateAllEdge ();
        void optionSetInitiateAllEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateAllEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateAllEdgeNotify (ChangeNotify notify);

        CompAction & optionGetInitiateAllButton ();
        void optionSetInitiateAllButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateAllButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateAllKey ();
        void optionSetInitiateAllKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateAllKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetInitiateGroupEdge ();
        void optionSetInitiateGroupEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateGroupEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateGroupEdgeNotify (ChangeNotify notify);

        CompAction & optionGetInitiateGroupButton ();
        void optionSetInitiateGroupButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateGroupButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateGroupButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateGroupKey ();
        void optionSetInitiateGroupKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateGroupKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateGroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetInitiateOutputEdge ();
        void optionSetInitiateOutputEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateOutputEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateOutputEdgeNotify (ChangeNotify notify);

        CompAction & optionGetInitiateOutputButton ();
        void optionSetInitiateOutputButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateOutputButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateOutputButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateOutputKey ();
        void optionSetInitiateOutputKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateOutputKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateOutputKeyNotify (ChangeNotify notify);

        int optionGetClickOnDesktop ();
        void optionSetClickOnDesktopNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline int
ScaleOptions::optionGetSpacing ()
{
    return mOptions[ScaleOptions::Spacing].value ().i ();
}

inline void
ScaleOptions::optionSetSpacingNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::Spacing] = notify;
}

inline int
ScaleOptions::optionGetXOffset ()
{
    return mOptions[ScaleOptions::XOffset].value ().i ();
}

inline void
ScaleOptions::optionSetXOffsetNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::XOffset] = notify;
}

inline int
ScaleOptions::optionGetYOffset ()
{
    return mOptions[ScaleOptions::YOffset].value ().i ();
}

inline void
ScaleOptions::optionSetYOffsetNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::YOffset] = notify;
}

inline int
ScaleOptions::optionGetYBottomOffset ()
{
    return mOptions[ScaleOptions::YBottomOffset].value ().i ();
}

inline void
ScaleOptions::optionSetYBottomOffsetNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::YBottomOffset] = notify;
}

inline float
ScaleOptions::optionGetSpeed ()
{
    return mOptions[ScaleOptions::Speed].value ().f ();
}

inline void
ScaleOptions::optionSetSpeedNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::Speed] = notify;
}

inline float
ScaleOptions::optionGetTimestep ()
{
    return mOptions[ScaleOptions::Timestep].value ().f ();
}

inline void
ScaleOptions::optionSetTimestepNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::Timestep] = notify;
}

inline bool
ScaleOptions::optionGetDarkenBack ()
{
    return mOptions[ScaleOptions::DarkenBack].value ().b ();
}

inline void
ScaleOptions::optionSetDarkenBackNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::DarkenBack] = notify;
}

inline int
ScaleOptions::optionGetOpacity ()
{
    return mOptions[ScaleOptions::Opacity].value ().i ();
}

inline void
ScaleOptions::optionSetOpacityNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::Opacity] = notify;
}

inline int
ScaleOptions::optionGetOverlayIcon ()
{
    return mOptions[ScaleOptions::OverlayIcon].value ().i ();
}

inline void
ScaleOptions::optionSetOverlayIconNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::OverlayIcon] = notify;
}

inline CompMatch &
ScaleOptions::optionGetWindowMatch ()
{
    return mOptions[ScaleOptions::WindowMatch].value ().match ();
}

inline void
ScaleOptions::optionSetWindowMatchNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::WindowMatch] = notify;
}

inline int
ScaleOptions::optionGetHoverTime ()
{
    return mOptions[ScaleOptions::HoverTime].value ().i ();
}

inline void
ScaleOptions::optionSetHoverTimeNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::HoverTime] = notify;
}

inline int
ScaleOptions::optionGetDndDistance ()
{
    return mOptions[ScaleOptions::DndDistance].value ().i ();
}

inline void
ScaleOptions::optionSetDndDistanceNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::DndDistance] = notify;
}

inline bool
ScaleOptions::optionGetDndTimeoutSpinner ()
{
    return mOptions[ScaleOptions::DndTimeoutSpinner].value ().b ();
}

inline void
ScaleOptions::optionSetDndTimeoutSpinnerNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::DndTimeoutSpinner] = notify;
}

inline int
ScaleOptions::optionGetDndTimeoutSpinnerSpeed ()
{
    return mOptions[ScaleOptions::DndTimeoutSpinnerSpeed].value ().i ();
}

inline void
ScaleOptions::optionSetDndTimeoutSpinnerSpeedNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::DndTimeoutSpinnerSpeed] = notify;
}

inline int
ScaleOptions::optionGetMultioutputMode ()
{
    return mOptions[ScaleOptions::MultioutputMode].value ().i ();
}

inline void
ScaleOptions::optionSetMultioutputModeNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::MultioutputMode] = notify;
}

inline bool
ScaleOptions::optionGetSkipAnimation ()
{
    return mOptions[ScaleOptions::SkipAnimation].value ().b ();
}

inline void
ScaleOptions::optionSetSkipAnimationNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::SkipAnimation] = notify;
}

inline bool
ScaleOptions::optionGetKeyBindingsToggle ()
{
    return mOptions[ScaleOptions::KeyBindingsToggle].value ().b ();
}

inline void
ScaleOptions::optionSetKeyBindingsToggleNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::KeyBindingsToggle] = notify;
}

inline bool
ScaleOptions::optionGetButtonBindingsToggle ()
{
    return mOptions[ScaleOptions::ButtonBindingsToggle].value ().b ();
}

inline void
ScaleOptions::optionSetButtonBindingsToggleNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::ButtonBindingsToggle] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateEdge ()
{
    return mOptions[ScaleOptions::InitiateEdge].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateEdge].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateEdge].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateEdgeNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateEdge] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateKey ()
{
    return mOptions[ScaleOptions::InitiateKey].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateKeyNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateKey] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateButton ()
{
    return mOptions[ScaleOptions::InitiateButton].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateButtonNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateButton] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateAllEdge ()
{
    return mOptions[ScaleOptions::InitiateAllEdge].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateAllEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateAllEdge].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateAllEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateAllEdge].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateAllEdgeNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateAllEdge] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateAllButton ()
{
    return mOptions[ScaleOptions::InitiateAllButton].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateAllButton].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateAllButton].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateAllButtonNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateAllButton] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateAllKey ()
{
    return mOptions[ScaleOptions::InitiateAllKey].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateAllKey].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateAllKey].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateAllKeyNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateAllKey] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateGroupEdge ()
{
    return mOptions[ScaleOptions::InitiateGroupEdge].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateGroupEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateGroupEdge].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateGroupEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateGroupEdge].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateGroupEdgeNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateGroupEdge] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateGroupButton ()
{
    return mOptions[ScaleOptions::InitiateGroupButton].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateGroupButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateGroupButton].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateGroupButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateGroupButton].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateGroupButtonNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateGroupButton] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateGroupKey ()
{
    return mOptions[ScaleOptions::InitiateGroupKey].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateGroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateGroupKey].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateGroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateGroupKey].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateGroupKeyNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateGroupKey] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateOutputEdge ()
{
    return mOptions[ScaleOptions::InitiateOutputEdge].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateOutputEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateOutputEdge].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateOutputEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateOutputEdge].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateOutputEdgeNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateOutputEdge] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateOutputButton ()
{
    return mOptions[ScaleOptions::InitiateOutputButton].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateOutputButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateOutputButton].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateOutputButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateOutputButton].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateOutputButtonNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateOutputButton] = notify;
}

inline CompAction &
ScaleOptions::optionGetInitiateOutputKey ()
{
    return mOptions[ScaleOptions::InitiateOutputKey].value ().action ();
}

inline void
ScaleOptions::optionSetInitiateOutputKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleOptions::InitiateOutputKey].value ().action ().setInitiate (init);
}

inline void
ScaleOptions::optionSetInitiateOutputKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleOptions::InitiateOutputKey].value ().action ().setTerminate (term);
}

inline void
ScaleOptions::optionSetInitiateOutputKeyNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::InitiateOutputKey] = notify;
}

inline int
ScaleOptions::optionGetClickOnDesktop ()
{
    return mOptions[ScaleOptions::ClickOnDesktop].value ().i ();
}

inline void
ScaleOptions::optionSetClickOnDesktopNotify (ScaleOptions::ChangeNotify notify)
{
    mNotify[ScaleOptions::ClickOnDesktop] = notify;
}



#endif
