/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SCALEADDON_OPTIONS_H
#define _SCALEADDON_OPTIONS_H

#include <core/core.h>

class ScaleaddonOptions : public CompOption::Class {
    public:
        enum Options {
            CloseKey,
            CloseButton,
            PullKey,
            PullButton,
            ZoomKey,
            ZoomButton,
            WindowTitle,
            TitleBold,
            TitleSize,
            BorderSize,
            FontColor,
            BackColor,
            WindowHighlight,
            HighlightColor,
            LayoutMode,
            NaturalPrecision,
            ConstrainPullToScreen,
            ExitAfterPull,
            OptionNum
        };

        enum WindowTitle {
            WindowTitleNoDisplay = 0,
            WindowTitleHighlightedWindowOnly = 1,
            WindowTitleAllWindows = 2,
        };

        enum LayoutMode {
            LayoutModeNormal = 0,
            LayoutModeNatural = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ScaleaddonOptions (bool init = true);
        virtual ~ScaleaddonOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetCloseKey ();
        void optionSetCloseKeyInitiate (CompAction::CallBack init);
        void optionSetCloseKeyTerminate (CompAction::CallBack term);
        void optionSetCloseKeyNotify (ChangeNotify notify);

        CompAction & optionGetCloseButton ();
        void optionSetCloseButtonInitiate (CompAction::CallBack init);
        void optionSetCloseButtonTerminate (CompAction::CallBack term);
        void optionSetCloseButtonNotify (ChangeNotify notify);

        CompAction & optionGetPullKey ();
        void optionSetPullKeyInitiate (CompAction::CallBack init);
        void optionSetPullKeyTerminate (CompAction::CallBack term);
        void optionSetPullKeyNotify (ChangeNotify notify);

        CompAction & optionGetPullButton ();
        void optionSetPullButtonInitiate (CompAction::CallBack init);
        void optionSetPullButtonTerminate (CompAction::CallBack term);
        void optionSetPullButtonNotify (ChangeNotify notify);

        CompAction & optionGetZoomKey ();
        void optionSetZoomKeyInitiate (CompAction::CallBack init);
        void optionSetZoomKeyTerminate (CompAction::CallBack term);
        void optionSetZoomKeyNotify (ChangeNotify notify);

        CompAction & optionGetZoomButton ();
        void optionSetZoomButtonInitiate (CompAction::CallBack init);
        void optionSetZoomButtonTerminate (CompAction::CallBack term);
        void optionSetZoomButtonNotify (ChangeNotify notify);

        int optionGetWindowTitle ();
        void optionSetWindowTitleNotify (ChangeNotify notify);

        bool optionGetTitleBold ();
        void optionSetTitleBoldNotify (ChangeNotify notify);

        int optionGetTitleSize ();
        void optionSetTitleSizeNotify (ChangeNotify notify);

        int optionGetBorderSize ();
        void optionSetBorderSizeNotify (ChangeNotify notify);

        unsigned short * optionGetFontColor ();
        unsigned short optionGetFontColorRed ();
        unsigned short optionGetFontColorGreen ();
        unsigned short optionGetFontColorBlue ();
        unsigned short optionGetFontColorAlpha ();
        void optionSetFontColorNotify (ChangeNotify notify);

        unsigned short * optionGetBackColor ();
        unsigned short optionGetBackColorRed ();
        unsigned short optionGetBackColorGreen ();
        unsigned short optionGetBackColorBlue ();
        unsigned short optionGetBackColorAlpha ();
        void optionSetBackColorNotify (ChangeNotify notify);

        bool optionGetWindowHighlight ();
        void optionSetWindowHighlightNotify (ChangeNotify notify);

        unsigned short * optionGetHighlightColor ();
        unsigned short optionGetHighlightColorRed ();
        unsigned short optionGetHighlightColorGreen ();
        unsigned short optionGetHighlightColorBlue ();
        unsigned short optionGetHighlightColorAlpha ();
        void optionSetHighlightColorNotify (ChangeNotify notify);

        int optionGetLayoutMode ();
        void optionSetLayoutModeNotify (ChangeNotify notify);

        float optionGetNaturalPrecision ();
        void optionSetNaturalPrecisionNotify (ChangeNotify notify);

        bool optionGetConstrainPullToScreen ();
        void optionSetConstrainPullToScreenNotify (ChangeNotify notify);

        bool optionGetExitAfterPull ();
        void optionSetExitAfterPullNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
ScaleaddonOptions::optionGetCloseKey ()
{
    return mOptions[ScaleaddonOptions::CloseKey].value ().action ();
}

inline void
ScaleaddonOptions::optionSetCloseKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleaddonOptions::CloseKey].value ().action ().setInitiate (init);
}

inline void
ScaleaddonOptions::optionSetCloseKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleaddonOptions::CloseKey].value ().action ().setTerminate (term);
}

inline void
ScaleaddonOptions::optionSetCloseKeyNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::CloseKey] = notify;
}

inline CompAction &
ScaleaddonOptions::optionGetCloseButton ()
{
    return mOptions[ScaleaddonOptions::CloseButton].value ().action ();
}

inline void
ScaleaddonOptions::optionSetCloseButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleaddonOptions::CloseButton].value ().action ().setInitiate (init);
}

inline void
ScaleaddonOptions::optionSetCloseButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleaddonOptions::CloseButton].value ().action ().setTerminate (term);
}

inline void
ScaleaddonOptions::optionSetCloseButtonNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::CloseButton] = notify;
}

inline CompAction &
ScaleaddonOptions::optionGetPullKey ()
{
    return mOptions[ScaleaddonOptions::PullKey].value ().action ();
}

inline void
ScaleaddonOptions::optionSetPullKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleaddonOptions::PullKey].value ().action ().setInitiate (init);
}

inline void
ScaleaddonOptions::optionSetPullKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleaddonOptions::PullKey].value ().action ().setTerminate (term);
}

inline void
ScaleaddonOptions::optionSetPullKeyNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::PullKey] = notify;
}

inline CompAction &
ScaleaddonOptions::optionGetPullButton ()
{
    return mOptions[ScaleaddonOptions::PullButton].value ().action ();
}

inline void
ScaleaddonOptions::optionSetPullButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleaddonOptions::PullButton].value ().action ().setInitiate (init);
}

inline void
ScaleaddonOptions::optionSetPullButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleaddonOptions::PullButton].value ().action ().setTerminate (term);
}

inline void
ScaleaddonOptions::optionSetPullButtonNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::PullButton] = notify;
}

inline CompAction &
ScaleaddonOptions::optionGetZoomKey ()
{
    return mOptions[ScaleaddonOptions::ZoomKey].value ().action ();
}

inline void
ScaleaddonOptions::optionSetZoomKeyInitiate (CompAction::CallBack init)
{
    mOptions[ScaleaddonOptions::ZoomKey].value ().action ().setInitiate (init);
}

inline void
ScaleaddonOptions::optionSetZoomKeyTerminate (CompAction::CallBack term)
{
    mOptions[ScaleaddonOptions::ZoomKey].value ().action ().setTerminate (term);
}

inline void
ScaleaddonOptions::optionSetZoomKeyNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::ZoomKey] = notify;
}

inline CompAction &
ScaleaddonOptions::optionGetZoomButton ()
{
    return mOptions[ScaleaddonOptions::ZoomButton].value ().action ();
}

inline void
ScaleaddonOptions::optionSetZoomButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScaleaddonOptions::ZoomButton].value ().action ().setInitiate (init);
}

inline void
ScaleaddonOptions::optionSetZoomButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScaleaddonOptions::ZoomButton].value ().action ().setTerminate (term);
}

inline void
ScaleaddonOptions::optionSetZoomButtonNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::ZoomButton] = notify;
}

inline int
ScaleaddonOptions::optionGetWindowTitle ()
{
    return mOptions[ScaleaddonOptions::WindowTitle].value ().i ();
}

inline void
ScaleaddonOptions::optionSetWindowTitleNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::WindowTitle] = notify;
}

inline bool
ScaleaddonOptions::optionGetTitleBold ()
{
    return mOptions[ScaleaddonOptions::TitleBold].value ().b ();
}

inline void
ScaleaddonOptions::optionSetTitleBoldNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::TitleBold] = notify;
}

inline int
ScaleaddonOptions::optionGetTitleSize ()
{
    return mOptions[ScaleaddonOptions::TitleSize].value ().i ();
}

inline void
ScaleaddonOptions::optionSetTitleSizeNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::TitleSize] = notify;
}

inline int
ScaleaddonOptions::optionGetBorderSize ()
{
    return mOptions[ScaleaddonOptions::BorderSize].value ().i ();
}

inline void
ScaleaddonOptions::optionSetBorderSizeNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::BorderSize] = notify;
}

inline unsigned short *
ScaleaddonOptions::optionGetFontColor ()
{
    return mOptions[ScaleaddonOptions::FontColor].value ().c ();
}

inline unsigned short
ScaleaddonOptions::optionGetFontColorRed ()
{
    return mOptions[ScaleaddonOptions::FontColor].value ().c ()[0];
}

inline unsigned short
ScaleaddonOptions::optionGetFontColorGreen ()
{
    return mOptions[ScaleaddonOptions::FontColor].value ().c ()[1];
}


inline unsigned short
ScaleaddonOptions::optionGetFontColorBlue ()
{
    return mOptions[ScaleaddonOptions::FontColor].value ().c ()[2];
}


inline unsigned short
ScaleaddonOptions::optionGetFontColorAlpha ()
{
    return mOptions[ScaleaddonOptions::FontColor].value ().c ()[3];
}


inline void
ScaleaddonOptions::optionSetFontColorNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::FontColor] = notify;
}

inline unsigned short *
ScaleaddonOptions::optionGetBackColor ()
{
    return mOptions[ScaleaddonOptions::BackColor].value ().c ();
}

inline unsigned short
ScaleaddonOptions::optionGetBackColorRed ()
{
    return mOptions[ScaleaddonOptions::BackColor].value ().c ()[0];
}

inline unsigned short
ScaleaddonOptions::optionGetBackColorGreen ()
{
    return mOptions[ScaleaddonOptions::BackColor].value ().c ()[1];
}


inline unsigned short
ScaleaddonOptions::optionGetBackColorBlue ()
{
    return mOptions[ScaleaddonOptions::BackColor].value ().c ()[2];
}


inline unsigned short
ScaleaddonOptions::optionGetBackColorAlpha ()
{
    return mOptions[ScaleaddonOptions::BackColor].value ().c ()[3];
}


inline void
ScaleaddonOptions::optionSetBackColorNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::BackColor] = notify;
}

inline bool
ScaleaddonOptions::optionGetWindowHighlight ()
{
    return mOptions[ScaleaddonOptions::WindowHighlight].value ().b ();
}

inline void
ScaleaddonOptions::optionSetWindowHighlightNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::WindowHighlight] = notify;
}

inline unsigned short *
ScaleaddonOptions::optionGetHighlightColor ()
{
    return mOptions[ScaleaddonOptions::HighlightColor].value ().c ();
}

inline unsigned short
ScaleaddonOptions::optionGetHighlightColorRed ()
{
    return mOptions[ScaleaddonOptions::HighlightColor].value ().c ()[0];
}

inline unsigned short
ScaleaddonOptions::optionGetHighlightColorGreen ()
{
    return mOptions[ScaleaddonOptions::HighlightColor].value ().c ()[1];
}


inline unsigned short
ScaleaddonOptions::optionGetHighlightColorBlue ()
{
    return mOptions[ScaleaddonOptions::HighlightColor].value ().c ()[2];
}


inline unsigned short
ScaleaddonOptions::optionGetHighlightColorAlpha ()
{
    return mOptions[ScaleaddonOptions::HighlightColor].value ().c ()[3];
}


inline void
ScaleaddonOptions::optionSetHighlightColorNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::HighlightColor] = notify;
}

inline int
ScaleaddonOptions::optionGetLayoutMode ()
{
    return mOptions[ScaleaddonOptions::LayoutMode].value ().i ();
}

inline void
ScaleaddonOptions::optionSetLayoutModeNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::LayoutMode] = notify;
}

inline float
ScaleaddonOptions::optionGetNaturalPrecision ()
{
    return mOptions[ScaleaddonOptions::NaturalPrecision].value ().f ();
}

inline void
ScaleaddonOptions::optionSetNaturalPrecisionNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::NaturalPrecision] = notify;
}

inline bool
ScaleaddonOptions::optionGetConstrainPullToScreen ()
{
    return mOptions[ScaleaddonOptions::ConstrainPullToScreen].value ().b ();
}

inline void
ScaleaddonOptions::optionSetConstrainPullToScreenNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::ConstrainPullToScreen] = notify;
}

inline bool
ScaleaddonOptions::optionGetExitAfterPull ()
{
    return mOptions[ScaleaddonOptions::ExitAfterPull].value ().b ();
}

inline void
ScaleaddonOptions::optionSetExitAfterPullNotify (ScaleaddonOptions::ChangeNotify notify)
{
    mNotify[ScaleaddonOptions::ExitAfterPull] = notify;
}



#endif
