/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SCREENSHOT_OPTIONS_H
#define _SCREENSHOT_OPTIONS_H

#include <core/core.h>

class ScreenshotOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateButton,
            DrawSelectionIndicator,
            SelectionOutlineColor,
            SelectionFillColor,
            Directory,
            LaunchApp,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ScreenshotOptions (bool init = true);
        virtual ~ScreenshotOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        bool optionGetDrawSelectionIndicator ();
        void optionSetDrawSelectionIndicatorNotify (ChangeNotify notify);

        unsigned short * optionGetSelectionOutlineColor ();
        unsigned short optionGetSelectionOutlineColorRed ();
        unsigned short optionGetSelectionOutlineColorGreen ();
        unsigned short optionGetSelectionOutlineColorBlue ();
        unsigned short optionGetSelectionOutlineColorAlpha ();
        void optionSetSelectionOutlineColorNotify (ChangeNotify notify);

        unsigned short * optionGetSelectionFillColor ();
        unsigned short optionGetSelectionFillColorRed ();
        unsigned short optionGetSelectionFillColorGreen ();
        unsigned short optionGetSelectionFillColorBlue ();
        unsigned short optionGetSelectionFillColorAlpha ();
        void optionSetSelectionFillColorNotify (ChangeNotify notify);

        CompString optionGetDirectory ();
        void optionSetDirectoryNotify (ChangeNotify notify);

        CompString optionGetLaunchApp ();
        void optionSetLaunchAppNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
ScreenshotOptions::optionGetInitiateButton ()
{
    return mOptions[ScreenshotOptions::InitiateButton].value ().action ();
}

inline void
ScreenshotOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[ScreenshotOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
ScreenshotOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[ScreenshotOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
ScreenshotOptions::optionSetInitiateButtonNotify (ScreenshotOptions::ChangeNotify notify)
{
    mNotify[ScreenshotOptions::InitiateButton] = notify;
}

inline bool
ScreenshotOptions::optionGetDrawSelectionIndicator ()
{
    return mOptions[ScreenshotOptions::DrawSelectionIndicator].value ().b ();
}

inline void
ScreenshotOptions::optionSetDrawSelectionIndicatorNotify (ScreenshotOptions::ChangeNotify notify)
{
    mNotify[ScreenshotOptions::DrawSelectionIndicator] = notify;
}

inline unsigned short *
ScreenshotOptions::optionGetSelectionOutlineColor ()
{
    return mOptions[ScreenshotOptions::SelectionOutlineColor].value ().c ();
}

inline unsigned short
ScreenshotOptions::optionGetSelectionOutlineColorRed ()
{
    return mOptions[ScreenshotOptions::SelectionOutlineColor].value ().c ()[0];
}

inline unsigned short
ScreenshotOptions::optionGetSelectionOutlineColorGreen ()
{
    return mOptions[ScreenshotOptions::SelectionOutlineColor].value ().c ()[1];
}


inline unsigned short
ScreenshotOptions::optionGetSelectionOutlineColorBlue ()
{
    return mOptions[ScreenshotOptions::SelectionOutlineColor].value ().c ()[2];
}


inline unsigned short
ScreenshotOptions::optionGetSelectionOutlineColorAlpha ()
{
    return mOptions[ScreenshotOptions::SelectionOutlineColor].value ().c ()[3];
}


inline void
ScreenshotOptions::optionSetSelectionOutlineColorNotify (ScreenshotOptions::ChangeNotify notify)
{
    mNotify[ScreenshotOptions::SelectionOutlineColor] = notify;
}

inline unsigned short *
ScreenshotOptions::optionGetSelectionFillColor ()
{
    return mOptions[ScreenshotOptions::SelectionFillColor].value ().c ();
}

inline unsigned short
ScreenshotOptions::optionGetSelectionFillColorRed ()
{
    return mOptions[ScreenshotOptions::SelectionFillColor].value ().c ()[0];
}

inline unsigned short
ScreenshotOptions::optionGetSelectionFillColorGreen ()
{
    return mOptions[ScreenshotOptions::SelectionFillColor].value ().c ()[1];
}


inline unsigned short
ScreenshotOptions::optionGetSelectionFillColorBlue ()
{
    return mOptions[ScreenshotOptions::SelectionFillColor].value ().c ()[2];
}


inline unsigned short
ScreenshotOptions::optionGetSelectionFillColorAlpha ()
{
    return mOptions[ScreenshotOptions::SelectionFillColor].value ().c ()[3];
}


inline void
ScreenshotOptions::optionSetSelectionFillColorNotify (ScreenshotOptions::ChangeNotify notify)
{
    mNotify[ScreenshotOptions::SelectionFillColor] = notify;
}

inline CompString
ScreenshotOptions::optionGetDirectory ()
{
    return mOptions[ScreenshotOptions::Directory].value ().s ();
}

inline void
ScreenshotOptions::optionSetDirectoryNotify (ScreenshotOptions::ChangeNotify notify)
{
    mNotify[ScreenshotOptions::Directory] = notify;
}

inline CompString
ScreenshotOptions::optionGetLaunchApp ()
{
    return mOptions[ScreenshotOptions::LaunchApp].value ().s ();
}

inline void
ScreenshotOptions::optionSetLaunchAppNotify (ScreenshotOptions::ChangeNotify notify)
{
    mNotify[ScreenshotOptions::LaunchApp] = notify;
}



#endif
