/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SHIFT_OPTIONS_H
#define _SHIFT_OPTIONS_H

#include <core/core.h>

class ShiftOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateKey,
            InitiateButton,
            InitiateEdge,
            InitiateAllKey,
            InitiateAllButton,
            InitiateAllEdge,
            NextKey,
            NextButton,
            PrevKey,
            PrevButton,
            NextAllKey,
            NextAllButton,
            PrevAllKey,
            PrevAllButton,
            NextGroupKey,
            NextGroupButton,
            PrevGroupKey,
            PrevGroupButton,
            WindowMatch,
            Minimized,
            Speed,
            ShiftSpeed,
            Timestep,
            MouseSpeed,
            ClickDuration,
            Size,
            BackgroundIntensity,
            HideAll,
            Reflection,
            GroundColor1,
            GroundColor2,
            GroundSize,
            Intensity,
            OverlayIcon,
            Mipmaps,
            MultioutputMode,
            Mode,
            FlipRotation,
            CoverOffset,
            CoverAngle,
            CoverExtraSpace,
            CoverMaxVisibleWindows,
            WindowTitle,
            TitleFontBold,
            TitleFontSize,
            TitleBackColor,
            TitleFontColor,
            TitleTextPlacement,
            VerticalOffset,
            OptionNum
        };

        enum OverlayIcon {
            OverlayIconNone = 0,
            OverlayIconEmblem = 1,
            OverlayIconBig = 2,
        };

        enum MultioutputMode {
            MultioutputModeDisabled = 0,
            MultioutputModeOnActivatedOutput = 1,
            MultioutputModeOneBigSwitcher = 2,
        };

        enum Mode {
            ModeCover = 0,
            ModeFlip = 1,
        };

        enum TitleTextPlacement {
            TitleTextPlacementCenteredOnScreen = 0,
            TitleTextPlacementTopOfScreenMinusOffset = 1,
            TitleTextPlacementBottomOfScreenPlusOffset = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ShiftOptions (bool init = true);
        virtual ~ShiftOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateEdge ();
        void optionSetInitiateEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateEdgeNotify (ChangeNotify notify);

        CompAction & optionGetInitiateAllKey ();
        void optionSetInitiateAllKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateAllKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetInitiateAllButton ();
        void optionSetInitiateAllButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateAllButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateAllEdge ();
        void optionSetInitiateAllEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateAllEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateAllEdgeNotify (ChangeNotify notify);

        CompAction & optionGetNextKey ();
        void optionSetNextKeyInitiate (CompAction::CallBack init);
        void optionSetNextKeyTerminate (CompAction::CallBack term);
        void optionSetNextKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextButton ();
        void optionSetNextButtonInitiate (CompAction::CallBack init);
        void optionSetNextButtonTerminate (CompAction::CallBack term);
        void optionSetNextButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevKey ();
        void optionSetPrevKeyInitiate (CompAction::CallBack init);
        void optionSetPrevKeyTerminate (CompAction::CallBack term);
        void optionSetPrevKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevButton ();
        void optionSetPrevButtonInitiate (CompAction::CallBack init);
        void optionSetPrevButtonTerminate (CompAction::CallBack term);
        void optionSetPrevButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextAllKey ();
        void optionSetNextAllKeyInitiate (CompAction::CallBack init);
        void optionSetNextAllKeyTerminate (CompAction::CallBack term);
        void optionSetNextAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextAllButton ();
        void optionSetNextAllButtonInitiate (CompAction::CallBack init);
        void optionSetNextAllButtonTerminate (CompAction::CallBack term);
        void optionSetNextAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevAllKey ();
        void optionSetPrevAllKeyInitiate (CompAction::CallBack init);
        void optionSetPrevAllKeyTerminate (CompAction::CallBack term);
        void optionSetPrevAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevAllButton ();
        void optionSetPrevAllButtonInitiate (CompAction::CallBack init);
        void optionSetPrevAllButtonTerminate (CompAction::CallBack term);
        void optionSetPrevAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextGroupKey ();
        void optionSetNextGroupKeyInitiate (CompAction::CallBack init);
        void optionSetNextGroupKeyTerminate (CompAction::CallBack term);
        void optionSetNextGroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextGroupButton ();
        void optionSetNextGroupButtonInitiate (CompAction::CallBack init);
        void optionSetNextGroupButtonTerminate (CompAction::CallBack term);
        void optionSetNextGroupButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevGroupKey ();
        void optionSetPrevGroupKeyInitiate (CompAction::CallBack init);
        void optionSetPrevGroupKeyTerminate (CompAction::CallBack term);
        void optionSetPrevGroupKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevGroupButton ();
        void optionSetPrevGroupButtonInitiate (CompAction::CallBack init);
        void optionSetPrevGroupButtonTerminate (CompAction::CallBack term);
        void optionSetPrevGroupButtonNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        bool optionGetMinimized ();
        void optionSetMinimizedNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetShiftSpeed ();
        void optionSetShiftSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        float optionGetMouseSpeed ();
        void optionSetMouseSpeedNotify (ChangeNotify notify);

        int optionGetClickDuration ();
        void optionSetClickDurationNotify (ChangeNotify notify);

        int optionGetSize ();
        void optionSetSizeNotify (ChangeNotify notify);

        float optionGetBackgroundIntensity ();
        void optionSetBackgroundIntensityNotify (ChangeNotify notify);

        bool optionGetHideAll ();
        void optionSetHideAllNotify (ChangeNotify notify);

        bool optionGetReflection ();
        void optionSetReflectionNotify (ChangeNotify notify);

        unsigned short * optionGetGroundColor1 ();
        unsigned short optionGetGroundColor1Red ();
        unsigned short optionGetGroundColor1Green ();
        unsigned short optionGetGroundColor1Blue ();
        unsigned short optionGetGroundColor1Alpha ();
        void optionSetGroundColor1Notify (ChangeNotify notify);

        unsigned short * optionGetGroundColor2 ();
        unsigned short optionGetGroundColor2Red ();
        unsigned short optionGetGroundColor2Green ();
        unsigned short optionGetGroundColor2Blue ();
        unsigned short optionGetGroundColor2Alpha ();
        void optionSetGroundColor2Notify (ChangeNotify notify);

        float optionGetGroundSize ();
        void optionSetGroundSizeNotify (ChangeNotify notify);

        float optionGetIntensity ();
        void optionSetIntensityNotify (ChangeNotify notify);

        int optionGetOverlayIcon ();
        void optionSetOverlayIconNotify (ChangeNotify notify);

        bool optionGetMipmaps ();
        void optionSetMipmapsNotify (ChangeNotify notify);

        int optionGetMultioutputMode ();
        void optionSetMultioutputModeNotify (ChangeNotify notify);

        int optionGetMode ();
        void optionSetModeNotify (ChangeNotify notify);

        int optionGetFlipRotation ();
        void optionSetFlipRotationNotify (ChangeNotify notify);

        float optionGetCoverOffset ();
        void optionSetCoverOffsetNotify (ChangeNotify notify);

        float optionGetCoverAngle ();
        void optionSetCoverAngleNotify (ChangeNotify notify);

        float optionGetCoverExtraSpace ();
        void optionSetCoverExtraSpaceNotify (ChangeNotify notify);

        int optionGetCoverMaxVisibleWindows ();
        void optionSetCoverMaxVisibleWindowsNotify (ChangeNotify notify);

        bool optionGetWindowTitle ();
        void optionSetWindowTitleNotify (ChangeNotify notify);

        bool optionGetTitleFontBold ();
        void optionSetTitleFontBoldNotify (ChangeNotify notify);

        int optionGetTitleFontSize ();
        void optionSetTitleFontSizeNotify (ChangeNotify notify);

        unsigned short * optionGetTitleBackColor ();
        unsigned short optionGetTitleBackColorRed ();
        unsigned short optionGetTitleBackColorGreen ();
        unsigned short optionGetTitleBackColorBlue ();
        unsigned short optionGetTitleBackColorAlpha ();
        void optionSetTitleBackColorNotify (ChangeNotify notify);

        unsigned short * optionGetTitleFontColor ();
        unsigned short optionGetTitleFontColorRed ();
        unsigned short optionGetTitleFontColorGreen ();
        unsigned short optionGetTitleFontColorBlue ();
        unsigned short optionGetTitleFontColorAlpha ();
        void optionSetTitleFontColorNotify (ChangeNotify notify);

        int optionGetTitleTextPlacement ();
        void optionSetTitleTextPlacementNotify (ChangeNotify notify);

        int optionGetVerticalOffset ();
        void optionSetVerticalOffsetNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
ShiftOptions::optionGetInitiateKey ()
{
    return mOptions[ShiftOptions::InitiateKey].value ().action ();
}

inline void
ShiftOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetInitiateKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::InitiateKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetInitiateButton ()
{
    return mOptions[ShiftOptions::InitiateButton].value ().action ();
}

inline void
ShiftOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetInitiateButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::InitiateButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetInitiateEdge ()
{
    return mOptions[ShiftOptions::InitiateEdge].value ().action ();
}

inline void
ShiftOptions::optionSetInitiateEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::InitiateEdge].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetInitiateEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::InitiateEdge].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetInitiateEdgeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::InitiateEdge] = notify;
}

inline CompAction &
ShiftOptions::optionGetInitiateAllKey ()
{
    return mOptions[ShiftOptions::InitiateAllKey].value ().action ();
}

inline void
ShiftOptions::optionSetInitiateAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::InitiateAllKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetInitiateAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::InitiateAllKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetInitiateAllKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::InitiateAllKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetInitiateAllButton ()
{
    return mOptions[ShiftOptions::InitiateAllButton].value ().action ();
}

inline void
ShiftOptions::optionSetInitiateAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::InitiateAllButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetInitiateAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::InitiateAllButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetInitiateAllButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::InitiateAllButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetInitiateAllEdge ()
{
    return mOptions[ShiftOptions::InitiateAllEdge].value ().action ();
}

inline void
ShiftOptions::optionSetInitiateAllEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::InitiateAllEdge].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetInitiateAllEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::InitiateAllEdge].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetInitiateAllEdgeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::InitiateAllEdge] = notify;
}

inline CompAction &
ShiftOptions::optionGetNextKey ()
{
    return mOptions[ShiftOptions::NextKey].value ().action ();
}

inline void
ShiftOptions::optionSetNextKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::NextKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetNextKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::NextKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetNextKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::NextKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetNextButton ()
{
    return mOptions[ShiftOptions::NextButton].value ().action ();
}

inline void
ShiftOptions::optionSetNextButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::NextButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetNextButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::NextButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetNextButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::NextButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetPrevKey ()
{
    return mOptions[ShiftOptions::PrevKey].value ().action ();
}

inline void
ShiftOptions::optionSetPrevKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::PrevKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetPrevKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::PrevKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetPrevKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::PrevKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetPrevButton ()
{
    return mOptions[ShiftOptions::PrevButton].value ().action ();
}

inline void
ShiftOptions::optionSetPrevButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::PrevButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetPrevButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::PrevButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetPrevButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::PrevButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetNextAllKey ()
{
    return mOptions[ShiftOptions::NextAllKey].value ().action ();
}

inline void
ShiftOptions::optionSetNextAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::NextAllKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetNextAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::NextAllKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetNextAllKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::NextAllKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetNextAllButton ()
{
    return mOptions[ShiftOptions::NextAllButton].value ().action ();
}

inline void
ShiftOptions::optionSetNextAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::NextAllButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetNextAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::NextAllButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetNextAllButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::NextAllButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetPrevAllKey ()
{
    return mOptions[ShiftOptions::PrevAllKey].value ().action ();
}

inline void
ShiftOptions::optionSetPrevAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::PrevAllKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetPrevAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::PrevAllKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetPrevAllKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::PrevAllKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetPrevAllButton ()
{
    return mOptions[ShiftOptions::PrevAllButton].value ().action ();
}

inline void
ShiftOptions::optionSetPrevAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::PrevAllButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetPrevAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::PrevAllButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetPrevAllButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::PrevAllButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetNextGroupKey ()
{
    return mOptions[ShiftOptions::NextGroupKey].value ().action ();
}

inline void
ShiftOptions::optionSetNextGroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::NextGroupKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetNextGroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::NextGroupKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetNextGroupKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::NextGroupKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetNextGroupButton ()
{
    return mOptions[ShiftOptions::NextGroupButton].value ().action ();
}

inline void
ShiftOptions::optionSetNextGroupButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::NextGroupButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetNextGroupButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::NextGroupButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetNextGroupButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::NextGroupButton] = notify;
}

inline CompAction &
ShiftOptions::optionGetPrevGroupKey ()
{
    return mOptions[ShiftOptions::PrevGroupKey].value ().action ();
}

inline void
ShiftOptions::optionSetPrevGroupKeyInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::PrevGroupKey].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetPrevGroupKeyTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::PrevGroupKey].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetPrevGroupKeyNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::PrevGroupKey] = notify;
}

inline CompAction &
ShiftOptions::optionGetPrevGroupButton ()
{
    return mOptions[ShiftOptions::PrevGroupButton].value ().action ();
}

inline void
ShiftOptions::optionSetPrevGroupButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShiftOptions::PrevGroupButton].value ().action ().setInitiate (init);
}

inline void
ShiftOptions::optionSetPrevGroupButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShiftOptions::PrevGroupButton].value ().action ().setTerminate (term);
}

inline void
ShiftOptions::optionSetPrevGroupButtonNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::PrevGroupButton] = notify;
}

inline CompMatch &
ShiftOptions::optionGetWindowMatch ()
{
    return mOptions[ShiftOptions::WindowMatch].value ().match ();
}

inline void
ShiftOptions::optionSetWindowMatchNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::WindowMatch] = notify;
}

inline bool
ShiftOptions::optionGetMinimized ()
{
    return mOptions[ShiftOptions::Minimized].value ().b ();
}

inline void
ShiftOptions::optionSetMinimizedNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Minimized] = notify;
}

inline float
ShiftOptions::optionGetSpeed ()
{
    return mOptions[ShiftOptions::Speed].value ().f ();
}

inline void
ShiftOptions::optionSetSpeedNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Speed] = notify;
}

inline float
ShiftOptions::optionGetShiftSpeed ()
{
    return mOptions[ShiftOptions::ShiftSpeed].value ().f ();
}

inline void
ShiftOptions::optionSetShiftSpeedNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::ShiftSpeed] = notify;
}

inline float
ShiftOptions::optionGetTimestep ()
{
    return mOptions[ShiftOptions::Timestep].value ().f ();
}

inline void
ShiftOptions::optionSetTimestepNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Timestep] = notify;
}

inline float
ShiftOptions::optionGetMouseSpeed ()
{
    return mOptions[ShiftOptions::MouseSpeed].value ().f ();
}

inline void
ShiftOptions::optionSetMouseSpeedNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::MouseSpeed] = notify;
}

inline int
ShiftOptions::optionGetClickDuration ()
{
    return mOptions[ShiftOptions::ClickDuration].value ().i ();
}

inline void
ShiftOptions::optionSetClickDurationNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::ClickDuration] = notify;
}

inline int
ShiftOptions::optionGetSize ()
{
    return mOptions[ShiftOptions::Size].value ().i ();
}

inline void
ShiftOptions::optionSetSizeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Size] = notify;
}

inline float
ShiftOptions::optionGetBackgroundIntensity ()
{
    return mOptions[ShiftOptions::BackgroundIntensity].value ().f ();
}

inline void
ShiftOptions::optionSetBackgroundIntensityNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::BackgroundIntensity] = notify;
}

inline bool
ShiftOptions::optionGetHideAll ()
{
    return mOptions[ShiftOptions::HideAll].value ().b ();
}

inline void
ShiftOptions::optionSetHideAllNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::HideAll] = notify;
}

inline bool
ShiftOptions::optionGetReflection ()
{
    return mOptions[ShiftOptions::Reflection].value ().b ();
}

inline void
ShiftOptions::optionSetReflectionNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Reflection] = notify;
}

inline unsigned short *
ShiftOptions::optionGetGroundColor1 ()
{
    return mOptions[ShiftOptions::GroundColor1].value ().c ();
}

inline unsigned short
ShiftOptions::optionGetGroundColor1Red ()
{
    return mOptions[ShiftOptions::GroundColor1].value ().c ()[0];
}

inline unsigned short
ShiftOptions::optionGetGroundColor1Green ()
{
    return mOptions[ShiftOptions::GroundColor1].value ().c ()[1];
}


inline unsigned short
ShiftOptions::optionGetGroundColor1Blue ()
{
    return mOptions[ShiftOptions::GroundColor1].value ().c ()[2];
}


inline unsigned short
ShiftOptions::optionGetGroundColor1Alpha ()
{
    return mOptions[ShiftOptions::GroundColor1].value ().c ()[3];
}


inline void
ShiftOptions::optionSetGroundColor1Notify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::GroundColor1] = notify;
}

inline unsigned short *
ShiftOptions::optionGetGroundColor2 ()
{
    return mOptions[ShiftOptions::GroundColor2].value ().c ();
}

inline unsigned short
ShiftOptions::optionGetGroundColor2Red ()
{
    return mOptions[ShiftOptions::GroundColor2].value ().c ()[0];
}

inline unsigned short
ShiftOptions::optionGetGroundColor2Green ()
{
    return mOptions[ShiftOptions::GroundColor2].value ().c ()[1];
}


inline unsigned short
ShiftOptions::optionGetGroundColor2Blue ()
{
    return mOptions[ShiftOptions::GroundColor2].value ().c ()[2];
}


inline unsigned short
ShiftOptions::optionGetGroundColor2Alpha ()
{
    return mOptions[ShiftOptions::GroundColor2].value ().c ()[3];
}


inline void
ShiftOptions::optionSetGroundColor2Notify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::GroundColor2] = notify;
}

inline float
ShiftOptions::optionGetGroundSize ()
{
    return mOptions[ShiftOptions::GroundSize].value ().f ();
}

inline void
ShiftOptions::optionSetGroundSizeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::GroundSize] = notify;
}

inline float
ShiftOptions::optionGetIntensity ()
{
    return mOptions[ShiftOptions::Intensity].value ().f ();
}

inline void
ShiftOptions::optionSetIntensityNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Intensity] = notify;
}

inline int
ShiftOptions::optionGetOverlayIcon ()
{
    return mOptions[ShiftOptions::OverlayIcon].value ().i ();
}

inline void
ShiftOptions::optionSetOverlayIconNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::OverlayIcon] = notify;
}

inline bool
ShiftOptions::optionGetMipmaps ()
{
    return mOptions[ShiftOptions::Mipmaps].value ().b ();
}

inline void
ShiftOptions::optionSetMipmapsNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Mipmaps] = notify;
}

inline int
ShiftOptions::optionGetMultioutputMode ()
{
    return mOptions[ShiftOptions::MultioutputMode].value ().i ();
}

inline void
ShiftOptions::optionSetMultioutputModeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::MultioutputMode] = notify;
}

inline int
ShiftOptions::optionGetMode ()
{
    return mOptions[ShiftOptions::Mode].value ().i ();
}

inline void
ShiftOptions::optionSetModeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::Mode] = notify;
}

inline int
ShiftOptions::optionGetFlipRotation ()
{
    return mOptions[ShiftOptions::FlipRotation].value ().i ();
}

inline void
ShiftOptions::optionSetFlipRotationNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::FlipRotation] = notify;
}

inline float
ShiftOptions::optionGetCoverOffset ()
{
    return mOptions[ShiftOptions::CoverOffset].value ().f ();
}

inline void
ShiftOptions::optionSetCoverOffsetNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::CoverOffset] = notify;
}

inline float
ShiftOptions::optionGetCoverAngle ()
{
    return mOptions[ShiftOptions::CoverAngle].value ().f ();
}

inline void
ShiftOptions::optionSetCoverAngleNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::CoverAngle] = notify;
}

inline float
ShiftOptions::optionGetCoverExtraSpace ()
{
    return mOptions[ShiftOptions::CoverExtraSpace].value ().f ();
}

inline void
ShiftOptions::optionSetCoverExtraSpaceNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::CoverExtraSpace] = notify;
}

inline int
ShiftOptions::optionGetCoverMaxVisibleWindows ()
{
    return mOptions[ShiftOptions::CoverMaxVisibleWindows].value ().i ();
}

inline void
ShiftOptions::optionSetCoverMaxVisibleWindowsNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::CoverMaxVisibleWindows] = notify;
}

inline bool
ShiftOptions::optionGetWindowTitle ()
{
    return mOptions[ShiftOptions::WindowTitle].value ().b ();
}

inline void
ShiftOptions::optionSetWindowTitleNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::WindowTitle] = notify;
}

inline bool
ShiftOptions::optionGetTitleFontBold ()
{
    return mOptions[ShiftOptions::TitleFontBold].value ().b ();
}

inline void
ShiftOptions::optionSetTitleFontBoldNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::TitleFontBold] = notify;
}

inline int
ShiftOptions::optionGetTitleFontSize ()
{
    return mOptions[ShiftOptions::TitleFontSize].value ().i ();
}

inline void
ShiftOptions::optionSetTitleFontSizeNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::TitleFontSize] = notify;
}

inline unsigned short *
ShiftOptions::optionGetTitleBackColor ()
{
    return mOptions[ShiftOptions::TitleBackColor].value ().c ();
}

inline unsigned short
ShiftOptions::optionGetTitleBackColorRed ()
{
    return mOptions[ShiftOptions::TitleBackColor].value ().c ()[0];
}

inline unsigned short
ShiftOptions::optionGetTitleBackColorGreen ()
{
    return mOptions[ShiftOptions::TitleBackColor].value ().c ()[1];
}


inline unsigned short
ShiftOptions::optionGetTitleBackColorBlue ()
{
    return mOptions[ShiftOptions::TitleBackColor].value ().c ()[2];
}


inline unsigned short
ShiftOptions::optionGetTitleBackColorAlpha ()
{
    return mOptions[ShiftOptions::TitleBackColor].value ().c ()[3];
}


inline void
ShiftOptions::optionSetTitleBackColorNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::TitleBackColor] = notify;
}

inline unsigned short *
ShiftOptions::optionGetTitleFontColor ()
{
    return mOptions[ShiftOptions::TitleFontColor].value ().c ();
}

inline unsigned short
ShiftOptions::optionGetTitleFontColorRed ()
{
    return mOptions[ShiftOptions::TitleFontColor].value ().c ()[0];
}

inline unsigned short
ShiftOptions::optionGetTitleFontColorGreen ()
{
    return mOptions[ShiftOptions::TitleFontColor].value ().c ()[1];
}


inline unsigned short
ShiftOptions::optionGetTitleFontColorBlue ()
{
    return mOptions[ShiftOptions::TitleFontColor].value ().c ()[2];
}


inline unsigned short
ShiftOptions::optionGetTitleFontColorAlpha ()
{
    return mOptions[ShiftOptions::TitleFontColor].value ().c ()[3];
}


inline void
ShiftOptions::optionSetTitleFontColorNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::TitleFontColor] = notify;
}

inline int
ShiftOptions::optionGetTitleTextPlacement ()
{
    return mOptions[ShiftOptions::TitleTextPlacement].value ().i ();
}

inline void
ShiftOptions::optionSetTitleTextPlacementNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::TitleTextPlacement] = notify;
}

inline int
ShiftOptions::optionGetVerticalOffset ()
{
    return mOptions[ShiftOptions::VerticalOffset].value ().i ();
}

inline void
ShiftOptions::optionSetVerticalOffsetNotify (ShiftOptions::ChangeNotify notify)
{
    mNotify[ShiftOptions::VerticalOffset] = notify;
}



#endif
