/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SHOWDESKTOP_OPTIONS_H
#define _SHOWDESKTOP_OPTIONS_H

#include <core/core.h>

class ShowdesktopOptions : public CompOption::Class {
    public:
        enum Options {
            Speed,
            Timestep,
            Direction,
            WindowMatch,
            SkipAnimation,
            WindowOpacity,
            WindowPartSize,
            OptionNum
        };

        enum Direction {
            DirectionUp = 0,
            DirectionDown = 1,
            DirectionLeft = 2,
            DirectionRight = 3,
            DirectionTopLeftCorner = 4,
            DirectionBottomLeftCorner = 5,
            DirectionTopRightCorner = 6,
            DirectionBottomRightCorner = 7,
            DirectionUpDown = 8,
            DirectionLeftRight = 9,
            DirectionToCorners = 10,
            DirectionIntelligentRandom = 11,
            DirectionFullyRandom = 12,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ShowdesktopOptions (bool init = true);
        virtual ~ShowdesktopOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        int optionGetDirection ();
        void optionSetDirectionNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        bool optionGetSkipAnimation ();
        void optionSetSkipAnimationNotify (ChangeNotify notify);

        float optionGetWindowOpacity ();
        void optionSetWindowOpacityNotify (ChangeNotify notify);

        int optionGetWindowPartSize ();
        void optionSetWindowPartSizeNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline float
ShowdesktopOptions::optionGetSpeed ()
{
    return mOptions[ShowdesktopOptions::Speed].value ().f ();
}

inline void
ShowdesktopOptions::optionSetSpeedNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::Speed] = notify;
}

inline float
ShowdesktopOptions::optionGetTimestep ()
{
    return mOptions[ShowdesktopOptions::Timestep].value ().f ();
}

inline void
ShowdesktopOptions::optionSetTimestepNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::Timestep] = notify;
}

inline int
ShowdesktopOptions::optionGetDirection ()
{
    return mOptions[ShowdesktopOptions::Direction].value ().i ();
}

inline void
ShowdesktopOptions::optionSetDirectionNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::Direction] = notify;
}

inline CompMatch &
ShowdesktopOptions::optionGetWindowMatch ()
{
    return mOptions[ShowdesktopOptions::WindowMatch].value ().match ();
}

inline void
ShowdesktopOptions::optionSetWindowMatchNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::WindowMatch] = notify;
}

inline bool
ShowdesktopOptions::optionGetSkipAnimation ()
{
    return mOptions[ShowdesktopOptions::SkipAnimation].value ().b ();
}

inline void
ShowdesktopOptions::optionSetSkipAnimationNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::SkipAnimation] = notify;
}

inline float
ShowdesktopOptions::optionGetWindowOpacity ()
{
    return mOptions[ShowdesktopOptions::WindowOpacity].value ().f ();
}

inline void
ShowdesktopOptions::optionSetWindowOpacityNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::WindowOpacity] = notify;
}

inline int
ShowdesktopOptions::optionGetWindowPartSize ()
{
    return mOptions[ShowdesktopOptions::WindowPartSize].value ().i ();
}

inline void
ShowdesktopOptions::optionSetWindowPartSizeNotify (ShowdesktopOptions::ChangeNotify notify)
{
    mNotify[ShowdesktopOptions::WindowPartSize] = notify;
}



#endif
