/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SHOWMOUSE_OPTIONS_H
#define _SHOWMOUSE_OPTIONS_H

#include <core/core.h>

class ShowmouseOptions : public CompOption::Class {
    public:
        enum Options {
            ActivateAtStartup,
            Initiate,
            InitiateButton,
            InitiateEdge,
            GuideThickness,
            GuideEmptyRadius,
            GuideColor,
            RotationSpeed,
            Radius,
            Emitters,
            NumParticles,
            Size,
            Slowdown,
            Life,
            Darken,
            Blend,
            Color,
            Random,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ShowmouseOptions (bool init = true);
        virtual ~ShowmouseOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        bool optionGetActivateAtStartup ();
        void optionSetActivateAtStartupNotify (ChangeNotify notify);

        CompAction & optionGetInitiate ();
        void optionSetInitiateInitiate (CompAction::CallBack init);
        void optionSetInitiateTerminate (CompAction::CallBack term);
        void optionSetInitiateNotify (ChangeNotify notify);

        CompAction & optionGetInitiateButton ();
        void optionSetInitiateButtonInitiate (CompAction::CallBack init);
        void optionSetInitiateButtonTerminate (CompAction::CallBack term);
        void optionSetInitiateButtonNotify (ChangeNotify notify);

        CompAction & optionGetInitiateEdge ();
        void optionSetInitiateEdgeInitiate (CompAction::CallBack init);
        void optionSetInitiateEdgeTerminate (CompAction::CallBack term);
        void optionSetInitiateEdgeNotify (ChangeNotify notify);

        int optionGetGuideThickness ();
        void optionSetGuideThicknessNotify (ChangeNotify notify);

        int optionGetGuideEmptyRadius ();
        void optionSetGuideEmptyRadiusNotify (ChangeNotify notify);

        unsigned short * optionGetGuideColor ();
        unsigned short optionGetGuideColorRed ();
        unsigned short optionGetGuideColorGreen ();
        unsigned short optionGetGuideColorBlue ();
        unsigned short optionGetGuideColorAlpha ();
        void optionSetGuideColorNotify (ChangeNotify notify);

        float optionGetRotationSpeed ();
        void optionSetRotationSpeedNotify (ChangeNotify notify);

        int optionGetRadius ();
        void optionSetRadiusNotify (ChangeNotify notify);

        int optionGetEmitters ();
        void optionSetEmittersNotify (ChangeNotify notify);

        int optionGetNumParticles ();
        void optionSetNumParticlesNotify (ChangeNotify notify);

        float optionGetSize ();
        void optionSetSizeNotify (ChangeNotify notify);

        float optionGetSlowdown ();
        void optionSetSlowdownNotify (ChangeNotify notify);

        float optionGetLife ();
        void optionSetLifeNotify (ChangeNotify notify);

        float optionGetDarken ();
        void optionSetDarkenNotify (ChangeNotify notify);

        bool optionGetBlend ();
        void optionSetBlendNotify (ChangeNotify notify);

        unsigned short * optionGetColor ();
        unsigned short optionGetColorRed ();
        unsigned short optionGetColorGreen ();
        unsigned short optionGetColorBlue ();
        unsigned short optionGetColorAlpha ();
        void optionSetColorNotify (ChangeNotify notify);

        bool optionGetRandom ();
        void optionSetRandomNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline bool
ShowmouseOptions::optionGetActivateAtStartup ()
{
    return mOptions[ShowmouseOptions::ActivateAtStartup].value ().b ();
}

inline void
ShowmouseOptions::optionSetActivateAtStartupNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::ActivateAtStartup] = notify;
}

inline CompAction &
ShowmouseOptions::optionGetInitiate ()
{
    return mOptions[ShowmouseOptions::Initiate].value ().action ();
}

inline void
ShowmouseOptions::optionSetInitiateInitiate (CompAction::CallBack init)
{
    mOptions[ShowmouseOptions::Initiate].value ().action ().setInitiate (init);
}

inline void
ShowmouseOptions::optionSetInitiateTerminate (CompAction::CallBack term)
{
    mOptions[ShowmouseOptions::Initiate].value ().action ().setTerminate (term);
}

inline void
ShowmouseOptions::optionSetInitiateNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Initiate] = notify;
}

inline CompAction &
ShowmouseOptions::optionGetInitiateButton ()
{
    return mOptions[ShowmouseOptions::InitiateButton].value ().action ();
}

inline void
ShowmouseOptions::optionSetInitiateButtonInitiate (CompAction::CallBack init)
{
    mOptions[ShowmouseOptions::InitiateButton].value ().action ().setInitiate (init);
}

inline void
ShowmouseOptions::optionSetInitiateButtonTerminate (CompAction::CallBack term)
{
    mOptions[ShowmouseOptions::InitiateButton].value ().action ().setTerminate (term);
}

inline void
ShowmouseOptions::optionSetInitiateButtonNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::InitiateButton] = notify;
}

inline CompAction &
ShowmouseOptions::optionGetInitiateEdge ()
{
    return mOptions[ShowmouseOptions::InitiateEdge].value ().action ();
}

inline void
ShowmouseOptions::optionSetInitiateEdgeInitiate (CompAction::CallBack init)
{
    mOptions[ShowmouseOptions::InitiateEdge].value ().action ().setInitiate (init);
}

inline void
ShowmouseOptions::optionSetInitiateEdgeTerminate (CompAction::CallBack term)
{
    mOptions[ShowmouseOptions::InitiateEdge].value ().action ().setTerminate (term);
}

inline void
ShowmouseOptions::optionSetInitiateEdgeNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::InitiateEdge] = notify;
}

inline int
ShowmouseOptions::optionGetGuideThickness ()
{
    return mOptions[ShowmouseOptions::GuideThickness].value ().i ();
}

inline void
ShowmouseOptions::optionSetGuideThicknessNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::GuideThickness] = notify;
}

inline int
ShowmouseOptions::optionGetGuideEmptyRadius ()
{
    return mOptions[ShowmouseOptions::GuideEmptyRadius].value ().i ();
}

inline void
ShowmouseOptions::optionSetGuideEmptyRadiusNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::GuideEmptyRadius] = notify;
}

inline unsigned short *
ShowmouseOptions::optionGetGuideColor ()
{
    return mOptions[ShowmouseOptions::GuideColor].value ().c ();
}

inline unsigned short
ShowmouseOptions::optionGetGuideColorRed ()
{
    return mOptions[ShowmouseOptions::GuideColor].value ().c ()[0];
}

inline unsigned short
ShowmouseOptions::optionGetGuideColorGreen ()
{
    return mOptions[ShowmouseOptions::GuideColor].value ().c ()[1];
}


inline unsigned short
ShowmouseOptions::optionGetGuideColorBlue ()
{
    return mOptions[ShowmouseOptions::GuideColor].value ().c ()[2];
}


inline unsigned short
ShowmouseOptions::optionGetGuideColorAlpha ()
{
    return mOptions[ShowmouseOptions::GuideColor].value ().c ()[3];
}


inline void
ShowmouseOptions::optionSetGuideColorNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::GuideColor] = notify;
}

inline float
ShowmouseOptions::optionGetRotationSpeed ()
{
    return mOptions[ShowmouseOptions::RotationSpeed].value ().f ();
}

inline void
ShowmouseOptions::optionSetRotationSpeedNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::RotationSpeed] = notify;
}

inline int
ShowmouseOptions::optionGetRadius ()
{
    return mOptions[ShowmouseOptions::Radius].value ().i ();
}

inline void
ShowmouseOptions::optionSetRadiusNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Radius] = notify;
}

inline int
ShowmouseOptions::optionGetEmitters ()
{
    return mOptions[ShowmouseOptions::Emitters].value ().i ();
}

inline void
ShowmouseOptions::optionSetEmittersNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Emitters] = notify;
}

inline int
ShowmouseOptions::optionGetNumParticles ()
{
    return mOptions[ShowmouseOptions::NumParticles].value ().i ();
}

inline void
ShowmouseOptions::optionSetNumParticlesNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::NumParticles] = notify;
}

inline float
ShowmouseOptions::optionGetSize ()
{
    return mOptions[ShowmouseOptions::Size].value ().f ();
}

inline void
ShowmouseOptions::optionSetSizeNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Size] = notify;
}

inline float
ShowmouseOptions::optionGetSlowdown ()
{
    return mOptions[ShowmouseOptions::Slowdown].value ().f ();
}

inline void
ShowmouseOptions::optionSetSlowdownNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Slowdown] = notify;
}

inline float
ShowmouseOptions::optionGetLife ()
{
    return mOptions[ShowmouseOptions::Life].value ().f ();
}

inline void
ShowmouseOptions::optionSetLifeNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Life] = notify;
}

inline float
ShowmouseOptions::optionGetDarken ()
{
    return mOptions[ShowmouseOptions::Darken].value ().f ();
}

inline void
ShowmouseOptions::optionSetDarkenNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Darken] = notify;
}

inline bool
ShowmouseOptions::optionGetBlend ()
{
    return mOptions[ShowmouseOptions::Blend].value ().b ();
}

inline void
ShowmouseOptions::optionSetBlendNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Blend] = notify;
}

inline unsigned short *
ShowmouseOptions::optionGetColor ()
{
    return mOptions[ShowmouseOptions::Color].value ().c ();
}

inline unsigned short
ShowmouseOptions::optionGetColorRed ()
{
    return mOptions[ShowmouseOptions::Color].value ().c ()[0];
}

inline unsigned short
ShowmouseOptions::optionGetColorGreen ()
{
    return mOptions[ShowmouseOptions::Color].value ().c ()[1];
}


inline unsigned short
ShowmouseOptions::optionGetColorBlue ()
{
    return mOptions[ShowmouseOptions::Color].value ().c ()[2];
}


inline unsigned short
ShowmouseOptions::optionGetColorAlpha ()
{
    return mOptions[ShowmouseOptions::Color].value ().c ()[3];
}


inline void
ShowmouseOptions::optionSetColorNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Color] = notify;
}

inline bool
ShowmouseOptions::optionGetRandom ()
{
    return mOptions[ShowmouseOptions::Random].value ().b ();
}

inline void
ShowmouseOptions::optionSetRandomNotify (ShowmouseOptions::ChangeNotify notify)
{
    mNotify[ShowmouseOptions::Random] = notify;
}



#endif
