/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SNAP_OPTIONS_H
#define _SNAP_OPTIONS_H

#include <core/core.h>

class SnapOptions : public CompOption::Class {
    public:
        enum Options {
            AvoidSnap,
            SnapType,
            EdgesCategories,
            ResistanceDistance,
            AttractionDistance,
            OptionNum
        };

        enum AvoidSnap {
            AvoidSnapShift = 0,
            AvoidSnapAlt = 1,
            AvoidSnapControl = 2,
            AvoidSnapMeta = 3,
        };

        enum SnapType {
            SnapTypeEdgeResistance = 0,
            SnapTypeEdgeAttraction = 1,
        };

        enum EdgesCategories {
            EdgesCategoriesScreenEdges = 0,
            EdgesCategoriesWindowEdges = 1,
        };

        #define AvoidSnapShiftMask (1 << 0)
        #define AvoidSnapAltMask (1 << 1)
        #define AvoidSnapControlMask (1 << 2)
        #define AvoidSnapMetaMask (1 << 3)


        #define SnapTypeEdgeResistanceMask (1 << 0)
        #define SnapTypeEdgeAttractionMask (1 << 1)


        #define EdgesCategoriesScreenEdgesMask (1 << 0)
        #define EdgesCategoriesWindowEdgesMask (1 << 1)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        SnapOptions (bool init = true);
        virtual ~SnapOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompOption::Value::Vector & optionGetAvoidSnap ();
        unsigned int optionGetAvoidSnapMask ();
        void optionSetAvoidSnapNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetSnapType ();
        unsigned int optionGetSnapTypeMask ();
        void optionSetSnapTypeNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEdgesCategories ();
        unsigned int optionGetEdgesCategoriesMask ();
        void optionSetEdgesCategoriesNotify (ChangeNotify notify);

        int optionGetResistanceDistance ();
        void optionSetResistanceDistanceNotify (ChangeNotify notify);

        int optionGetAttractionDistance ();
        void optionSetAttractionDistanceNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mAvoidSnapMask;
        unsigned int mSnapTypeMask;
        unsigned int mEdgesCategoriesMask;

};


inline CompOption::Value::Vector &
SnapOptions::optionGetAvoidSnap ()
{
    return mOptions[SnapOptions::AvoidSnap].value ().list ();
}

inline unsigned int
SnapOptions::optionGetAvoidSnapMask ()
{
    return mAvoidSnapMask;
}

inline void
SnapOptions::optionSetAvoidSnapNotify (SnapOptions::ChangeNotify notify)
{
    mNotify[SnapOptions::AvoidSnap] = notify;
}

inline CompOption::Value::Vector &
SnapOptions::optionGetSnapType ()
{
    return mOptions[SnapOptions::SnapType].value ().list ();
}

inline unsigned int
SnapOptions::optionGetSnapTypeMask ()
{
    return mSnapTypeMask;
}

inline void
SnapOptions::optionSetSnapTypeNotify (SnapOptions::ChangeNotify notify)
{
    mNotify[SnapOptions::SnapType] = notify;
}

inline CompOption::Value::Vector &
SnapOptions::optionGetEdgesCategories ()
{
    return mOptions[SnapOptions::EdgesCategories].value ().list ();
}

inline unsigned int
SnapOptions::optionGetEdgesCategoriesMask ()
{
    return mEdgesCategoriesMask;
}

inline void
SnapOptions::optionSetEdgesCategoriesNotify (SnapOptions::ChangeNotify notify)
{
    mNotify[SnapOptions::EdgesCategories] = notify;
}

inline int
SnapOptions::optionGetResistanceDistance ()
{
    return mOptions[SnapOptions::ResistanceDistance].value ().i ();
}

inline void
SnapOptions::optionSetResistanceDistanceNotify (SnapOptions::ChangeNotify notify)
{
    mNotify[SnapOptions::ResistanceDistance] = notify;
}

inline int
SnapOptions::optionGetAttractionDistance ()
{
    return mOptions[SnapOptions::AttractionDistance].value ().i ();
}

inline void
SnapOptions::optionSetAttractionDistanceNotify (SnapOptions::ChangeNotify notify)
{
    mNotify[SnapOptions::AttractionDistance] = notify;
}



#endif
