/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SPLASH_OPTIONS_H
#define _SPLASH_OPTIONS_H

#include <core/core.h>

class SplashOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateKey,
            Firststart,
            Background,
            Logo,
            FadeTime,
            DisplayTime,
            Saturation,
            Brightness,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        SplashOptions (bool init = true);
        virtual ~SplashOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        bool optionGetFirststart ();
        void optionSetFirststartNotify (ChangeNotify notify);

        CompString optionGetBackground ();
        void optionSetBackgroundNotify (ChangeNotify notify);

        CompString optionGetLogo ();
        void optionSetLogoNotify (ChangeNotify notify);

        float optionGetFadeTime ();
        void optionSetFadeTimeNotify (ChangeNotify notify);

        float optionGetDisplayTime ();
        void optionSetDisplayTimeNotify (ChangeNotify notify);

        float optionGetSaturation ();
        void optionSetSaturationNotify (ChangeNotify notify);

        float optionGetBrightness ();
        void optionSetBrightnessNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
SplashOptions::optionGetInitiateKey ()
{
    return mOptions[SplashOptions::InitiateKey].value ().action ();
}

inline void
SplashOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[SplashOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
SplashOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[SplashOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
SplashOptions::optionSetInitiateKeyNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::InitiateKey] = notify;
}

inline bool
SplashOptions::optionGetFirststart ()
{
    return mOptions[SplashOptions::Firststart].value ().b ();
}

inline void
SplashOptions::optionSetFirststartNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::Firststart] = notify;
}

inline CompString
SplashOptions::optionGetBackground ()
{
    return mOptions[SplashOptions::Background].value ().s ();
}

inline void
SplashOptions::optionSetBackgroundNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::Background] = notify;
}

inline CompString
SplashOptions::optionGetLogo ()
{
    return mOptions[SplashOptions::Logo].value ().s ();
}

inline void
SplashOptions::optionSetLogoNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::Logo] = notify;
}

inline float
SplashOptions::optionGetFadeTime ()
{
    return mOptions[SplashOptions::FadeTime].value ().f ();
}

inline void
SplashOptions::optionSetFadeTimeNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::FadeTime] = notify;
}

inline float
SplashOptions::optionGetDisplayTime ()
{
    return mOptions[SplashOptions::DisplayTime].value ().f ();
}

inline void
SplashOptions::optionSetDisplayTimeNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::DisplayTime] = notify;
}

inline float
SplashOptions::optionGetSaturation ()
{
    return mOptions[SplashOptions::Saturation].value ().f ();
}

inline void
SplashOptions::optionSetSaturationNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::Saturation] = notify;
}

inline float
SplashOptions::optionGetBrightness ()
{
    return mOptions[SplashOptions::Brightness].value ().f ();
}

inline void
SplashOptions::optionSetBrightnessNotify (SplashOptions::ChangeNotify notify)
{
    mNotify[SplashOptions::Brightness] = notify;
}



#endif
