/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _SWITCHER_OPTIONS_H
#define _SWITCHER_OPTIONS_H

#include <core/core.h>

class SwitcherOptions : public CompOption::Class {
    public:
        enum Options {
            NextButton,
            NextKey,
            PrevButton,
            PrevKey,
            NextAllButton,
            NextAllKey,
            PrevAllButton,
            PrevAllKey,
            NextNoPopupButton,
            NextNoPopupKey,
            PrevNoPopupButton,
            PrevNoPopupKey,
            NextPanelButton,
            NextPanelKey,
            PrevPanelButton,
            PrevPanelKey,
            Speed,
            Timestep,
            SizeMultiplier,
            WindowMatch,
            Mipmap,
            Saturation,
            Brightness,
            Opacity,
            FocusOnSwitch,
            BringToFront,
            Zoom,
            Icon,
            IconOnly,
            Minimized,
            AutoRotate,
            UseBackgroundColor,
            BackgroundColor,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        SwitcherOptions (bool init = true);
        virtual ~SwitcherOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetNextButton ();
        void optionSetNextButtonInitiate (CompAction::CallBack init);
        void optionSetNextButtonTerminate (CompAction::CallBack term);
        void optionSetNextButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextKey ();
        void optionSetNextKeyInitiate (CompAction::CallBack init);
        void optionSetNextKeyTerminate (CompAction::CallBack term);
        void optionSetNextKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevButton ();
        void optionSetPrevButtonInitiate (CompAction::CallBack init);
        void optionSetPrevButtonTerminate (CompAction::CallBack term);
        void optionSetPrevButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevKey ();
        void optionSetPrevKeyInitiate (CompAction::CallBack init);
        void optionSetPrevKeyTerminate (CompAction::CallBack term);
        void optionSetPrevKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextAllButton ();
        void optionSetNextAllButtonInitiate (CompAction::CallBack init);
        void optionSetNextAllButtonTerminate (CompAction::CallBack term);
        void optionSetNextAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextAllKey ();
        void optionSetNextAllKeyInitiate (CompAction::CallBack init);
        void optionSetNextAllKeyTerminate (CompAction::CallBack term);
        void optionSetNextAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevAllButton ();
        void optionSetPrevAllButtonInitiate (CompAction::CallBack init);
        void optionSetPrevAllButtonTerminate (CompAction::CallBack term);
        void optionSetPrevAllButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevAllKey ();
        void optionSetPrevAllKeyInitiate (CompAction::CallBack init);
        void optionSetPrevAllKeyTerminate (CompAction::CallBack term);
        void optionSetPrevAllKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextNoPopupButton ();
        void optionSetNextNoPopupButtonInitiate (CompAction::CallBack init);
        void optionSetNextNoPopupButtonTerminate (CompAction::CallBack term);
        void optionSetNextNoPopupButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextNoPopupKey ();
        void optionSetNextNoPopupKeyInitiate (CompAction::CallBack init);
        void optionSetNextNoPopupKeyTerminate (CompAction::CallBack term);
        void optionSetNextNoPopupKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevNoPopupButton ();
        void optionSetPrevNoPopupButtonInitiate (CompAction::CallBack init);
        void optionSetPrevNoPopupButtonTerminate (CompAction::CallBack term);
        void optionSetPrevNoPopupButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevNoPopupKey ();
        void optionSetPrevNoPopupKeyInitiate (CompAction::CallBack init);
        void optionSetPrevNoPopupKeyTerminate (CompAction::CallBack term);
        void optionSetPrevNoPopupKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextPanelButton ();
        void optionSetNextPanelButtonInitiate (CompAction::CallBack init);
        void optionSetNextPanelButtonTerminate (CompAction::CallBack term);
        void optionSetNextPanelButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextPanelKey ();
        void optionSetNextPanelKeyInitiate (CompAction::CallBack init);
        void optionSetNextPanelKeyTerminate (CompAction::CallBack term);
        void optionSetNextPanelKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevPanelButton ();
        void optionSetPrevPanelButtonInitiate (CompAction::CallBack init);
        void optionSetPrevPanelButtonTerminate (CompAction::CallBack term);
        void optionSetPrevPanelButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevPanelKey ();
        void optionSetPrevPanelKeyInitiate (CompAction::CallBack init);
        void optionSetPrevPanelKeyTerminate (CompAction::CallBack term);
        void optionSetPrevPanelKeyNotify (ChangeNotify notify);

        float optionGetSpeed ();
        void optionSetSpeedNotify (ChangeNotify notify);

        float optionGetTimestep ();
        void optionSetTimestepNotify (ChangeNotify notify);

        float optionGetSizeMultiplier ();
        void optionSetSizeMultiplierNotify (ChangeNotify notify);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        bool optionGetMipmap ();
        void optionSetMipmapNotify (ChangeNotify notify);

        int optionGetSaturation ();
        void optionSetSaturationNotify (ChangeNotify notify);

        int optionGetBrightness ();
        void optionSetBrightnessNotify (ChangeNotify notify);

        int optionGetOpacity ();
        void optionSetOpacityNotify (ChangeNotify notify);

        bool optionGetFocusOnSwitch ();
        void optionSetFocusOnSwitchNotify (ChangeNotify notify);

        bool optionGetBringToFront ();
        void optionSetBringToFrontNotify (ChangeNotify notify);

        float optionGetZoom ();
        void optionSetZoomNotify (ChangeNotify notify);

        bool optionGetIcon ();
        void optionSetIconNotify (ChangeNotify notify);

        bool optionGetIconOnly ();
        void optionSetIconOnlyNotify (ChangeNotify notify);

        bool optionGetMinimized ();
        void optionSetMinimizedNotify (ChangeNotify notify);

        bool optionGetAutoRotate ();
        void optionSetAutoRotateNotify (ChangeNotify notify);

        bool optionGetUseBackgroundColor ();
        void optionSetUseBackgroundColorNotify (ChangeNotify notify);

        unsigned short * optionGetBackgroundColor ();
        unsigned short optionGetBackgroundColorRed ();
        unsigned short optionGetBackgroundColorGreen ();
        unsigned short optionGetBackgroundColorBlue ();
        unsigned short optionGetBackgroundColorAlpha ();
        void optionSetBackgroundColorNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
SwitcherOptions::optionGetNextButton ()
{
    return mOptions[SwitcherOptions::NextButton].value ().action ();
}

inline void
SwitcherOptions::optionSetNextButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextKey ()
{
    return mOptions[SwitcherOptions::NextKey].value ().action ();
}

inline void
SwitcherOptions::optionSetNextKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevButton ()
{
    return mOptions[SwitcherOptions::PrevButton].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevKey ()
{
    return mOptions[SwitcherOptions::PrevKey].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextAllButton ()
{
    return mOptions[SwitcherOptions::NextAllButton].value ().action ();
}

inline void
SwitcherOptions::optionSetNextAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextAllButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextAllButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextAllButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextAllButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextAllKey ()
{
    return mOptions[SwitcherOptions::NextAllKey].value ().action ();
}

inline void
SwitcherOptions::optionSetNextAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextAllKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextAllKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextAllKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextAllKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevAllButton ()
{
    return mOptions[SwitcherOptions::PrevAllButton].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevAllButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevAllButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevAllButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevAllButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevAllButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevAllButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevAllKey ()
{
    return mOptions[SwitcherOptions::PrevAllKey].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevAllKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevAllKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevAllKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevAllKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevAllKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevAllKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextNoPopupButton ()
{
    return mOptions[SwitcherOptions::NextNoPopupButton].value ().action ();
}

inline void
SwitcherOptions::optionSetNextNoPopupButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextNoPopupButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextNoPopupButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextNoPopupButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextNoPopupButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextNoPopupButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextNoPopupKey ()
{
    return mOptions[SwitcherOptions::NextNoPopupKey].value ().action ();
}

inline void
SwitcherOptions::optionSetNextNoPopupKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextNoPopupKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextNoPopupKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextNoPopupKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextNoPopupKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextNoPopupKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevNoPopupButton ()
{
    return mOptions[SwitcherOptions::PrevNoPopupButton].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevNoPopupButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevNoPopupButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevNoPopupButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevNoPopupButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevNoPopupButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevNoPopupButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevNoPopupKey ()
{
    return mOptions[SwitcherOptions::PrevNoPopupKey].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevNoPopupKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevNoPopupKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevNoPopupKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevNoPopupKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevNoPopupKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevNoPopupKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextPanelButton ()
{
    return mOptions[SwitcherOptions::NextPanelButton].value ().action ();
}

inline void
SwitcherOptions::optionSetNextPanelButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextPanelButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextPanelButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextPanelButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextPanelButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextPanelButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetNextPanelKey ()
{
    return mOptions[SwitcherOptions::NextPanelKey].value ().action ();
}

inline void
SwitcherOptions::optionSetNextPanelKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::NextPanelKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetNextPanelKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::NextPanelKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetNextPanelKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::NextPanelKey] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevPanelButton ()
{
    return mOptions[SwitcherOptions::PrevPanelButton].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevPanelButtonInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevPanelButton].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevPanelButtonTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevPanelButton].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevPanelButtonNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevPanelButton] = notify;
}

inline CompAction &
SwitcherOptions::optionGetPrevPanelKey ()
{
    return mOptions[SwitcherOptions::PrevPanelKey].value ().action ();
}

inline void
SwitcherOptions::optionSetPrevPanelKeyInitiate (CompAction::CallBack init)
{
    mOptions[SwitcherOptions::PrevPanelKey].value ().action ().setInitiate (init);
}

inline void
SwitcherOptions::optionSetPrevPanelKeyTerminate (CompAction::CallBack term)
{
    mOptions[SwitcherOptions::PrevPanelKey].value ().action ().setTerminate (term);
}

inline void
SwitcherOptions::optionSetPrevPanelKeyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::PrevPanelKey] = notify;
}

inline float
SwitcherOptions::optionGetSpeed ()
{
    return mOptions[SwitcherOptions::Speed].value ().f ();
}

inline void
SwitcherOptions::optionSetSpeedNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Speed] = notify;
}

inline float
SwitcherOptions::optionGetTimestep ()
{
    return mOptions[SwitcherOptions::Timestep].value ().f ();
}

inline void
SwitcherOptions::optionSetTimestepNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Timestep] = notify;
}

inline float
SwitcherOptions::optionGetSizeMultiplier ()
{
    return mOptions[SwitcherOptions::SizeMultiplier].value ().f ();
}

inline void
SwitcherOptions::optionSetSizeMultiplierNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::SizeMultiplier] = notify;
}

inline CompMatch &
SwitcherOptions::optionGetWindowMatch ()
{
    return mOptions[SwitcherOptions::WindowMatch].value ().match ();
}

inline void
SwitcherOptions::optionSetWindowMatchNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::WindowMatch] = notify;
}

inline bool
SwitcherOptions::optionGetMipmap ()
{
    return mOptions[SwitcherOptions::Mipmap].value ().b ();
}

inline void
SwitcherOptions::optionSetMipmapNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Mipmap] = notify;
}

inline int
SwitcherOptions::optionGetSaturation ()
{
    return mOptions[SwitcherOptions::Saturation].value ().i ();
}

inline void
SwitcherOptions::optionSetSaturationNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Saturation] = notify;
}

inline int
SwitcherOptions::optionGetBrightness ()
{
    return mOptions[SwitcherOptions::Brightness].value ().i ();
}

inline void
SwitcherOptions::optionSetBrightnessNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Brightness] = notify;
}

inline int
SwitcherOptions::optionGetOpacity ()
{
    return mOptions[SwitcherOptions::Opacity].value ().i ();
}

inline void
SwitcherOptions::optionSetOpacityNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Opacity] = notify;
}

inline bool
SwitcherOptions::optionGetFocusOnSwitch ()
{
    return mOptions[SwitcherOptions::FocusOnSwitch].value ().b ();
}

inline void
SwitcherOptions::optionSetFocusOnSwitchNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::FocusOnSwitch] = notify;
}

inline bool
SwitcherOptions::optionGetBringToFront ()
{
    return mOptions[SwitcherOptions::BringToFront].value ().b ();
}

inline void
SwitcherOptions::optionSetBringToFrontNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::BringToFront] = notify;
}

inline float
SwitcherOptions::optionGetZoom ()
{
    return mOptions[SwitcherOptions::Zoom].value ().f ();
}

inline void
SwitcherOptions::optionSetZoomNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Zoom] = notify;
}

inline bool
SwitcherOptions::optionGetIcon ()
{
    return mOptions[SwitcherOptions::Icon].value ().b ();
}

inline void
SwitcherOptions::optionSetIconNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Icon] = notify;
}

inline bool
SwitcherOptions::optionGetIconOnly ()
{
    return mOptions[SwitcherOptions::IconOnly].value ().b ();
}

inline void
SwitcherOptions::optionSetIconOnlyNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::IconOnly] = notify;
}

inline bool
SwitcherOptions::optionGetMinimized ()
{
    return mOptions[SwitcherOptions::Minimized].value ().b ();
}

inline void
SwitcherOptions::optionSetMinimizedNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::Minimized] = notify;
}

inline bool
SwitcherOptions::optionGetAutoRotate ()
{
    return mOptions[SwitcherOptions::AutoRotate].value ().b ();
}

inline void
SwitcherOptions::optionSetAutoRotateNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::AutoRotate] = notify;
}

inline bool
SwitcherOptions::optionGetUseBackgroundColor ()
{
    return mOptions[SwitcherOptions::UseBackgroundColor].value ().b ();
}

inline void
SwitcherOptions::optionSetUseBackgroundColorNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::UseBackgroundColor] = notify;
}

inline unsigned short *
SwitcherOptions::optionGetBackgroundColor ()
{
    return mOptions[SwitcherOptions::BackgroundColor].value ().c ();
}

inline unsigned short
SwitcherOptions::optionGetBackgroundColorRed ()
{
    return mOptions[SwitcherOptions::BackgroundColor].value ().c ()[0];
}

inline unsigned short
SwitcherOptions::optionGetBackgroundColorGreen ()
{
    return mOptions[SwitcherOptions::BackgroundColor].value ().c ()[1];
}


inline unsigned short
SwitcherOptions::optionGetBackgroundColorBlue ()
{
    return mOptions[SwitcherOptions::BackgroundColor].value ().c ()[2];
}


inline unsigned short
SwitcherOptions::optionGetBackgroundColorAlpha ()
{
    return mOptions[SwitcherOptions::BackgroundColor].value ().c ()[3];
}


inline void
SwitcherOptions::optionSetBackgroundColorNotify (SwitcherOptions::ChangeNotify notify)
{
    mNotify[SwitcherOptions::BackgroundColor] = notify;
}



#endif
