/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _TD_OPTIONS_H
#define _TD_OPTIONS_H

#include <core/core.h>

class TdOptions : public CompOption::Class {
    public:
        enum Options {
            WindowMatch,
            MinCubeSize,
            MaxWindowSpace,
            ManualOnly,
            Width,
            Bevel,
            WidthColor,
            WidthColorInactive,
            BevelTopleft,
            BevelTopright,
            BevelBottomleft,
            BevelBottomright,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        TdOptions (bool init = true);
        virtual ~TdOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompMatch & optionGetWindowMatch ();
        void optionSetWindowMatchNotify (ChangeNotify notify);

        int optionGetMinCubeSize ();
        void optionSetMinCubeSizeNotify (ChangeNotify notify);

        int optionGetMaxWindowSpace ();
        void optionSetMaxWindowSpaceNotify (ChangeNotify notify);

        bool optionGetManualOnly ();
        void optionSetManualOnlyNotify (ChangeNotify notify);

        float optionGetWidth ();
        void optionSetWidthNotify (ChangeNotify notify);

        int optionGetBevel ();
        void optionSetBevelNotify (ChangeNotify notify);

        unsigned short * optionGetWidthColor ();
        unsigned short optionGetWidthColorRed ();
        unsigned short optionGetWidthColorGreen ();
        unsigned short optionGetWidthColorBlue ();
        unsigned short optionGetWidthColorAlpha ();
        void optionSetWidthColorNotify (ChangeNotify notify);

        unsigned short * optionGetWidthColorInactive ();
        unsigned short optionGetWidthColorInactiveRed ();
        unsigned short optionGetWidthColorInactiveGreen ();
        unsigned short optionGetWidthColorInactiveBlue ();
        unsigned short optionGetWidthColorInactiveAlpha ();
        void optionSetWidthColorInactiveNotify (ChangeNotify notify);

        bool optionGetBevelTopleft ();
        void optionSetBevelTopleftNotify (ChangeNotify notify);

        bool optionGetBevelTopright ();
        void optionSetBevelToprightNotify (ChangeNotify notify);

        bool optionGetBevelBottomleft ();
        void optionSetBevelBottomleftNotify (ChangeNotify notify);

        bool optionGetBevelBottomright ();
        void optionSetBevelBottomrightNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompMatch &
TdOptions::optionGetWindowMatch ()
{
    return mOptions[TdOptions::WindowMatch].value ().match ();
}

inline void
TdOptions::optionSetWindowMatchNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::WindowMatch] = notify;
}

inline int
TdOptions::optionGetMinCubeSize ()
{
    return mOptions[TdOptions::MinCubeSize].value ().i ();
}

inline void
TdOptions::optionSetMinCubeSizeNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::MinCubeSize] = notify;
}

inline int
TdOptions::optionGetMaxWindowSpace ()
{
    return mOptions[TdOptions::MaxWindowSpace].value ().i ();
}

inline void
TdOptions::optionSetMaxWindowSpaceNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::MaxWindowSpace] = notify;
}

inline bool
TdOptions::optionGetManualOnly ()
{
    return mOptions[TdOptions::ManualOnly].value ().b ();
}

inline void
TdOptions::optionSetManualOnlyNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::ManualOnly] = notify;
}

inline float
TdOptions::optionGetWidth ()
{
    return mOptions[TdOptions::Width].value ().f ();
}

inline void
TdOptions::optionSetWidthNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::Width] = notify;
}

inline int
TdOptions::optionGetBevel ()
{
    return mOptions[TdOptions::Bevel].value ().i ();
}

inline void
TdOptions::optionSetBevelNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::Bevel] = notify;
}

inline unsigned short *
TdOptions::optionGetWidthColor ()
{
    return mOptions[TdOptions::WidthColor].value ().c ();
}

inline unsigned short
TdOptions::optionGetWidthColorRed ()
{
    return mOptions[TdOptions::WidthColor].value ().c ()[0];
}

inline unsigned short
TdOptions::optionGetWidthColorGreen ()
{
    return mOptions[TdOptions::WidthColor].value ().c ()[1];
}


inline unsigned short
TdOptions::optionGetWidthColorBlue ()
{
    return mOptions[TdOptions::WidthColor].value ().c ()[2];
}


inline unsigned short
TdOptions::optionGetWidthColorAlpha ()
{
    return mOptions[TdOptions::WidthColor].value ().c ()[3];
}


inline void
TdOptions::optionSetWidthColorNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::WidthColor] = notify;
}

inline unsigned short *
TdOptions::optionGetWidthColorInactive ()
{
    return mOptions[TdOptions::WidthColorInactive].value ().c ();
}

inline unsigned short
TdOptions::optionGetWidthColorInactiveRed ()
{
    return mOptions[TdOptions::WidthColorInactive].value ().c ()[0];
}

inline unsigned short
TdOptions::optionGetWidthColorInactiveGreen ()
{
    return mOptions[TdOptions::WidthColorInactive].value ().c ()[1];
}


inline unsigned short
TdOptions::optionGetWidthColorInactiveBlue ()
{
    return mOptions[TdOptions::WidthColorInactive].value ().c ()[2];
}


inline unsigned short
TdOptions::optionGetWidthColorInactiveAlpha ()
{
    return mOptions[TdOptions::WidthColorInactive].value ().c ()[3];
}


inline void
TdOptions::optionSetWidthColorInactiveNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::WidthColorInactive] = notify;
}

inline bool
TdOptions::optionGetBevelTopleft ()
{
    return mOptions[TdOptions::BevelTopleft].value ().b ();
}

inline void
TdOptions::optionSetBevelTopleftNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::BevelTopleft] = notify;
}

inline bool
TdOptions::optionGetBevelTopright ()
{
    return mOptions[TdOptions::BevelTopright].value ().b ();
}

inline void
TdOptions::optionSetBevelToprightNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::BevelTopright] = notify;
}

inline bool
TdOptions::optionGetBevelBottomleft ()
{
    return mOptions[TdOptions::BevelBottomleft].value ().b ();
}

inline void
TdOptions::optionSetBevelBottomleftNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::BevelBottomleft] = notify;
}

inline bool
TdOptions::optionGetBevelBottomright ()
{
    return mOptions[TdOptions::BevelBottomright].value ().b ();
}

inline void
TdOptions::optionSetBevelBottomrightNotify (TdOptions::ChangeNotify notify)
{
    mNotify[TdOptions::BevelBottomright] = notify;
}



#endif
