/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _THUMBNAIL_OPTIONS_H
#define _THUMBNAIL_OPTIONS_H

#include <core/core.h>

class ThumbnailOptions : public CompOption::Class {
    public:
        enum Options {
            AlwaysOnTop,
            ThumbSize,
            ShowDelay,
            FadeSpeed,
            Border,
            ThumbColor,
            WindowLike,
            Mipmap,
            CurrentViewport,
            TitleEnabled,
            FontBold,
            TextDistance,
            FontSize,
            FontColor,
            FontBackgroundColor,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        ThumbnailOptions (bool init = true);
        virtual ~ThumbnailOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        bool optionGetAlwaysOnTop ();
        void optionSetAlwaysOnTopNotify (ChangeNotify notify);

        int optionGetThumbSize ();
        void optionSetThumbSizeNotify (ChangeNotify notify);

        int optionGetShowDelay ();
        void optionSetShowDelayNotify (ChangeNotify notify);

        float optionGetFadeSpeed ();
        void optionSetFadeSpeedNotify (ChangeNotify notify);

        int optionGetBorder ();
        void optionSetBorderNotify (ChangeNotify notify);

        unsigned short * optionGetThumbColor ();
        unsigned short optionGetThumbColorRed ();
        unsigned short optionGetThumbColorGreen ();
        unsigned short optionGetThumbColorBlue ();
        unsigned short optionGetThumbColorAlpha ();
        void optionSetThumbColorNotify (ChangeNotify notify);

        bool optionGetWindowLike ();
        void optionSetWindowLikeNotify (ChangeNotify notify);

        bool optionGetMipmap ();
        void optionSetMipmapNotify (ChangeNotify notify);

        bool optionGetCurrentViewport ();
        void optionSetCurrentViewportNotify (ChangeNotify notify);

        bool optionGetTitleEnabled ();
        void optionSetTitleEnabledNotify (ChangeNotify notify);

        bool optionGetFontBold ();
        void optionSetFontBoldNotify (ChangeNotify notify);

        int optionGetTextDistance ();
        void optionSetTextDistanceNotify (ChangeNotify notify);

        int optionGetFontSize ();
        void optionSetFontSizeNotify (ChangeNotify notify);

        unsigned short * optionGetFontColor ();
        unsigned short optionGetFontColorRed ();
        unsigned short optionGetFontColorGreen ();
        unsigned short optionGetFontColorBlue ();
        unsigned short optionGetFontColorAlpha ();
        void optionSetFontColorNotify (ChangeNotify notify);

        unsigned short * optionGetFontBackgroundColor ();
        unsigned short optionGetFontBackgroundColorRed ();
        unsigned short optionGetFontBackgroundColorGreen ();
        unsigned short optionGetFontBackgroundColorBlue ();
        unsigned short optionGetFontBackgroundColorAlpha ();
        void optionSetFontBackgroundColorNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline bool
ThumbnailOptions::optionGetAlwaysOnTop ()
{
    return mOptions[ThumbnailOptions::AlwaysOnTop].value ().b ();
}

inline void
ThumbnailOptions::optionSetAlwaysOnTopNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::AlwaysOnTop] = notify;
}

inline int
ThumbnailOptions::optionGetThumbSize ()
{
    return mOptions[ThumbnailOptions::ThumbSize].value ().i ();
}

inline void
ThumbnailOptions::optionSetThumbSizeNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::ThumbSize] = notify;
}

inline int
ThumbnailOptions::optionGetShowDelay ()
{
    return mOptions[ThumbnailOptions::ShowDelay].value ().i ();
}

inline void
ThumbnailOptions::optionSetShowDelayNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::ShowDelay] = notify;
}

inline float
ThumbnailOptions::optionGetFadeSpeed ()
{
    return mOptions[ThumbnailOptions::FadeSpeed].value ().f ();
}

inline void
ThumbnailOptions::optionSetFadeSpeedNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::FadeSpeed] = notify;
}

inline int
ThumbnailOptions::optionGetBorder ()
{
    return mOptions[ThumbnailOptions::Border].value ().i ();
}

inline void
ThumbnailOptions::optionSetBorderNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::Border] = notify;
}

inline unsigned short *
ThumbnailOptions::optionGetThumbColor ()
{
    return mOptions[ThumbnailOptions::ThumbColor].value ().c ();
}

inline unsigned short
ThumbnailOptions::optionGetThumbColorRed ()
{
    return mOptions[ThumbnailOptions::ThumbColor].value ().c ()[0];
}

inline unsigned short
ThumbnailOptions::optionGetThumbColorGreen ()
{
    return mOptions[ThumbnailOptions::ThumbColor].value ().c ()[1];
}


inline unsigned short
ThumbnailOptions::optionGetThumbColorBlue ()
{
    return mOptions[ThumbnailOptions::ThumbColor].value ().c ()[2];
}


inline unsigned short
ThumbnailOptions::optionGetThumbColorAlpha ()
{
    return mOptions[ThumbnailOptions::ThumbColor].value ().c ()[3];
}


inline void
ThumbnailOptions::optionSetThumbColorNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::ThumbColor] = notify;
}

inline bool
ThumbnailOptions::optionGetWindowLike ()
{
    return mOptions[ThumbnailOptions::WindowLike].value ().b ();
}

inline void
ThumbnailOptions::optionSetWindowLikeNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::WindowLike] = notify;
}

inline bool
ThumbnailOptions::optionGetMipmap ()
{
    return mOptions[ThumbnailOptions::Mipmap].value ().b ();
}

inline void
ThumbnailOptions::optionSetMipmapNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::Mipmap] = notify;
}

inline bool
ThumbnailOptions::optionGetCurrentViewport ()
{
    return mOptions[ThumbnailOptions::CurrentViewport].value ().b ();
}

inline void
ThumbnailOptions::optionSetCurrentViewportNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::CurrentViewport] = notify;
}

inline bool
ThumbnailOptions::optionGetTitleEnabled ()
{
    return mOptions[ThumbnailOptions::TitleEnabled].value ().b ();
}

inline void
ThumbnailOptions::optionSetTitleEnabledNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::TitleEnabled] = notify;
}

inline bool
ThumbnailOptions::optionGetFontBold ()
{
    return mOptions[ThumbnailOptions::FontBold].value ().b ();
}

inline void
ThumbnailOptions::optionSetFontBoldNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::FontBold] = notify;
}

inline int
ThumbnailOptions::optionGetTextDistance ()
{
    return mOptions[ThumbnailOptions::TextDistance].value ().i ();
}

inline void
ThumbnailOptions::optionSetTextDistanceNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::TextDistance] = notify;
}

inline int
ThumbnailOptions::optionGetFontSize ()
{
    return mOptions[ThumbnailOptions::FontSize].value ().i ();
}

inline void
ThumbnailOptions::optionSetFontSizeNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::FontSize] = notify;
}

inline unsigned short *
ThumbnailOptions::optionGetFontColor ()
{
    return mOptions[ThumbnailOptions::FontColor].value ().c ();
}

inline unsigned short
ThumbnailOptions::optionGetFontColorRed ()
{
    return mOptions[ThumbnailOptions::FontColor].value ().c ()[0];
}

inline unsigned short
ThumbnailOptions::optionGetFontColorGreen ()
{
    return mOptions[ThumbnailOptions::FontColor].value ().c ()[1];
}


inline unsigned short
ThumbnailOptions::optionGetFontColorBlue ()
{
    return mOptions[ThumbnailOptions::FontColor].value ().c ()[2];
}


inline unsigned short
ThumbnailOptions::optionGetFontColorAlpha ()
{
    return mOptions[ThumbnailOptions::FontColor].value ().c ()[3];
}


inline void
ThumbnailOptions::optionSetFontColorNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::FontColor] = notify;
}

inline unsigned short *
ThumbnailOptions::optionGetFontBackgroundColor ()
{
    return mOptions[ThumbnailOptions::FontBackgroundColor].value ().c ();
}

inline unsigned short
ThumbnailOptions::optionGetFontBackgroundColorRed ()
{
    return mOptions[ThumbnailOptions::FontBackgroundColor].value ().c ()[0];
}

inline unsigned short
ThumbnailOptions::optionGetFontBackgroundColorGreen ()
{
    return mOptions[ThumbnailOptions::FontBackgroundColor].value ().c ()[1];
}


inline unsigned short
ThumbnailOptions::optionGetFontBackgroundColorBlue ()
{
    return mOptions[ThumbnailOptions::FontBackgroundColor].value ().c ()[2];
}


inline unsigned short
ThumbnailOptions::optionGetFontBackgroundColorAlpha ()
{
    return mOptions[ThumbnailOptions::FontBackgroundColor].value ().c ()[3];
}


inline void
ThumbnailOptions::optionSetFontBackgroundColorNotify (ThumbnailOptions::ChangeNotify notify)
{
    mNotify[ThumbnailOptions::FontBackgroundColor] = notify;
}



#endif
