/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WALL_OPTIONS_H
#define _WALL_OPTIONS_H

#include <core/core.h>

class WallOptions : public CompOption::Class {
    public:
        enum Options {
            ShowSwitcher,
            Miniscreen,
            PreviewTimeout,
            PreviewScale,
            EdgeRadius,
            BorderWidth,
            OutlineColor,
            BackgroundGradientBaseColor,
            BackgroundGradientHighlightColor,
            BackgroundGradientShadowColor,
            ThumbGradientBaseColor,
            ThumbGradientHighlightColor,
            ThumbHighlightGradientBaseColor,
            ThumbHighlightGradientShadowColor,
            ArrowBaseColor,
            ArrowShadowColor,
            AllowWraparound,
            SlideDuration,
            NoSlideMatch,
            AutoSwitchVpAndWindow,
            LeftKey,
            LeftButton,
            RightKey,
            RightButton,
            UpKey,
            UpButton,
            DownKey,
            DownButton,
            NextKey,
            NextButton,
            PrevKey,
            PrevButton,
            LeftWindowKey,
            RightWindowKey,
            UpWindowKey,
            DownWindowKey,
            FlipLeftEdge,
            FlipRightEdge,
            FlipUpEdge,
            FlipDownEdge,
            Mmmode,
            EdgeflipPointer,
            EdgeflipMove,
            EdgeflipDnd,
            OptionNum
        };

        enum Mmmode {
            MmmodeSwitchAll = 0,
            MmmodeSwitchSeparately = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WallOptions (bool init = true);
        virtual ~WallOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        bool optionGetShowSwitcher ();
        void optionSetShowSwitcherNotify (ChangeNotify notify);

        bool optionGetMiniscreen ();
        void optionSetMiniscreenNotify (ChangeNotify notify);

        float optionGetPreviewTimeout ();
        void optionSetPreviewTimeoutNotify (ChangeNotify notify);

        int optionGetPreviewScale ();
        void optionSetPreviewScaleNotify (ChangeNotify notify);

        int optionGetEdgeRadius ();
        void optionSetEdgeRadiusNotify (ChangeNotify notify);

        int optionGetBorderWidth ();
        void optionSetBorderWidthNotify (ChangeNotify notify);

        unsigned short * optionGetOutlineColor ();
        unsigned short optionGetOutlineColorRed ();
        unsigned short optionGetOutlineColorGreen ();
        unsigned short optionGetOutlineColorBlue ();
        unsigned short optionGetOutlineColorAlpha ();
        void optionSetOutlineColorNotify (ChangeNotify notify);

        unsigned short * optionGetBackgroundGradientBaseColor ();
        unsigned short optionGetBackgroundGradientBaseColorRed ();
        unsigned short optionGetBackgroundGradientBaseColorGreen ();
        unsigned short optionGetBackgroundGradientBaseColorBlue ();
        unsigned short optionGetBackgroundGradientBaseColorAlpha ();
        void optionSetBackgroundGradientBaseColorNotify (ChangeNotify notify);

        unsigned short * optionGetBackgroundGradientHighlightColor ();
        unsigned short optionGetBackgroundGradientHighlightColorRed ();
        unsigned short optionGetBackgroundGradientHighlightColorGreen ();
        unsigned short optionGetBackgroundGradientHighlightColorBlue ();
        unsigned short optionGetBackgroundGradientHighlightColorAlpha ();
        void optionSetBackgroundGradientHighlightColorNotify (ChangeNotify notify);

        unsigned short * optionGetBackgroundGradientShadowColor ();
        unsigned short optionGetBackgroundGradientShadowColorRed ();
        unsigned short optionGetBackgroundGradientShadowColorGreen ();
        unsigned short optionGetBackgroundGradientShadowColorBlue ();
        unsigned short optionGetBackgroundGradientShadowColorAlpha ();
        void optionSetBackgroundGradientShadowColorNotify (ChangeNotify notify);

        unsigned short * optionGetThumbGradientBaseColor ();
        unsigned short optionGetThumbGradientBaseColorRed ();
        unsigned short optionGetThumbGradientBaseColorGreen ();
        unsigned short optionGetThumbGradientBaseColorBlue ();
        unsigned short optionGetThumbGradientBaseColorAlpha ();
        void optionSetThumbGradientBaseColorNotify (ChangeNotify notify);

        unsigned short * optionGetThumbGradientHighlightColor ();
        unsigned short optionGetThumbGradientHighlightColorRed ();
        unsigned short optionGetThumbGradientHighlightColorGreen ();
        unsigned short optionGetThumbGradientHighlightColorBlue ();
        unsigned short optionGetThumbGradientHighlightColorAlpha ();
        void optionSetThumbGradientHighlightColorNotify (ChangeNotify notify);

        unsigned short * optionGetThumbHighlightGradientBaseColor ();
        unsigned short optionGetThumbHighlightGradientBaseColorRed ();
        unsigned short optionGetThumbHighlightGradientBaseColorGreen ();
        unsigned short optionGetThumbHighlightGradientBaseColorBlue ();
        unsigned short optionGetThumbHighlightGradientBaseColorAlpha ();
        void optionSetThumbHighlightGradientBaseColorNotify (ChangeNotify notify);

        unsigned short * optionGetThumbHighlightGradientShadowColor ();
        unsigned short optionGetThumbHighlightGradientShadowColorRed ();
        unsigned short optionGetThumbHighlightGradientShadowColorGreen ();
        unsigned short optionGetThumbHighlightGradientShadowColorBlue ();
        unsigned short optionGetThumbHighlightGradientShadowColorAlpha ();
        void optionSetThumbHighlightGradientShadowColorNotify (ChangeNotify notify);

        unsigned short * optionGetArrowBaseColor ();
        unsigned short optionGetArrowBaseColorRed ();
        unsigned short optionGetArrowBaseColorGreen ();
        unsigned short optionGetArrowBaseColorBlue ();
        unsigned short optionGetArrowBaseColorAlpha ();
        void optionSetArrowBaseColorNotify (ChangeNotify notify);

        unsigned short * optionGetArrowShadowColor ();
        unsigned short optionGetArrowShadowColorRed ();
        unsigned short optionGetArrowShadowColorGreen ();
        unsigned short optionGetArrowShadowColorBlue ();
        unsigned short optionGetArrowShadowColorAlpha ();
        void optionSetArrowShadowColorNotify (ChangeNotify notify);

        bool optionGetAllowWraparound ();
        void optionSetAllowWraparoundNotify (ChangeNotify notify);

        float optionGetSlideDuration ();
        void optionSetSlideDurationNotify (ChangeNotify notify);

        CompMatch & optionGetNoSlideMatch ();
        void optionSetNoSlideMatchNotify (ChangeNotify notify);

        bool optionGetAutoSwitchVpAndWindow ();
        void optionSetAutoSwitchVpAndWindowNotify (ChangeNotify notify);

        CompAction & optionGetLeftKey ();
        void optionSetLeftKeyInitiate (CompAction::CallBack init);
        void optionSetLeftKeyTerminate (CompAction::CallBack term);
        void optionSetLeftKeyNotify (ChangeNotify notify);

        CompAction & optionGetLeftButton ();
        void optionSetLeftButtonInitiate (CompAction::CallBack init);
        void optionSetLeftButtonTerminate (CompAction::CallBack term);
        void optionSetLeftButtonNotify (ChangeNotify notify);

        CompAction & optionGetRightKey ();
        void optionSetRightKeyInitiate (CompAction::CallBack init);
        void optionSetRightKeyTerminate (CompAction::CallBack term);
        void optionSetRightKeyNotify (ChangeNotify notify);

        CompAction & optionGetRightButton ();
        void optionSetRightButtonInitiate (CompAction::CallBack init);
        void optionSetRightButtonTerminate (CompAction::CallBack term);
        void optionSetRightButtonNotify (ChangeNotify notify);

        CompAction & optionGetUpKey ();
        void optionSetUpKeyInitiate (CompAction::CallBack init);
        void optionSetUpKeyTerminate (CompAction::CallBack term);
        void optionSetUpKeyNotify (ChangeNotify notify);

        CompAction & optionGetUpButton ();
        void optionSetUpButtonInitiate (CompAction::CallBack init);
        void optionSetUpButtonTerminate (CompAction::CallBack term);
        void optionSetUpButtonNotify (ChangeNotify notify);

        CompAction & optionGetDownKey ();
        void optionSetDownKeyInitiate (CompAction::CallBack init);
        void optionSetDownKeyTerminate (CompAction::CallBack term);
        void optionSetDownKeyNotify (ChangeNotify notify);

        CompAction & optionGetDownButton ();
        void optionSetDownButtonInitiate (CompAction::CallBack init);
        void optionSetDownButtonTerminate (CompAction::CallBack term);
        void optionSetDownButtonNotify (ChangeNotify notify);

        CompAction & optionGetNextKey ();
        void optionSetNextKeyInitiate (CompAction::CallBack init);
        void optionSetNextKeyTerminate (CompAction::CallBack term);
        void optionSetNextKeyNotify (ChangeNotify notify);

        CompAction & optionGetNextButton ();
        void optionSetNextButtonInitiate (CompAction::CallBack init);
        void optionSetNextButtonTerminate (CompAction::CallBack term);
        void optionSetNextButtonNotify (ChangeNotify notify);

        CompAction & optionGetPrevKey ();
        void optionSetPrevKeyInitiate (CompAction::CallBack init);
        void optionSetPrevKeyTerminate (CompAction::CallBack term);
        void optionSetPrevKeyNotify (ChangeNotify notify);

        CompAction & optionGetPrevButton ();
        void optionSetPrevButtonInitiate (CompAction::CallBack init);
        void optionSetPrevButtonTerminate (CompAction::CallBack term);
        void optionSetPrevButtonNotify (ChangeNotify notify);

        CompAction & optionGetLeftWindowKey ();
        void optionSetLeftWindowKeyInitiate (CompAction::CallBack init);
        void optionSetLeftWindowKeyTerminate (CompAction::CallBack term);
        void optionSetLeftWindowKeyNotify (ChangeNotify notify);

        CompAction & optionGetRightWindowKey ();
        void optionSetRightWindowKeyInitiate (CompAction::CallBack init);
        void optionSetRightWindowKeyTerminate (CompAction::CallBack term);
        void optionSetRightWindowKeyNotify (ChangeNotify notify);

        CompAction & optionGetUpWindowKey ();
        void optionSetUpWindowKeyInitiate (CompAction::CallBack init);
        void optionSetUpWindowKeyTerminate (CompAction::CallBack term);
        void optionSetUpWindowKeyNotify (ChangeNotify notify);

        CompAction & optionGetDownWindowKey ();
        void optionSetDownWindowKeyInitiate (CompAction::CallBack init);
        void optionSetDownWindowKeyTerminate (CompAction::CallBack term);
        void optionSetDownWindowKeyNotify (ChangeNotify notify);

        CompAction & optionGetFlipLeftEdge ();
        void optionSetFlipLeftEdgeInitiate (CompAction::CallBack init);
        void optionSetFlipLeftEdgeTerminate (CompAction::CallBack term);
        void optionSetFlipLeftEdgeNotify (ChangeNotify notify);

        CompAction & optionGetFlipRightEdge ();
        void optionSetFlipRightEdgeInitiate (CompAction::CallBack init);
        void optionSetFlipRightEdgeTerminate (CompAction::CallBack term);
        void optionSetFlipRightEdgeNotify (ChangeNotify notify);

        CompAction & optionGetFlipUpEdge ();
        void optionSetFlipUpEdgeInitiate (CompAction::CallBack init);
        void optionSetFlipUpEdgeTerminate (CompAction::CallBack term);
        void optionSetFlipUpEdgeNotify (ChangeNotify notify);

        CompAction & optionGetFlipDownEdge ();
        void optionSetFlipDownEdgeInitiate (CompAction::CallBack init);
        void optionSetFlipDownEdgeTerminate (CompAction::CallBack term);
        void optionSetFlipDownEdgeNotify (ChangeNotify notify);

        int optionGetMmmode ();
        void optionSetMmmodeNotify (ChangeNotify notify);

        bool optionGetEdgeflipPointer ();
        void optionSetEdgeflipPointerNotify (ChangeNotify notify);

        bool optionGetEdgeflipMove ();
        void optionSetEdgeflipMoveNotify (ChangeNotify notify);

        bool optionGetEdgeflipDnd ();
        void optionSetEdgeflipDndNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline bool
WallOptions::optionGetShowSwitcher ()
{
    return mOptions[WallOptions::ShowSwitcher].value ().b ();
}

inline void
WallOptions::optionSetShowSwitcherNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ShowSwitcher] = notify;
}

inline bool
WallOptions::optionGetMiniscreen ()
{
    return mOptions[WallOptions::Miniscreen].value ().b ();
}

inline void
WallOptions::optionSetMiniscreenNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::Miniscreen] = notify;
}

inline float
WallOptions::optionGetPreviewTimeout ()
{
    return mOptions[WallOptions::PreviewTimeout].value ().f ();
}

inline void
WallOptions::optionSetPreviewTimeoutNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::PreviewTimeout] = notify;
}

inline int
WallOptions::optionGetPreviewScale ()
{
    return mOptions[WallOptions::PreviewScale].value ().i ();
}

inline void
WallOptions::optionSetPreviewScaleNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::PreviewScale] = notify;
}

inline int
WallOptions::optionGetEdgeRadius ()
{
    return mOptions[WallOptions::EdgeRadius].value ().i ();
}

inline void
WallOptions::optionSetEdgeRadiusNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::EdgeRadius] = notify;
}

inline int
WallOptions::optionGetBorderWidth ()
{
    return mOptions[WallOptions::BorderWidth].value ().i ();
}

inline void
WallOptions::optionSetBorderWidthNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::BorderWidth] = notify;
}

inline unsigned short *
WallOptions::optionGetOutlineColor ()
{
    return mOptions[WallOptions::OutlineColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetOutlineColorRed ()
{
    return mOptions[WallOptions::OutlineColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetOutlineColorGreen ()
{
    return mOptions[WallOptions::OutlineColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetOutlineColorBlue ()
{
    return mOptions[WallOptions::OutlineColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetOutlineColorAlpha ()
{
    return mOptions[WallOptions::OutlineColor].value ().c ()[3];
}


inline void
WallOptions::optionSetOutlineColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::OutlineColor] = notify;
}

inline unsigned short *
WallOptions::optionGetBackgroundGradientBaseColor ()
{
    return mOptions[WallOptions::BackgroundGradientBaseColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetBackgroundGradientBaseColorRed ()
{
    return mOptions[WallOptions::BackgroundGradientBaseColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetBackgroundGradientBaseColorGreen ()
{
    return mOptions[WallOptions::BackgroundGradientBaseColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetBackgroundGradientBaseColorBlue ()
{
    return mOptions[WallOptions::BackgroundGradientBaseColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetBackgroundGradientBaseColorAlpha ()
{
    return mOptions[WallOptions::BackgroundGradientBaseColor].value ().c ()[3];
}


inline void
WallOptions::optionSetBackgroundGradientBaseColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::BackgroundGradientBaseColor] = notify;
}

inline unsigned short *
WallOptions::optionGetBackgroundGradientHighlightColor ()
{
    return mOptions[WallOptions::BackgroundGradientHighlightColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetBackgroundGradientHighlightColorRed ()
{
    return mOptions[WallOptions::BackgroundGradientHighlightColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetBackgroundGradientHighlightColorGreen ()
{
    return mOptions[WallOptions::BackgroundGradientHighlightColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetBackgroundGradientHighlightColorBlue ()
{
    return mOptions[WallOptions::BackgroundGradientHighlightColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetBackgroundGradientHighlightColorAlpha ()
{
    return mOptions[WallOptions::BackgroundGradientHighlightColor].value ().c ()[3];
}


inline void
WallOptions::optionSetBackgroundGradientHighlightColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::BackgroundGradientHighlightColor] = notify;
}

inline unsigned short *
WallOptions::optionGetBackgroundGradientShadowColor ()
{
    return mOptions[WallOptions::BackgroundGradientShadowColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetBackgroundGradientShadowColorRed ()
{
    return mOptions[WallOptions::BackgroundGradientShadowColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetBackgroundGradientShadowColorGreen ()
{
    return mOptions[WallOptions::BackgroundGradientShadowColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetBackgroundGradientShadowColorBlue ()
{
    return mOptions[WallOptions::BackgroundGradientShadowColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetBackgroundGradientShadowColorAlpha ()
{
    return mOptions[WallOptions::BackgroundGradientShadowColor].value ().c ()[3];
}


inline void
WallOptions::optionSetBackgroundGradientShadowColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::BackgroundGradientShadowColor] = notify;
}

inline unsigned short *
WallOptions::optionGetThumbGradientBaseColor ()
{
    return mOptions[WallOptions::ThumbGradientBaseColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetThumbGradientBaseColorRed ()
{
    return mOptions[WallOptions::ThumbGradientBaseColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetThumbGradientBaseColorGreen ()
{
    return mOptions[WallOptions::ThumbGradientBaseColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetThumbGradientBaseColorBlue ()
{
    return mOptions[WallOptions::ThumbGradientBaseColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetThumbGradientBaseColorAlpha ()
{
    return mOptions[WallOptions::ThumbGradientBaseColor].value ().c ()[3];
}


inline void
WallOptions::optionSetThumbGradientBaseColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ThumbGradientBaseColor] = notify;
}

inline unsigned short *
WallOptions::optionGetThumbGradientHighlightColor ()
{
    return mOptions[WallOptions::ThumbGradientHighlightColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetThumbGradientHighlightColorRed ()
{
    return mOptions[WallOptions::ThumbGradientHighlightColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetThumbGradientHighlightColorGreen ()
{
    return mOptions[WallOptions::ThumbGradientHighlightColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetThumbGradientHighlightColorBlue ()
{
    return mOptions[WallOptions::ThumbGradientHighlightColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetThumbGradientHighlightColorAlpha ()
{
    return mOptions[WallOptions::ThumbGradientHighlightColor].value ().c ()[3];
}


inline void
WallOptions::optionSetThumbGradientHighlightColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ThumbGradientHighlightColor] = notify;
}

inline unsigned short *
WallOptions::optionGetThumbHighlightGradientBaseColor ()
{
    return mOptions[WallOptions::ThumbHighlightGradientBaseColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetThumbHighlightGradientBaseColorRed ()
{
    return mOptions[WallOptions::ThumbHighlightGradientBaseColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetThumbHighlightGradientBaseColorGreen ()
{
    return mOptions[WallOptions::ThumbHighlightGradientBaseColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetThumbHighlightGradientBaseColorBlue ()
{
    return mOptions[WallOptions::ThumbHighlightGradientBaseColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetThumbHighlightGradientBaseColorAlpha ()
{
    return mOptions[WallOptions::ThumbHighlightGradientBaseColor].value ().c ()[3];
}


inline void
WallOptions::optionSetThumbHighlightGradientBaseColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ThumbHighlightGradientBaseColor] = notify;
}

inline unsigned short *
WallOptions::optionGetThumbHighlightGradientShadowColor ()
{
    return mOptions[WallOptions::ThumbHighlightGradientShadowColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetThumbHighlightGradientShadowColorRed ()
{
    return mOptions[WallOptions::ThumbHighlightGradientShadowColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetThumbHighlightGradientShadowColorGreen ()
{
    return mOptions[WallOptions::ThumbHighlightGradientShadowColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetThumbHighlightGradientShadowColorBlue ()
{
    return mOptions[WallOptions::ThumbHighlightGradientShadowColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetThumbHighlightGradientShadowColorAlpha ()
{
    return mOptions[WallOptions::ThumbHighlightGradientShadowColor].value ().c ()[3];
}


inline void
WallOptions::optionSetThumbHighlightGradientShadowColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ThumbHighlightGradientShadowColor] = notify;
}

inline unsigned short *
WallOptions::optionGetArrowBaseColor ()
{
    return mOptions[WallOptions::ArrowBaseColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetArrowBaseColorRed ()
{
    return mOptions[WallOptions::ArrowBaseColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetArrowBaseColorGreen ()
{
    return mOptions[WallOptions::ArrowBaseColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetArrowBaseColorBlue ()
{
    return mOptions[WallOptions::ArrowBaseColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetArrowBaseColorAlpha ()
{
    return mOptions[WallOptions::ArrowBaseColor].value ().c ()[3];
}


inline void
WallOptions::optionSetArrowBaseColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ArrowBaseColor] = notify;
}

inline unsigned short *
WallOptions::optionGetArrowShadowColor ()
{
    return mOptions[WallOptions::ArrowShadowColor].value ().c ();
}

inline unsigned short
WallOptions::optionGetArrowShadowColorRed ()
{
    return mOptions[WallOptions::ArrowShadowColor].value ().c ()[0];
}

inline unsigned short
WallOptions::optionGetArrowShadowColorGreen ()
{
    return mOptions[WallOptions::ArrowShadowColor].value ().c ()[1];
}


inline unsigned short
WallOptions::optionGetArrowShadowColorBlue ()
{
    return mOptions[WallOptions::ArrowShadowColor].value ().c ()[2];
}


inline unsigned short
WallOptions::optionGetArrowShadowColorAlpha ()
{
    return mOptions[WallOptions::ArrowShadowColor].value ().c ()[3];
}


inline void
WallOptions::optionSetArrowShadowColorNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::ArrowShadowColor] = notify;
}

inline bool
WallOptions::optionGetAllowWraparound ()
{
    return mOptions[WallOptions::AllowWraparound].value ().b ();
}

inline void
WallOptions::optionSetAllowWraparoundNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::AllowWraparound] = notify;
}

inline float
WallOptions::optionGetSlideDuration ()
{
    return mOptions[WallOptions::SlideDuration].value ().f ();
}

inline void
WallOptions::optionSetSlideDurationNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::SlideDuration] = notify;
}

inline CompMatch &
WallOptions::optionGetNoSlideMatch ()
{
    return mOptions[WallOptions::NoSlideMatch].value ().match ();
}

inline void
WallOptions::optionSetNoSlideMatchNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::NoSlideMatch] = notify;
}

inline bool
WallOptions::optionGetAutoSwitchVpAndWindow ()
{
    return mOptions[WallOptions::AutoSwitchVpAndWindow].value ().b ();
}

inline void
WallOptions::optionSetAutoSwitchVpAndWindowNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::AutoSwitchVpAndWindow] = notify;
}

inline CompAction &
WallOptions::optionGetLeftKey ()
{
    return mOptions[WallOptions::LeftKey].value ().action ();
}

inline void
WallOptions::optionSetLeftKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::LeftKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetLeftKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::LeftKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetLeftKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::LeftKey] = notify;
}

inline CompAction &
WallOptions::optionGetLeftButton ()
{
    return mOptions[WallOptions::LeftButton].value ().action ();
}

inline void
WallOptions::optionSetLeftButtonInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::LeftButton].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetLeftButtonTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::LeftButton].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetLeftButtonNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::LeftButton] = notify;
}

inline CompAction &
WallOptions::optionGetRightKey ()
{
    return mOptions[WallOptions::RightKey].value ().action ();
}

inline void
WallOptions::optionSetRightKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::RightKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetRightKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::RightKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetRightKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::RightKey] = notify;
}

inline CompAction &
WallOptions::optionGetRightButton ()
{
    return mOptions[WallOptions::RightButton].value ().action ();
}

inline void
WallOptions::optionSetRightButtonInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::RightButton].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetRightButtonTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::RightButton].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetRightButtonNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::RightButton] = notify;
}

inline CompAction &
WallOptions::optionGetUpKey ()
{
    return mOptions[WallOptions::UpKey].value ().action ();
}

inline void
WallOptions::optionSetUpKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::UpKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetUpKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::UpKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetUpKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::UpKey] = notify;
}

inline CompAction &
WallOptions::optionGetUpButton ()
{
    return mOptions[WallOptions::UpButton].value ().action ();
}

inline void
WallOptions::optionSetUpButtonInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::UpButton].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetUpButtonTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::UpButton].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetUpButtonNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::UpButton] = notify;
}

inline CompAction &
WallOptions::optionGetDownKey ()
{
    return mOptions[WallOptions::DownKey].value ().action ();
}

inline void
WallOptions::optionSetDownKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::DownKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetDownKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::DownKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetDownKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::DownKey] = notify;
}

inline CompAction &
WallOptions::optionGetDownButton ()
{
    return mOptions[WallOptions::DownButton].value ().action ();
}

inline void
WallOptions::optionSetDownButtonInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::DownButton].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetDownButtonTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::DownButton].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetDownButtonNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::DownButton] = notify;
}

inline CompAction &
WallOptions::optionGetNextKey ()
{
    return mOptions[WallOptions::NextKey].value ().action ();
}

inline void
WallOptions::optionSetNextKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::NextKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetNextKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::NextKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetNextKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::NextKey] = notify;
}

inline CompAction &
WallOptions::optionGetNextButton ()
{
    return mOptions[WallOptions::NextButton].value ().action ();
}

inline void
WallOptions::optionSetNextButtonInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::NextButton].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetNextButtonTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::NextButton].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetNextButtonNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::NextButton] = notify;
}

inline CompAction &
WallOptions::optionGetPrevKey ()
{
    return mOptions[WallOptions::PrevKey].value ().action ();
}

inline void
WallOptions::optionSetPrevKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::PrevKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetPrevKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::PrevKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetPrevKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::PrevKey] = notify;
}

inline CompAction &
WallOptions::optionGetPrevButton ()
{
    return mOptions[WallOptions::PrevButton].value ().action ();
}

inline void
WallOptions::optionSetPrevButtonInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::PrevButton].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetPrevButtonTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::PrevButton].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetPrevButtonNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::PrevButton] = notify;
}

inline CompAction &
WallOptions::optionGetLeftWindowKey ()
{
    return mOptions[WallOptions::LeftWindowKey].value ().action ();
}

inline void
WallOptions::optionSetLeftWindowKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::LeftWindowKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetLeftWindowKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::LeftWindowKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetLeftWindowKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::LeftWindowKey] = notify;
}

inline CompAction &
WallOptions::optionGetRightWindowKey ()
{
    return mOptions[WallOptions::RightWindowKey].value ().action ();
}

inline void
WallOptions::optionSetRightWindowKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::RightWindowKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetRightWindowKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::RightWindowKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetRightWindowKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::RightWindowKey] = notify;
}

inline CompAction &
WallOptions::optionGetUpWindowKey ()
{
    return mOptions[WallOptions::UpWindowKey].value ().action ();
}

inline void
WallOptions::optionSetUpWindowKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::UpWindowKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetUpWindowKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::UpWindowKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetUpWindowKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::UpWindowKey] = notify;
}

inline CompAction &
WallOptions::optionGetDownWindowKey ()
{
    return mOptions[WallOptions::DownWindowKey].value ().action ();
}

inline void
WallOptions::optionSetDownWindowKeyInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::DownWindowKey].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetDownWindowKeyTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::DownWindowKey].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetDownWindowKeyNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::DownWindowKey] = notify;
}

inline CompAction &
WallOptions::optionGetFlipLeftEdge ()
{
    return mOptions[WallOptions::FlipLeftEdge].value ().action ();
}

inline void
WallOptions::optionSetFlipLeftEdgeInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::FlipLeftEdge].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetFlipLeftEdgeTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::FlipLeftEdge].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetFlipLeftEdgeNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::FlipLeftEdge] = notify;
}

inline CompAction &
WallOptions::optionGetFlipRightEdge ()
{
    return mOptions[WallOptions::FlipRightEdge].value ().action ();
}

inline void
WallOptions::optionSetFlipRightEdgeInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::FlipRightEdge].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetFlipRightEdgeTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::FlipRightEdge].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetFlipRightEdgeNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::FlipRightEdge] = notify;
}

inline CompAction &
WallOptions::optionGetFlipUpEdge ()
{
    return mOptions[WallOptions::FlipUpEdge].value ().action ();
}

inline void
WallOptions::optionSetFlipUpEdgeInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::FlipUpEdge].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetFlipUpEdgeTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::FlipUpEdge].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetFlipUpEdgeNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::FlipUpEdge] = notify;
}

inline CompAction &
WallOptions::optionGetFlipDownEdge ()
{
    return mOptions[WallOptions::FlipDownEdge].value ().action ();
}

inline void
WallOptions::optionSetFlipDownEdgeInitiate (CompAction::CallBack init)
{
    mOptions[WallOptions::FlipDownEdge].value ().action ().setInitiate (init);
}

inline void
WallOptions::optionSetFlipDownEdgeTerminate (CompAction::CallBack term)
{
    mOptions[WallOptions::FlipDownEdge].value ().action ().setTerminate (term);
}

inline void
WallOptions::optionSetFlipDownEdgeNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::FlipDownEdge] = notify;
}

inline int
WallOptions::optionGetMmmode ()
{
    return mOptions[WallOptions::Mmmode].value ().i ();
}

inline void
WallOptions::optionSetMmmodeNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::Mmmode] = notify;
}

inline bool
WallOptions::optionGetEdgeflipPointer ()
{
    return mOptions[WallOptions::EdgeflipPointer].value ().b ();
}

inline void
WallOptions::optionSetEdgeflipPointerNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::EdgeflipPointer] = notify;
}

inline bool
WallOptions::optionGetEdgeflipMove ()
{
    return mOptions[WallOptions::EdgeflipMove].value ().b ();
}

inline void
WallOptions::optionSetEdgeflipMoveNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::EdgeflipMove] = notify;
}

inline bool
WallOptions::optionGetEdgeflipDnd ()
{
    return mOptions[WallOptions::EdgeflipDnd].value ().b ();
}

inline void
WallOptions::optionSetEdgeflipDndNotify (WallOptions::ChangeNotify notify)
{
    mNotify[WallOptions::EdgeflipDnd] = notify;
}



#endif
