/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WALLPAPER_OPTIONS_H
#define _WALLPAPER_OPTIONS_H

#include <core/core.h>

class WallpaperOptions : public CompOption::Class {
    public:
        enum Options {
            BgImage,
            BgImagePos,
            BgFillType,
            BgColor1,
            BgColor2,
            CycleWallpapers,
            CycleTimeout,
            FadeDuration,
            OptionNum
        };

        enum BgImagePos {
            BgImagePosScaleAndCrop = 0,
            BgImagePosScaled = 1,
            BgImagePosCentered = 2,
            BgImagePosTiled = 3,
            BgImagePosCenterTiled = 4,
        };

        enum BgFillType {
            BgFillTypeSolidFill = 0,
            BgFillTypeVerticalGradient = 1,
            BgFillTypeHorizontalGradient = 2,
        };

        #define BgImagePosScaleAndCropMask (1 << 0)
        #define BgImagePosScaledMask (1 << 1)
        #define BgImagePosCenteredMask (1 << 2)
        #define BgImagePosTiledMask (1 << 3)
        #define BgImagePosCenterTiledMask (1 << 4)


        #define BgFillTypeSolidFillMask (1 << 0)
        #define BgFillTypeVerticalGradientMask (1 << 1)
        #define BgFillTypeHorizontalGradientMask (1 << 2)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WallpaperOptions (bool init = true);
        virtual ~WallpaperOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompOption::Value::Vector & optionGetBgImage ();
        void optionSetBgImageNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetBgImagePos ();
        unsigned int optionGetBgImagePosMask ();
        void optionSetBgImagePosNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetBgFillType ();
        unsigned int optionGetBgFillTypeMask ();
        void optionSetBgFillTypeNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetBgColor1 ();
        void optionSetBgColor1Notify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetBgColor2 ();
        void optionSetBgColor2Notify (ChangeNotify notify);

        bool optionGetCycleWallpapers ();
        void optionSetCycleWallpapersNotify (ChangeNotify notify);

        float optionGetCycleTimeout ();
        void optionSetCycleTimeoutNotify (ChangeNotify notify);

        float optionGetFadeDuration ();
        void optionSetFadeDurationNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mBgImagePosMask;
        unsigned int mBgFillTypeMask;

};


inline CompOption::Value::Vector &
WallpaperOptions::optionGetBgImage ()
{
    return mOptions[WallpaperOptions::BgImage].value ().list ();
}

inline void
WallpaperOptions::optionSetBgImageNotify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::BgImage] = notify;
}

inline CompOption::Value::Vector &
WallpaperOptions::optionGetBgImagePos ()
{
    return mOptions[WallpaperOptions::BgImagePos].value ().list ();
}

inline unsigned int
WallpaperOptions::optionGetBgImagePosMask ()
{
    return mBgImagePosMask;
}

inline void
WallpaperOptions::optionSetBgImagePosNotify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::BgImagePos] = notify;
}

inline CompOption::Value::Vector &
WallpaperOptions::optionGetBgFillType ()
{
    return mOptions[WallpaperOptions::BgFillType].value ().list ();
}

inline unsigned int
WallpaperOptions::optionGetBgFillTypeMask ()
{
    return mBgFillTypeMask;
}

inline void
WallpaperOptions::optionSetBgFillTypeNotify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::BgFillType] = notify;
}

inline CompOption::Value::Vector &
WallpaperOptions::optionGetBgColor1 ()
{
    return mOptions[WallpaperOptions::BgColor1].value ().list ();
}

inline void
WallpaperOptions::optionSetBgColor1Notify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::BgColor1] = notify;
}

inline CompOption::Value::Vector &
WallpaperOptions::optionGetBgColor2 ()
{
    return mOptions[WallpaperOptions::BgColor2].value ().list ();
}

inline void
WallpaperOptions::optionSetBgColor2Notify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::BgColor2] = notify;
}

inline bool
WallpaperOptions::optionGetCycleWallpapers ()
{
    return mOptions[WallpaperOptions::CycleWallpapers].value ().b ();
}

inline void
WallpaperOptions::optionSetCycleWallpapersNotify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::CycleWallpapers] = notify;
}

inline float
WallpaperOptions::optionGetCycleTimeout ()
{
    return mOptions[WallpaperOptions::CycleTimeout].value ().f ();
}

inline void
WallpaperOptions::optionSetCycleTimeoutNotify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::CycleTimeout] = notify;
}

inline float
WallpaperOptions::optionGetFadeDuration ()
{
    return mOptions[WallpaperOptions::FadeDuration].value ().f ();
}

inline void
WallpaperOptions::optionSetFadeDurationNotify (WallpaperOptions::ChangeNotify notify)
{
    mNotify[WallpaperOptions::FadeDuration] = notify;
}



#endif
