/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WATER_OPTIONS_H
#define _WATER_OPTIONS_H

#include <core/core.h>

class WaterOptions : public CompOption::Class {
    public:
        enum Options {
            InitiateKey,
            ToggleRainKey,
            ToggleWiperKey,
            OffsetScale,
            RainDelay,
            LightVecX,
            LightVecY,
            LightVecZ,
            TitleWave,
            Point,
            Line,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WaterOptions (bool init = true);
        virtual ~WaterOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetInitiateKey ();
        void optionSetInitiateKeyInitiate (CompAction::CallBack init);
        void optionSetInitiateKeyTerminate (CompAction::CallBack term);
        void optionSetInitiateKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleRainKey ();
        void optionSetToggleRainKeyInitiate (CompAction::CallBack init);
        void optionSetToggleRainKeyTerminate (CompAction::CallBack term);
        void optionSetToggleRainKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleWiperKey ();
        void optionSetToggleWiperKeyInitiate (CompAction::CallBack init);
        void optionSetToggleWiperKeyTerminate (CompAction::CallBack term);
        void optionSetToggleWiperKeyNotify (ChangeNotify notify);

        float optionGetOffsetScale ();
        void optionSetOffsetScaleNotify (ChangeNotify notify);

        int optionGetRainDelay ();
        void optionSetRainDelayNotify (ChangeNotify notify);

        float optionGetLightVecX ();
        void optionSetLightVecXNotify (ChangeNotify notify);

        float optionGetLightVecY ();
        void optionSetLightVecYNotify (ChangeNotify notify);

        float optionGetLightVecZ ();
        void optionSetLightVecZNotify (ChangeNotify notify);

        CompAction & optionGetTitleWave ();
        void optionSetTitleWaveInitiate (CompAction::CallBack init);
        void optionSetTitleWaveTerminate (CompAction::CallBack term);
        void optionSetTitleWaveNotify (ChangeNotify notify);

        CompAction & optionGetPoint ();
        void optionSetPointInitiate (CompAction::CallBack init);
        void optionSetPointTerminate (CompAction::CallBack term);
        void optionSetPointNotify (ChangeNotify notify);

        CompAction & optionGetLine ();
        void optionSetLineInitiate (CompAction::CallBack init);
        void optionSetLineTerminate (CompAction::CallBack term);
        void optionSetLineNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
WaterOptions::optionGetInitiateKey ()
{
    return mOptions[WaterOptions::InitiateKey].value ().action ();
}

inline void
WaterOptions::optionSetInitiateKeyInitiate (CompAction::CallBack init)
{
    mOptions[WaterOptions::InitiateKey].value ().action ().setInitiate (init);
}

inline void
WaterOptions::optionSetInitiateKeyTerminate (CompAction::CallBack term)
{
    mOptions[WaterOptions::InitiateKey].value ().action ().setTerminate (term);
}

inline void
WaterOptions::optionSetInitiateKeyNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::InitiateKey] = notify;
}

inline CompAction &
WaterOptions::optionGetToggleRainKey ()
{
    return mOptions[WaterOptions::ToggleRainKey].value ().action ();
}

inline void
WaterOptions::optionSetToggleRainKeyInitiate (CompAction::CallBack init)
{
    mOptions[WaterOptions::ToggleRainKey].value ().action ().setInitiate (init);
}

inline void
WaterOptions::optionSetToggleRainKeyTerminate (CompAction::CallBack term)
{
    mOptions[WaterOptions::ToggleRainKey].value ().action ().setTerminate (term);
}

inline void
WaterOptions::optionSetToggleRainKeyNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::ToggleRainKey] = notify;
}

inline CompAction &
WaterOptions::optionGetToggleWiperKey ()
{
    return mOptions[WaterOptions::ToggleWiperKey].value ().action ();
}

inline void
WaterOptions::optionSetToggleWiperKeyInitiate (CompAction::CallBack init)
{
    mOptions[WaterOptions::ToggleWiperKey].value ().action ().setInitiate (init);
}

inline void
WaterOptions::optionSetToggleWiperKeyTerminate (CompAction::CallBack term)
{
    mOptions[WaterOptions::ToggleWiperKey].value ().action ().setTerminate (term);
}

inline void
WaterOptions::optionSetToggleWiperKeyNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::ToggleWiperKey] = notify;
}

inline float
WaterOptions::optionGetOffsetScale ()
{
    return mOptions[WaterOptions::OffsetScale].value ().f ();
}

inline void
WaterOptions::optionSetOffsetScaleNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::OffsetScale] = notify;
}

inline int
WaterOptions::optionGetRainDelay ()
{
    return mOptions[WaterOptions::RainDelay].value ().i ();
}

inline void
WaterOptions::optionSetRainDelayNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::RainDelay] = notify;
}

inline float
WaterOptions::optionGetLightVecX ()
{
    return mOptions[WaterOptions::LightVecX].value ().f ();
}

inline void
WaterOptions::optionSetLightVecXNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::LightVecX] = notify;
}

inline float
WaterOptions::optionGetLightVecY ()
{
    return mOptions[WaterOptions::LightVecY].value ().f ();
}

inline void
WaterOptions::optionSetLightVecYNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::LightVecY] = notify;
}

inline float
WaterOptions::optionGetLightVecZ ()
{
    return mOptions[WaterOptions::LightVecZ].value ().f ();
}

inline void
WaterOptions::optionSetLightVecZNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::LightVecZ] = notify;
}

inline CompAction &
WaterOptions::optionGetTitleWave ()
{
    return mOptions[WaterOptions::TitleWave].value ().action ();
}

inline void
WaterOptions::optionSetTitleWaveInitiate (CompAction::CallBack init)
{
    mOptions[WaterOptions::TitleWave].value ().action ().setInitiate (init);
}

inline void
WaterOptions::optionSetTitleWaveTerminate (CompAction::CallBack term)
{
    mOptions[WaterOptions::TitleWave].value ().action ().setTerminate (term);
}

inline void
WaterOptions::optionSetTitleWaveNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::TitleWave] = notify;
}

inline CompAction &
WaterOptions::optionGetPoint ()
{
    return mOptions[WaterOptions::Point].value ().action ();
}

inline void
WaterOptions::optionSetPointInitiate (CompAction::CallBack init)
{
    mOptions[WaterOptions::Point].value ().action ().setInitiate (init);
}

inline void
WaterOptions::optionSetPointTerminate (CompAction::CallBack term)
{
    mOptions[WaterOptions::Point].value ().action ().setTerminate (term);
}

inline void
WaterOptions::optionSetPointNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::Point] = notify;
}

inline CompAction &
WaterOptions::optionGetLine ()
{
    return mOptions[WaterOptions::Line].value ().action ();
}

inline void
WaterOptions::optionSetLineInitiate (CompAction::CallBack init)
{
    mOptions[WaterOptions::Line].value ().action ().setInitiate (init);
}

inline void
WaterOptions::optionSetLineTerminate (CompAction::CallBack term)
{
    mOptions[WaterOptions::Line].value ().action ().setTerminate (term);
}

inline void
WaterOptions::optionSetLineNotify (WaterOptions::ChangeNotify notify)
{
    mNotify[WaterOptions::Line] = notify;
}



#endif
