/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WIDGET_OPTIONS_H
#define _WIDGET_OPTIONS_H

#include <core/core.h>

class WidgetOptions : public CompOption::Class {
    public:
        enum Options {
            ToggleKey,
            ToggleButton,
            ToggleEdge,
            Match,
            EndOnClick,
            FadeTime,
            BgBrightness,
            BgSaturation,
            OptionNum
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WidgetOptions (bool init = true);
        virtual ~WidgetOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetToggleKey ();
        void optionSetToggleKeyInitiate (CompAction::CallBack init);
        void optionSetToggleKeyTerminate (CompAction::CallBack term);
        void optionSetToggleKeyNotify (ChangeNotify notify);

        CompAction & optionGetToggleButton ();
        void optionSetToggleButtonInitiate (CompAction::CallBack init);
        void optionSetToggleButtonTerminate (CompAction::CallBack term);
        void optionSetToggleButtonNotify (ChangeNotify notify);

        CompAction & optionGetToggleEdge ();
        void optionSetToggleEdgeInitiate (CompAction::CallBack init);
        void optionSetToggleEdgeTerminate (CompAction::CallBack term);
        void optionSetToggleEdgeNotify (ChangeNotify notify);

        CompMatch & optionGetMatch ();
        void optionSetMatchNotify (ChangeNotify notify);

        bool optionGetEndOnClick ();
        void optionSetEndOnClickNotify (ChangeNotify notify);

        float optionGetFadeTime ();
        void optionSetFadeTimeNotify (ChangeNotify notify);

        int optionGetBgBrightness ();
        void optionSetBgBrightnessNotify (ChangeNotify notify);

        int optionGetBgSaturation ();
        void optionSetBgSaturationNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
WidgetOptions::optionGetToggleKey ()
{
    return mOptions[WidgetOptions::ToggleKey].value ().action ();
}

inline void
WidgetOptions::optionSetToggleKeyInitiate (CompAction::CallBack init)
{
    mOptions[WidgetOptions::ToggleKey].value ().action ().setInitiate (init);
}

inline void
WidgetOptions::optionSetToggleKeyTerminate (CompAction::CallBack term)
{
    mOptions[WidgetOptions::ToggleKey].value ().action ().setTerminate (term);
}

inline void
WidgetOptions::optionSetToggleKeyNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::ToggleKey] = notify;
}

inline CompAction &
WidgetOptions::optionGetToggleButton ()
{
    return mOptions[WidgetOptions::ToggleButton].value ().action ();
}

inline void
WidgetOptions::optionSetToggleButtonInitiate (CompAction::CallBack init)
{
    mOptions[WidgetOptions::ToggleButton].value ().action ().setInitiate (init);
}

inline void
WidgetOptions::optionSetToggleButtonTerminate (CompAction::CallBack term)
{
    mOptions[WidgetOptions::ToggleButton].value ().action ().setTerminate (term);
}

inline void
WidgetOptions::optionSetToggleButtonNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::ToggleButton] = notify;
}

inline CompAction &
WidgetOptions::optionGetToggleEdge ()
{
    return mOptions[WidgetOptions::ToggleEdge].value ().action ();
}

inline void
WidgetOptions::optionSetToggleEdgeInitiate (CompAction::CallBack init)
{
    mOptions[WidgetOptions::ToggleEdge].value ().action ().setInitiate (init);
}

inline void
WidgetOptions::optionSetToggleEdgeTerminate (CompAction::CallBack term)
{
    mOptions[WidgetOptions::ToggleEdge].value ().action ().setTerminate (term);
}

inline void
WidgetOptions::optionSetToggleEdgeNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::ToggleEdge] = notify;
}

inline CompMatch &
WidgetOptions::optionGetMatch ()
{
    return mOptions[WidgetOptions::Match].value ().match ();
}

inline void
WidgetOptions::optionSetMatchNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::Match] = notify;
}

inline bool
WidgetOptions::optionGetEndOnClick ()
{
    return mOptions[WidgetOptions::EndOnClick].value ().b ();
}

inline void
WidgetOptions::optionSetEndOnClickNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::EndOnClick] = notify;
}

inline float
WidgetOptions::optionGetFadeTime ()
{
    return mOptions[WidgetOptions::FadeTime].value ().f ();
}

inline void
WidgetOptions::optionSetFadeTimeNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::FadeTime] = notify;
}

inline int
WidgetOptions::optionGetBgBrightness ()
{
    return mOptions[WidgetOptions::BgBrightness].value ().i ();
}

inline void
WidgetOptions::optionSetBgBrightnessNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::BgBrightness] = notify;
}

inline int
WidgetOptions::optionGetBgSaturation ()
{
    return mOptions[WidgetOptions::BgSaturation].value ().i ();
}

inline void
WidgetOptions::optionSetBgSaturationNotify (WidgetOptions::ChangeNotify notify)
{
    mNotify[WidgetOptions::BgSaturation] = notify;
}



#endif
