/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WIZARD_OPTIONS_H
#define _WIZARD_OPTIONS_H

#include <core/core.h>

class WizardOptions : public CompOption::Class {
    public:
        enum Options {
            Toggle,
            Gx,
            Gy,
            GStrength,
            GPosx,
            GPosy,
            GSpeed,
            GAngle,
            GMovement,
            EActive,
            EName,
            ETrigger,
            EPosx,
            EPosy,
            ESpeed,
            EAngle,
            EMovement,
            ECount,
            EH,
            EDh,
            EL,
            EDl,
            EA,
            EDa,
            EDx,
            EDy,
            EDcirc,
            EVx,
            EVy,
            EVt,
            EVphi,
            EDvx,
            EDvy,
            EDvcirc,
            EDvt,
            EDvphi,
            ES,
            EDs,
            ESnew,
            EDsnew,
            EG,
            EDg,
            EGp,
            HardLimit,
            SoftLimit,
            Darken,
            Blend,
            Tnew,
            Told,
            OptionNum
        };

        enum GMovement {
            GMovementMousePosition = 0,
            GMovementFollowMouse = 1,
            GMovementBounce = 2,
            GMovementWrap = 3,
        };

        enum ETrigger {
            ETriggerPersistent = 0,
            ETriggerMouseMovement = 1,
            ETriggerRandomShot = 2,
            ETriggerRandomPeriod = 3,
        };

        enum EMovement {
            EMovementMousePosition = 0,
            EMovementFollowMouse = 1,
            EMovementBounce = 2,
            EMovementWrap = 3,
        };

        #define GMovementMousePositionMask (1 << 0)
        #define GMovementFollowMouseMask (1 << 1)
        #define GMovementBounceMask (1 << 2)
        #define GMovementWrapMask (1 << 3)


        #define ETriggerPersistentMask (1 << 0)
        #define ETriggerMouseMovementMask (1 << 1)
        #define ETriggerRandomShotMask (1 << 2)
        #define ETriggerRandomPeriodMask (1 << 3)


        #define EMovementMousePositionMask (1 << 0)
        #define EMovementFollowMouseMask (1 << 1)
        #define EMovementBounceMask (1 << 2)
        #define EMovementWrapMask (1 << 3)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WizardOptions (bool init = true);
        virtual ~WizardOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetToggle ();
        void optionSetToggleInitiate (CompAction::CallBack init);
        void optionSetToggleTerminate (CompAction::CallBack term);
        void optionSetToggleNotify (ChangeNotify notify);

        float optionGetGx ();
        void optionSetGxNotify (ChangeNotify notify);

        float optionGetGy ();
        void optionSetGyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetGStrength ();
        void optionSetGStrengthNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetGPosx ();
        void optionSetGPosxNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetGPosy ();
        void optionSetGPosyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetGSpeed ();
        void optionSetGSpeedNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetGAngle ();
        void optionSetGAngleNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetGMovement ();
        unsigned int optionGetGMovementMask ();
        void optionSetGMovementNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEActive ();
        void optionSetEActiveNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEName ();
        void optionSetENameNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetETrigger ();
        unsigned int optionGetETriggerMask ();
        void optionSetETriggerNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEPosx ();
        void optionSetEPosxNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEPosy ();
        void optionSetEPosyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetESpeed ();
        void optionSetESpeedNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEAngle ();
        void optionSetEAngleNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEMovement ();
        unsigned int optionGetEMovementMask ();
        void optionSetEMovementNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetECount ();
        void optionSetECountNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEH ();
        void optionSetEHNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDh ();
        void optionSetEDhNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEL ();
        void optionSetELNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDl ();
        void optionSetEDlNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEA ();
        void optionSetEANotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDa ();
        void optionSetEDaNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDx ();
        void optionSetEDxNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDy ();
        void optionSetEDyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDcirc ();
        void optionSetEDcircNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEVx ();
        void optionSetEVxNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEVy ();
        void optionSetEVyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEVt ();
        void optionSetEVtNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEVphi ();
        void optionSetEVphiNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDvx ();
        void optionSetEDvxNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDvy ();
        void optionSetEDvyNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDvcirc ();
        void optionSetEDvcircNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDvt ();
        void optionSetEDvtNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDvphi ();
        void optionSetEDvphiNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetES ();
        void optionSetESNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDs ();
        void optionSetEDsNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetESnew ();
        void optionSetESnewNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDsnew ();
        void optionSetEDsnewNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEG ();
        void optionSetEGNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEDg ();
        void optionSetEDgNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetEGp ();
        void optionSetEGpNotify (ChangeNotify notify);

        int optionGetHardLimit ();
        void optionSetHardLimitNotify (ChangeNotify notify);

        int optionGetSoftLimit ();
        void optionSetSoftLimitNotify (ChangeNotify notify);

        float optionGetDarken ();
        void optionSetDarkenNotify (ChangeNotify notify);

        bool optionGetBlend ();
        void optionSetBlendNotify (ChangeNotify notify);

        float optionGetTnew ();
        void optionSetTnewNotify (ChangeNotify notify);

        float optionGetTold ();
        void optionSetToldNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mGMovementMask;
        unsigned int mETriggerMask;
        unsigned int mEMovementMask;

};


inline CompAction &
WizardOptions::optionGetToggle ()
{
    return mOptions[WizardOptions::Toggle].value ().action ();
}

inline void
WizardOptions::optionSetToggleInitiate (CompAction::CallBack init)
{
    mOptions[WizardOptions::Toggle].value ().action ().setInitiate (init);
}

inline void
WizardOptions::optionSetToggleTerminate (CompAction::CallBack term)
{
    mOptions[WizardOptions::Toggle].value ().action ().setTerminate (term);
}

inline void
WizardOptions::optionSetToggleNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Toggle] = notify;
}

inline float
WizardOptions::optionGetGx ()
{
    return mOptions[WizardOptions::Gx].value ().f ();
}

inline void
WizardOptions::optionSetGxNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Gx] = notify;
}

inline float
WizardOptions::optionGetGy ()
{
    return mOptions[WizardOptions::Gy].value ().f ();
}

inline void
WizardOptions::optionSetGyNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Gy] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetGStrength ()
{
    return mOptions[WizardOptions::GStrength].value ().list ();
}

inline void
WizardOptions::optionSetGStrengthNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::GStrength] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetGPosx ()
{
    return mOptions[WizardOptions::GPosx].value ().list ();
}

inline void
WizardOptions::optionSetGPosxNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::GPosx] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetGPosy ()
{
    return mOptions[WizardOptions::GPosy].value ().list ();
}

inline void
WizardOptions::optionSetGPosyNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::GPosy] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetGSpeed ()
{
    return mOptions[WizardOptions::GSpeed].value ().list ();
}

inline void
WizardOptions::optionSetGSpeedNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::GSpeed] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetGAngle ()
{
    return mOptions[WizardOptions::GAngle].value ().list ();
}

inline void
WizardOptions::optionSetGAngleNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::GAngle] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetGMovement ()
{
    return mOptions[WizardOptions::GMovement].value ().list ();
}

inline unsigned int
WizardOptions::optionGetGMovementMask ()
{
    return mGMovementMask;
}

inline void
WizardOptions::optionSetGMovementNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::GMovement] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEActive ()
{
    return mOptions[WizardOptions::EActive].value ().list ();
}

inline void
WizardOptions::optionSetEActiveNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EActive] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEName ()
{
    return mOptions[WizardOptions::EName].value ().list ();
}

inline void
WizardOptions::optionSetENameNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EName] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetETrigger ()
{
    return mOptions[WizardOptions::ETrigger].value ().list ();
}

inline unsigned int
WizardOptions::optionGetETriggerMask ()
{
    return mETriggerMask;
}

inline void
WizardOptions::optionSetETriggerNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::ETrigger] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEPosx ()
{
    return mOptions[WizardOptions::EPosx].value ().list ();
}

inline void
WizardOptions::optionSetEPosxNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EPosx] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEPosy ()
{
    return mOptions[WizardOptions::EPosy].value ().list ();
}

inline void
WizardOptions::optionSetEPosyNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EPosy] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetESpeed ()
{
    return mOptions[WizardOptions::ESpeed].value ().list ();
}

inline void
WizardOptions::optionSetESpeedNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::ESpeed] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEAngle ()
{
    return mOptions[WizardOptions::EAngle].value ().list ();
}

inline void
WizardOptions::optionSetEAngleNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EAngle] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEMovement ()
{
    return mOptions[WizardOptions::EMovement].value ().list ();
}

inline unsigned int
WizardOptions::optionGetEMovementMask ()
{
    return mEMovementMask;
}

inline void
WizardOptions::optionSetEMovementNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EMovement] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetECount ()
{
    return mOptions[WizardOptions::ECount].value ().list ();
}

inline void
WizardOptions::optionSetECountNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::ECount] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEH ()
{
    return mOptions[WizardOptions::EH].value ().list ();
}

inline void
WizardOptions::optionSetEHNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EH] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDh ()
{
    return mOptions[WizardOptions::EDh].value ().list ();
}

inline void
WizardOptions::optionSetEDhNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDh] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEL ()
{
    return mOptions[WizardOptions::EL].value ().list ();
}

inline void
WizardOptions::optionSetELNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EL] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDl ()
{
    return mOptions[WizardOptions::EDl].value ().list ();
}

inline void
WizardOptions::optionSetEDlNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDl] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEA ()
{
    return mOptions[WizardOptions::EA].value ().list ();
}

inline void
WizardOptions::optionSetEANotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EA] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDa ()
{
    return mOptions[WizardOptions::EDa].value ().list ();
}

inline void
WizardOptions::optionSetEDaNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDa] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDx ()
{
    return mOptions[WizardOptions::EDx].value ().list ();
}

inline void
WizardOptions::optionSetEDxNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDx] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDy ()
{
    return mOptions[WizardOptions::EDy].value ().list ();
}

inline void
WizardOptions::optionSetEDyNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDy] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDcirc ()
{
    return mOptions[WizardOptions::EDcirc].value ().list ();
}

inline void
WizardOptions::optionSetEDcircNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDcirc] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEVx ()
{
    return mOptions[WizardOptions::EVx].value ().list ();
}

inline void
WizardOptions::optionSetEVxNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EVx] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEVy ()
{
    return mOptions[WizardOptions::EVy].value ().list ();
}

inline void
WizardOptions::optionSetEVyNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EVy] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEVt ()
{
    return mOptions[WizardOptions::EVt].value ().list ();
}

inline void
WizardOptions::optionSetEVtNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EVt] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEVphi ()
{
    return mOptions[WizardOptions::EVphi].value ().list ();
}

inline void
WizardOptions::optionSetEVphiNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EVphi] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDvx ()
{
    return mOptions[WizardOptions::EDvx].value ().list ();
}

inline void
WizardOptions::optionSetEDvxNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDvx] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDvy ()
{
    return mOptions[WizardOptions::EDvy].value ().list ();
}

inline void
WizardOptions::optionSetEDvyNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDvy] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDvcirc ()
{
    return mOptions[WizardOptions::EDvcirc].value ().list ();
}

inline void
WizardOptions::optionSetEDvcircNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDvcirc] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDvt ()
{
    return mOptions[WizardOptions::EDvt].value ().list ();
}

inline void
WizardOptions::optionSetEDvtNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDvt] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDvphi ()
{
    return mOptions[WizardOptions::EDvphi].value ().list ();
}

inline void
WizardOptions::optionSetEDvphiNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDvphi] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetES ()
{
    return mOptions[WizardOptions::ES].value ().list ();
}

inline void
WizardOptions::optionSetESNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::ES] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDs ()
{
    return mOptions[WizardOptions::EDs].value ().list ();
}

inline void
WizardOptions::optionSetEDsNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDs] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetESnew ()
{
    return mOptions[WizardOptions::ESnew].value ().list ();
}

inline void
WizardOptions::optionSetESnewNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::ESnew] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDsnew ()
{
    return mOptions[WizardOptions::EDsnew].value ().list ();
}

inline void
WizardOptions::optionSetEDsnewNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDsnew] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEG ()
{
    return mOptions[WizardOptions::EG].value ().list ();
}

inline void
WizardOptions::optionSetEGNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EG] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEDg ()
{
    return mOptions[WizardOptions::EDg].value ().list ();
}

inline void
WizardOptions::optionSetEDgNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EDg] = notify;
}

inline CompOption::Value::Vector &
WizardOptions::optionGetEGp ()
{
    return mOptions[WizardOptions::EGp].value ().list ();
}

inline void
WizardOptions::optionSetEGpNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::EGp] = notify;
}

inline int
WizardOptions::optionGetHardLimit ()
{
    return mOptions[WizardOptions::HardLimit].value ().i ();
}

inline void
WizardOptions::optionSetHardLimitNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::HardLimit] = notify;
}

inline int
WizardOptions::optionGetSoftLimit ()
{
    return mOptions[WizardOptions::SoftLimit].value ().i ();
}

inline void
WizardOptions::optionSetSoftLimitNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::SoftLimit] = notify;
}

inline float
WizardOptions::optionGetDarken ()
{
    return mOptions[WizardOptions::Darken].value ().f ();
}

inline void
WizardOptions::optionSetDarkenNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Darken] = notify;
}

inline bool
WizardOptions::optionGetBlend ()
{
    return mOptions[WizardOptions::Blend].value ().b ();
}

inline void
WizardOptions::optionSetBlendNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Blend] = notify;
}

inline float
WizardOptions::optionGetTnew ()
{
    return mOptions[WizardOptions::Tnew].value ().f ();
}

inline void
WizardOptions::optionSetTnewNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Tnew] = notify;
}

inline float
WizardOptions::optionGetTold ()
{
    return mOptions[WizardOptions::Told].value ().f ();
}

inline void
WizardOptions::optionSetToldNotify (WizardOptions::ChangeNotify notify)
{
    mNotify[WizardOptions::Told] = notify;
}



#endif
