/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WOBBLY_OPTIONS_H
#define _WOBBLY_OPTIONS_H

#include <core/core.h>

class WobblyOptions : public CompOption::Class {
    public:
        enum Options {
            SnapKey,
            SnapInverted,
            Shiver,
            Friction,
            SpringK,
            GridResolution,
            MinGridSize,
            MapEffect,
            FocusEffect,
            MapWindowMatch,
            FocusWindowMatch,
            GrabWindowMatch,
            MoveWindowMatch,
            MaximizeEffect,
            OptionNum
        };

        enum MapEffect {
            MapEffectNone = 0,
            MapEffectShiver = 1,
        };

        enum FocusEffect {
            FocusEffectNone = 0,
            FocusEffectShiver = 1,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WobblyOptions (bool init = true);
        virtual ~WobblyOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetSnapKey ();
        void optionSetSnapKeyInitiate (CompAction::CallBack init);
        void optionSetSnapKeyTerminate (CompAction::CallBack term);
        void optionSetSnapKeyNotify (ChangeNotify notify);

        bool optionGetSnapInverted ();
        void optionSetSnapInvertedNotify (ChangeNotify notify);

        CompAction & optionGetShiver ();
        void optionSetShiverInitiate (CompAction::CallBack init);
        void optionSetShiverTerminate (CompAction::CallBack term);
        void optionSetShiverNotify (ChangeNotify notify);

        float optionGetFriction ();
        void optionSetFrictionNotify (ChangeNotify notify);

        float optionGetSpringK ();
        void optionSetSpringKNotify (ChangeNotify notify);

        int optionGetGridResolution ();
        void optionSetGridResolutionNotify (ChangeNotify notify);

        int optionGetMinGridSize ();
        void optionSetMinGridSizeNotify (ChangeNotify notify);

        int optionGetMapEffect ();
        void optionSetMapEffectNotify (ChangeNotify notify);

        int optionGetFocusEffect ();
        void optionSetFocusEffectNotify (ChangeNotify notify);

        CompMatch & optionGetMapWindowMatch ();
        void optionSetMapWindowMatchNotify (ChangeNotify notify);

        CompMatch & optionGetFocusWindowMatch ();
        void optionSetFocusWindowMatchNotify (ChangeNotify notify);

        CompMatch & optionGetGrabWindowMatch ();
        void optionSetGrabWindowMatchNotify (ChangeNotify notify);

        CompMatch & optionGetMoveWindowMatch ();
        void optionSetMoveWindowMatchNotify (ChangeNotify notify);

        bool optionGetMaximizeEffect ();
        void optionSetMaximizeEffectNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
WobblyOptions::optionGetSnapKey ()
{
    return mOptions[WobblyOptions::SnapKey].value ().action ();
}

inline void
WobblyOptions::optionSetSnapKeyInitiate (CompAction::CallBack init)
{
    mOptions[WobblyOptions::SnapKey].value ().action ().setInitiate (init);
}

inline void
WobblyOptions::optionSetSnapKeyTerminate (CompAction::CallBack term)
{
    mOptions[WobblyOptions::SnapKey].value ().action ().setTerminate (term);
}

inline void
WobblyOptions::optionSetSnapKeyNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::SnapKey] = notify;
}

inline bool
WobblyOptions::optionGetSnapInverted ()
{
    return mOptions[WobblyOptions::SnapInverted].value ().b ();
}

inline void
WobblyOptions::optionSetSnapInvertedNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::SnapInverted] = notify;
}

inline CompAction &
WobblyOptions::optionGetShiver ()
{
    return mOptions[WobblyOptions::Shiver].value ().action ();
}

inline void
WobblyOptions::optionSetShiverInitiate (CompAction::CallBack init)
{
    mOptions[WobblyOptions::Shiver].value ().action ().setInitiate (init);
}

inline void
WobblyOptions::optionSetShiverTerminate (CompAction::CallBack term)
{
    mOptions[WobblyOptions::Shiver].value ().action ().setTerminate (term);
}

inline void
WobblyOptions::optionSetShiverNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::Shiver] = notify;
}

inline float
WobblyOptions::optionGetFriction ()
{
    return mOptions[WobblyOptions::Friction].value ().f ();
}

inline void
WobblyOptions::optionSetFrictionNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::Friction] = notify;
}

inline float
WobblyOptions::optionGetSpringK ()
{
    return mOptions[WobblyOptions::SpringK].value ().f ();
}

inline void
WobblyOptions::optionSetSpringKNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::SpringK] = notify;
}

inline int
WobblyOptions::optionGetGridResolution ()
{
    return mOptions[WobblyOptions::GridResolution].value ().i ();
}

inline void
WobblyOptions::optionSetGridResolutionNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::GridResolution] = notify;
}

inline int
WobblyOptions::optionGetMinGridSize ()
{
    return mOptions[WobblyOptions::MinGridSize].value ().i ();
}

inline void
WobblyOptions::optionSetMinGridSizeNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::MinGridSize] = notify;
}

inline int
WobblyOptions::optionGetMapEffect ()
{
    return mOptions[WobblyOptions::MapEffect].value ().i ();
}

inline void
WobblyOptions::optionSetMapEffectNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::MapEffect] = notify;
}

inline int
WobblyOptions::optionGetFocusEffect ()
{
    return mOptions[WobblyOptions::FocusEffect].value ().i ();
}

inline void
WobblyOptions::optionSetFocusEffectNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::FocusEffect] = notify;
}

inline CompMatch &
WobblyOptions::optionGetMapWindowMatch ()
{
    return mOptions[WobblyOptions::MapWindowMatch].value ().match ();
}

inline void
WobblyOptions::optionSetMapWindowMatchNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::MapWindowMatch] = notify;
}

inline CompMatch &
WobblyOptions::optionGetFocusWindowMatch ()
{
    return mOptions[WobblyOptions::FocusWindowMatch].value ().match ();
}

inline void
WobblyOptions::optionSetFocusWindowMatchNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::FocusWindowMatch] = notify;
}

inline CompMatch &
WobblyOptions::optionGetGrabWindowMatch ()
{
    return mOptions[WobblyOptions::GrabWindowMatch].value ().match ();
}

inline void
WobblyOptions::optionSetGrabWindowMatchNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::GrabWindowMatch] = notify;
}

inline CompMatch &
WobblyOptions::optionGetMoveWindowMatch ()
{
    return mOptions[WobblyOptions::MoveWindowMatch].value ().match ();
}

inline void
WobblyOptions::optionSetMoveWindowMatchNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::MoveWindowMatch] = notify;
}

inline bool
WobblyOptions::optionGetMaximizeEffect ()
{
    return mOptions[WobblyOptions::MaximizeEffect].value ().b ();
}

inline void
WobblyOptions::optionSetMaximizeEffectNotify (WobblyOptions::ChangeNotify notify)
{
    mNotify[WobblyOptions::MaximizeEffect] = notify;
}



#endif
