/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WORKSPACENAMES_OPTIONS_H
#define _WORKSPACENAMES_OPTIONS_H

#include <core/core.h>

class WorkspacenamesOptions : public CompOption::Class {
    public:
        enum Options {
            Viewports,
            Names,
            DisplayTime,
            FadeTime,
            BoldText,
            TextFontSize,
            TextPlacement,
            VerticalOffset,
            BackColor,
            FontColor,
            OptionNum
        };

        enum TextPlacement {
            TextPlacementCenteredOnScreen = 0,
            TextPlacementTopOfScreenMinusOffset = 1,
            TextPlacementBottomOfScreenPlusOffset = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        WorkspacenamesOptions (bool init = true);
        virtual ~WorkspacenamesOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompOption::Value::Vector & optionGetViewports ();
        void optionSetViewportsNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetNames ();
        void optionSetNamesNotify (ChangeNotify notify);

        float optionGetDisplayTime ();
        void optionSetDisplayTimeNotify (ChangeNotify notify);

        float optionGetFadeTime ();
        void optionSetFadeTimeNotify (ChangeNotify notify);

        bool optionGetBoldText ();
        void optionSetBoldTextNotify (ChangeNotify notify);

        int optionGetTextFontSize ();
        void optionSetTextFontSizeNotify (ChangeNotify notify);

        int optionGetTextPlacement ();
        void optionSetTextPlacementNotify (ChangeNotify notify);

        int optionGetVerticalOffset ();
        void optionSetVerticalOffsetNotify (ChangeNotify notify);

        unsigned short * optionGetBackColor ();
        unsigned short optionGetBackColorRed ();
        unsigned short optionGetBackColorGreen ();
        unsigned short optionGetBackColorBlue ();
        unsigned short optionGetBackColorAlpha ();
        void optionSetBackColorNotify (ChangeNotify notify);

        unsigned short * optionGetFontColor ();
        unsigned short optionGetFontColorRed ();
        unsigned short optionGetFontColorGreen ();
        unsigned short optionGetFontColorBlue ();
        unsigned short optionGetFontColorAlpha ();
        void optionSetFontColorNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompOption::Value::Vector &
WorkspacenamesOptions::optionGetViewports ()
{
    return mOptions[WorkspacenamesOptions::Viewports].value ().list ();
}

inline void
WorkspacenamesOptions::optionSetViewportsNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::Viewports] = notify;
}

inline CompOption::Value::Vector &
WorkspacenamesOptions::optionGetNames ()
{
    return mOptions[WorkspacenamesOptions::Names].value ().list ();
}

inline void
WorkspacenamesOptions::optionSetNamesNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::Names] = notify;
}

inline float
WorkspacenamesOptions::optionGetDisplayTime ()
{
    return mOptions[WorkspacenamesOptions::DisplayTime].value ().f ();
}

inline void
WorkspacenamesOptions::optionSetDisplayTimeNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::DisplayTime] = notify;
}

inline float
WorkspacenamesOptions::optionGetFadeTime ()
{
    return mOptions[WorkspacenamesOptions::FadeTime].value ().f ();
}

inline void
WorkspacenamesOptions::optionSetFadeTimeNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::FadeTime] = notify;
}

inline bool
WorkspacenamesOptions::optionGetBoldText ()
{
    return mOptions[WorkspacenamesOptions::BoldText].value ().b ();
}

inline void
WorkspacenamesOptions::optionSetBoldTextNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::BoldText] = notify;
}

inline int
WorkspacenamesOptions::optionGetTextFontSize ()
{
    return mOptions[WorkspacenamesOptions::TextFontSize].value ().i ();
}

inline void
WorkspacenamesOptions::optionSetTextFontSizeNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::TextFontSize] = notify;
}

inline int
WorkspacenamesOptions::optionGetTextPlacement ()
{
    return mOptions[WorkspacenamesOptions::TextPlacement].value ().i ();
}

inline void
WorkspacenamesOptions::optionSetTextPlacementNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::TextPlacement] = notify;
}

inline int
WorkspacenamesOptions::optionGetVerticalOffset ()
{
    return mOptions[WorkspacenamesOptions::VerticalOffset].value ().i ();
}

inline void
WorkspacenamesOptions::optionSetVerticalOffsetNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::VerticalOffset] = notify;
}

inline unsigned short *
WorkspacenamesOptions::optionGetBackColor ()
{
    return mOptions[WorkspacenamesOptions::BackColor].value ().c ();
}

inline unsigned short
WorkspacenamesOptions::optionGetBackColorRed ()
{
    return mOptions[WorkspacenamesOptions::BackColor].value ().c ()[0];
}

inline unsigned short
WorkspacenamesOptions::optionGetBackColorGreen ()
{
    return mOptions[WorkspacenamesOptions::BackColor].value ().c ()[1];
}


inline unsigned short
WorkspacenamesOptions::optionGetBackColorBlue ()
{
    return mOptions[WorkspacenamesOptions::BackColor].value ().c ()[2];
}


inline unsigned short
WorkspacenamesOptions::optionGetBackColorAlpha ()
{
    return mOptions[WorkspacenamesOptions::BackColor].value ().c ()[3];
}


inline void
WorkspacenamesOptions::optionSetBackColorNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::BackColor] = notify;
}

inline unsigned short *
WorkspacenamesOptions::optionGetFontColor ()
{
    return mOptions[WorkspacenamesOptions::FontColor].value ().c ();
}

inline unsigned short
WorkspacenamesOptions::optionGetFontColorRed ()
{
    return mOptions[WorkspacenamesOptions::FontColor].value ().c ()[0];
}

inline unsigned short
WorkspacenamesOptions::optionGetFontColorGreen ()
{
    return mOptions[WorkspacenamesOptions::FontColor].value ().c ()[1];
}


inline unsigned short
WorkspacenamesOptions::optionGetFontColorBlue ()
{
    return mOptions[WorkspacenamesOptions::FontColor].value ().c ()[2];
}


inline unsigned short
WorkspacenamesOptions::optionGetFontColorAlpha ()
{
    return mOptions[WorkspacenamesOptions::FontColor].value ().c ()[3];
}


inline void
WorkspacenamesOptions::optionSetFontColorNotify (WorkspacenamesOptions::ChangeNotify notify)
{
    mNotify[WorkspacenamesOptions::FontColor] = notify;
}



#endif
