/*
 * Copyright © 2010 Canonical Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies
 * and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of
 * Canonical Ltd. not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 * Canonical Ltd. makes no representations about the suitability of this
 * software for any purpose. It is provided "as is" without express or
 * implied warranty.
 *
 * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
 * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
 * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
 */

#ifndef _COMPIZ_PRIVATEIOSOURCE_H
#define _COMPIZ_PRIVATEIOSOURCE_H

#include <glibmm/main.h>

typedef boost::function<void (short int)> FdWatchCallBack;
typedef int CompWatchFdHandle;

namespace compiz
{
    namespace private_screen
    {
	class EventManager;
    }
}

class CompWatchFd :
    public Glib::IOSource
{
    public:

	virtual ~CompWatchFd ();

	static
	Glib::RefPtr<CompWatchFd> create (int, Glib::IOCondition, FdWatchCallBack);

    protected:

	explicit CompWatchFd (int, Glib::IOCondition, FdWatchCallBack);
	bool		 internalCallback (Glib::IOCondition);

    private:

	int		  mFd;
	FdWatchCallBack   mCallBack;
	CompWatchFdHandle mHandle;
	bool		  mForceFail;
	bool		  mExecuting;

    friend class ::compiz::private_screen::EventManager;
};

#endif
